function BrowserAssistant(url) {
	var sina_url = 'http://h2w.iask.cn/h2wdisplay.php?u=';
	var sina_url2 = 'http://h2w.iask.cn/hd.php?u=';
	var baidu_url = 'http://gate.baidu.com/tc?src=';
	var google_url = 'http://www.google.com.hk/gwt/x?u=';
	this.url = sina_url2+url;
};

BrowserAssistant.prototype.setup = function() {
    
    this.stageController = this.controller.stageController;

    var thisA = this;
    var attr = {
		//minFontSize:18,
		cacheAdapter: true,
		virtualpagewidth: this.controller.window.innerWidth,
		//virtualpageheight: 32 
	};

	this.controller.setupWidget('browser', attr, {});
    this.reloadModel = {
		label: $L('Reload'),
		icon: 'refresh',
		command: 'refresh'
	};
    this.stopModel = {
		label: $L('Stop'),
		icon: 'load-progress',
		command: 'stop'
	};
    this.cmdMenuModel = {
		visible: true,
		items: [{ icon: 'back', command: 'do-back',disabled: true},{},{}, this.reloadModel]
	};

    this.controller.setupWidget(Mojo.Menu.commandMenu, {menuClass:'no-fade'}, this.cmdMenuModel);
	Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.urlChanged.bind(this));
	Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadProgress, this.loadProgress.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadStarted, this.loadStarted.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadStopped, this.loadStopped.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadFailed, this.loadStopped.bind(this));
    //Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.titleChanged.bind(this));

    setTimeout(function(){
		thisA.openUrl(thisA.url);
		//thisA.history.push(thisA.url);
	}, 100);
    
    
};


BrowserAssistant.prototype.openUrl = function(url){
	this.controller.get('browser').mojo.openURL(url);
};

BrowserAssistant.prototype.handleCommand = function(event) {
    if (event.type == Mojo.Event.command) {
		switch (event.command) {
		    case 'refresh':
				//this.controller.get('tips').hide();
				this.controller.get('browser').show();
				this.controller.get('browser').mojo.reloadPage();
				break;
		    case 'stop':
				this.controller.get('browser').mojo.stopLoad();
				break;
			case "do-back":
				this.goBack();
				break;
			case "do-forward":
				this.goForward();
				break;
		}

    }else if (event.type == Mojo.Event.forward) {
		event.stop();
		this.goForward();

	}else if (event.type == Mojo.Event.back) {
		event.stop();
		this.goBack();
	}
};


BrowserAssistant.prototype.urlChanged = function(event) {
	//Mojo.Log.info('#####################urlChanged#');
	this.url = event.url;
	this._goback = event.canGoBack;
	this._goforward = event.canGoForward;

	if(this._goback){
		this.cmdMenuModel.items[0].disabled = false;
	}else{
		this.cmdMenuModel.items[0].disabled = true;
	}

	if(this._goforward){
		this.cmdMenuModel.items[1] = {icon: 'forward', command: 'do-forward'};
	}else{
		this.cmdMenuModel.items[1] = {};
	}

	this.controller.modelChanged(this.cmdMenuModel);

};

BrowserAssistant.prototype.goBack = function() {
	//Mojo.Log.info('#####################goBack#');
	if(this._goback){
		this.controller.get('browser').mojo.goBack();
	}
};

BrowserAssistant.prototype.goForward = function() {
	//Mojo.Log.info('#####################goForward#');
	if(this._goforward){
		this.controller.get('browser').mojo.goForward();
	}
};

BrowserAssistant.prototype.loadStarted = function(event) {
 	this.cmdMenuModel.items.pop(this.reloadModel);
 	this.cmdMenuModel.items.push(this.stopModel);
 	this.controller.modelChanged(this.cmdMenuModel);
  	this.currLoadProgressImage = 0;
};

BrowserAssistant.prototype.loadStopped = function(event) {
 	this.cmdMenuModel.items.pop(this.stopModel);
 	this.cmdMenuModel.items.push(this.reloadModel);
 	this.controller.modelChanged(this.cmdMenuModel);
};

BrowserAssistant.prototype.loadProgress = function(event) {
  	var percent = event.progress;
 	try {
 		if (percent > 100) {
 			percent = 100;
 		}
 		else if (percent < 0) {
 			percent = 0;
 		}

 		this.currLoadProgressPercentage = percent;

 		var image = Math.round(percent / 4.1);
 		if (image > 23) {
 			image = 23;
 		}

 		if (image < this.currLoadProgressImage) {
 			return;
 		}

 		if (this.currLoadProgressImage != image) {

 			if (this.loadProgressAnimator) {
 				this.loadProgressAnimator.cancel();
 				delete this.loadProgressAnimator;
 			}

 			var icon = this.controller.select('div.load-progress')[0];
 			if (icon) {
 				this.loadProgressAnimator = Mojo.Animation.animateValue(Mojo.Animation.queueForElement(icon),
                                            "linear", this._updateLoadProgress.bind(this), {
 					from: this.currLoadProgressImage,
 					to: image,
 					duration: 0.5
 				});
 			}
 		}
 	}
 	catch (e) {
 		Mojo.Log.logException(e, e.description);
 	}
};

BrowserAssistant.prototype._updateLoadProgress = function(image) {

 	image = Math.round(image);
 	if (this.currLoadProgressImage == image) {
 		return;
 	}
 	var icon = this.controller.select('div.load-progress');
 	if (icon && icon[0]) {
 		icon[0].setStyle({'background-position': "0px -" + (image * 48) + "px"});
 	}
 	this.currLoadProgressImage = image;
};
 
BrowserAssistant.prototype.activate = function(event) {

};

BrowserAssistant.prototype.deactivate = function(event) {

};

BrowserAssistant.prototype.cleanup = function(event) {
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadProgress, this.loadProgress.bind(this));
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadStarted, this.loadStarted.bind(this));
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadStopped, this.loadStopped.bind(this));
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadFailed, this.loadStopped.bind(this));
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.urlChanged.bind(this));
};
