
function DockAssistant() {
	this.items = [];
};

DockAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	Weibo.Control.setTheme(this.controller);
	this.spinnerModel = {spinning: false};
    this.spinnerAtt = {spinnerSize: 'large'};
    this.controller.setupWidget("spinner", this.spinnerAtt, this.spinnerModel);
    this.controller.get("scrim").hide();
	this.loadItem();
	
	this.controller.listen('itemBox', Mojo.Event.tap,this.pageClick.bind(this));


};

DockAssistant.prototype.loadTip = function(flag){
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);
	if(flag === true){
		this.controller.get("scrim").show();
	}else{
		this.controller.get("scrim").hide();
	}

};

DockAssistant.prototype.pageClick = function(event){
	var eventSrc = event.target;
	var target = eventSrc.id;
	Mojo.Log.info("^^^^^^#dock_"+target);
	if(target == "tweet_user" || target == "dock_img" || target == "dock_name" || target == "dock_time"){
		this.nextItem();
	}

};

DockAssistant.prototype.loadItem = function(){
	//this.loadTip(true);
	var url = "http://api.t.sina.com.cn/statuses/friends_timeline.json?count=10";
	var _url = Weibo.Oauth.oauthUrl(url,"GET");
	var req = new Ajax.Request(_url, {
              method: "get",
			  requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: this.countItems.bind(this),
              onFailure: this.loadFailure.bind(this)
         });
};

DockAssistant.prototype.countItems = function(resp) {
	var thisA = this;
	if(resp.responseJSON){
		var _rData = resp.responseJSON;
	}else{
		var _rData = resp.responseText;
			_rData = _rData.replace(/^\s*/, '').replace(/\s*$/, ''); 
			_rData = _rData.evalJSON();
	}
						
	var _data = formatItems(_rData);

	var oldItems = _data.list;
			
	if(_data.ids){
		var url = "http://api.t.sina.com.cn/statuses/counts.json?ids="+_data.ids;
		var _url = Weibo.Oauth.oauthUrl(url,"GET");
	
		this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(r){
              			//thisA.loadTip(false);
              			thisA.items = countStatus(oldItems,r.responseJSON);
              			thisA.index = -1;
              			thisA.showItem();
    				
              		}.bind(this),
              		onFailure: this.loadFailure.bind(this)
        		});
        	
        }

};

DockAssistant.prototype.showItem = function() {
	if(this.items.length > 0){
		this.index = this.index < 0 ? (this.items.length - 1) : this.index;
		this.controller.get('itemBox').innerHTML = Mojo.View.render({object:this.items[this.index],template:'dock/itemTemplate'});
		
		this.index = this.index - 1;
		var thisA = this;
		var _time = Weibo.Prefs.dockTime || 6;
		if(this.index < 0){
			this.items = [];
			this.controller.window.setTimeout(function(){thisA.loadItem()}, _time*1000);
		}else{
			this.controller.window.setTimeout(function(){thisA.showItem()}, _time*1000);
		}
	}
};

DockAssistant.prototype.nextItem = function() {
	if(this.items.length > 0){
		this.index = this.index < 0 ? (this.items.length - 1) : this.index;
		this.controller.get('itemBox').innerHTML = Mojo.View.render({object:this.items[this.index],template:'dock/itemTemplate'});
		
		this.index = this.index - 1;
		var thisA = this;
		var _time = Weibo.Prefs.dockTime || 6;
		if(this.index < 0){
			this.items = [];
			this.loadItem();
		}else{
			this.showItem();
		}
	}
};

DockAssistant.prototype.loadFailure = function(event) {

};

DockAssistant.prototype.activate = function(event) {

};

DockAssistant.prototype.deactivate = function(event) {

};

DockAssistant.prototype.cleanup = function(event) {

}