
function ListDefaultAssistant(title,loadType) {
	this.title = title || "home";
	this.titleSub = this.title;//用于个人分组
	this.searchBox_is_open = false;
	this.newLoad = loadType || false;
	this._orientation = "up";
	//Weibo.list['mytopic'] = [];
	this.listTitle = [];
	this.homeShowTitle = '@'+Weibo.Prefs.screen_name+' ▼';
	
	this.paneIndex = {'home':0,'mention':1,'comment':2,'dm':3};
	this.filterIcon = {'0':'all','1':'original','2':'pics','3':'videos','4':'musics'};
	Weibo.homeFeature = 0;

	this.search_type = 'status';
	//var _w = this.controller.window.innerHeight > 480 ? 201 : 150;

};

ListDefaultAssistant.prototype.getNavItems = function(title) {

	if(title == 'home'){
		var r = [
					{ iconPath: 'images/menu_search.png', command: "do-search"},
					{ label:'@'+Weibo.Prefs.screen_name+' ▼', command: "do-group",width:150},
					{ iconPath: 'images/filter/all.png',command: 'do-feature'},
                    { iconPath: 'images/menu_top/'+this.title+'.png',command: 'do-select'}
            	];
    }else{

		var r = [
					{ iconPath: 'images/menu_search.png', command: "do-search"},
					{ label:'@'+Weibo.Prefs.screen_name+' ▼', command: "do-group",width:200},
                    { iconPath: 'images/menu_top/'+this.title+'.png',command: 'do-select'}
            	];
    }
    return r;

};

ListDefaultAssistant.prototype.setupMenu = function() {
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);

	var _navs = this.getNavItems(this.title);
	
	this.NavMenuModel = {
        visible: true,
        items: [
        	{},
			{items: _navs},
        	{}
        ]
    };

    this.controller.setupWidget(Mojo.Menu.viewMenu, 
	{
    	spacerHeight: 50,
    	menuClass: 'no-fade'
    }, 
    this.NavMenuModel); 
        
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
		this.subMenuAttr = {
        	spacerHeight: 0,
        	menuClass: 'no-fade'
        },
		this.subMenuModel = {
        	visible: true,
        	items: [{ iconPath: 'images/menu_camera.png', command: 'update'},{},{ icon:'refresh', command: 'refresh'}]
    	}
    );

};

ListDefaultAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	Weibo.Control.setTheme(this.controller);
	Weibo.Control.setFontSize(this.stageController);
	Weibo.Control.setAvatar(this.stageController);

	this.setupMenu();
	
	this.statusAttr = {
        itemTemplate: "tpl/"+this.title,
        listTemplate: "tpl/listTemplate",
        //swipeToDelete: false,
        renderLimit: 25
    };
        
	this.controller.setupWidget("homeListWgt", 
        this.homeAttr = {
            itemTemplate: "tpl/home",
            listTemplate: "tpl/listTemplate",
            onItemRendered: this.listItemRendered.bind(this),
            renderLimit: 26
        },  
        this.homeModel = {items: []}
    );

    this.controller.setupWidget("mentionListWgt", 
        this.mentionAttr = {
            itemTemplate: "tpl/mention",
            listTemplate: "tpl/listTemplate",
            renderLimit: 26
        },    
        this.mentionModel = {items: []}
    );

    this.controller.setupWidget("commentListWgt", 
        this.commentAttr = {
            itemTemplate: "tpl/"+this.title,
            listTemplate: "tpl/listTemplate",
            renderLimit: 26
        },
        this.commentModel = {items: []}
    );

    this.controller.setupWidget("dmListWgt", 
        this.dmAttr = {
            itemTemplate: "tpl/"+this.title,
            listTemplate: "tpl/listTemplate",
            renderLimit: 26
        },   
        this.dmModel = {items: []}
    );

    this.controller.setupWidget("userListWgt", 
        this.userAttr = {
            itemTemplate: "tpl/my",
            listTemplate: "tpl/listTemplate",
            //swipeToDelete: false,
            renderLimit: 26
        }, 
        this.userModel = { items: []}
    );

    this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/public",
            listTemplate: "tpl/listTemplate",
            //swipeToDelete: false,
            renderLimit: 26
        }, 
        this.statusModel = { items: []}
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	
	this.panelsScrollerModel= {mode: "horizontal-snap"};
	this.controller.setupWidget('panels_scroller', {}, this.panelsScrollerModel);
	
	var elements = this.controller.select('.snap');
	this.panelsScrollerModel.snapElements = {x: elements, y: []};
	this.panelsScrollerModel.snapIndex = 0;
	
	this.controller.listen('panels_scroller', Mojo.Event.propertyChanged, this.getPoints.bind(this));
	
	this.vertScrollerModel= {scrollbars: true, mode: "vertical"};
	this.controller.setupWidget('homeListWgtBox', {}, this.vertScrollerModel);
	this.controller.setupWidget('mentionListWgtBox', {}, this.vertScrollerModel);
	this.controller.setupWidget('commentListWgtBox', {}, this.vertScrollerModel);
	this.controller.setupWidget('dmListWgtBox', {}, this.vertScrollerModel);
	this.controller.setupWidget('userListWgtBox', {}, this.vertScrollerModel);
	this.controller.setupWidget('feedListWgtBox', {}, this.vertScrollerModel);

    this.showFeedWgt(this.title);
    this.load();
    this.loadMyGroup();
    
    this.controller.listen('loadMoreBtnhome', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('loadMoreBtnmention', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('loadMoreBtncomment', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('loadMoreBtndm', Mojo.Event.tap,this.loadMore.bind(this));
    
    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));

	this.controller.listen('topMenu', Mojo.Event.tap,this.selectMenu.bind(this));
	this.controller.listen('countTip', Mojo.Event.tap,this.selectMenu.bind(this));

	this.controller.listen('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.listen('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
	
	this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
	
    this.controller.listen("homeListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.homeModel));
    this.controller.listen("mentionListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.mentionModel));
    this.controller.listen("commentListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.commentModel));
    this.controller.listen("dmListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.dmModel));
    this.controller.listen("userListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.statusModel));
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.statusModel));
    
    this.controller.setupWidget(
         "keyword",
        {
              hintText: $L("keyword"),
              autoFocus: true,
              limitResize: true,
              autoReplace: false,
              textCase: Mojo.Widget.steModeLowerCase,
              //enterSubmits: true,
              changeOnKeyPress:true,
              requiresEnterKey:true
        },
        this.keywordModel = {value : '',disabled: true});

    this.handleKeyDown = this.handleKeyDown.bindAsEventListener(this);
	Mojo.Event.listen(this.controller.document, "keyup", this.handleKeyDown, true);

	this.controller.listen('searchType', Mojo.Event.tap,this.selectSearchType.bind(this));
	
	this.controller.setupWidget("topicListWgt", 
        this.topicAttr = {
            itemTemplate: "tpl/mytopic",
            listTemplate: "tpl/listTemplate",
            //renderLimit: 100,
        },    
        this.topicModel = {
            items: []
        }
    );
    
    this.controller.listen("topicListWgt", Mojo.Event.listTap,this.viewTopic.bindAsEventListener(this));
            
    this.controller.setupWidget(
	 	'dropDownMenuWrapper', 
	 	{}, 
	 	this.vertScrollerModel = {scrollbars: true, mode: "vertical"}
	 );

    //this.selectSource = this.selectSource.bindAsEventListener(this); 	
	//Mojo.Event.listen(this.controller.get('downArrow'), Mojo.Event.tap, this.selectSource );
	
	this.loadMyTopic();	
	
	this.showCountTipHandler = this.showCountTip.bind(this);
	this.showCountTip();
	
	Mojo.Event.listen(this.controller.get('scrim'), Mojo.Event.tap, this.closeSearchBox.bind(this) );
	this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
	
	
	this.controller.listen("searchBtn", Mojo.Event.tap, this.searchSubmit.bind(this));
	this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
	this.controller.listen("box", Mojo.Event.dragging, this.handleDragging.bind(this));
	//this.controller.listen("box", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	
	this.controller.listen("homeListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.listen("mentionListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.listen("commentListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.listen("dmListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	
	this.controller.listen("homeListWgtBox", Mojo.Event.dragging, this.handleDragging.bind(this));
	this.controller.listen("mentionListWgtBox", Mojo.Event.dragging, this.handleDragging.bind(this));
	this.controller.listen("commentListWgtBox", Mojo.Event.dragging, this.handleDragging.bind(this));
	this.controller.listen("dmListWgtBox", Mojo.Event.dragging, this.handleDragging.bind(this));
	
	this.controller.listen("homeListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("homeListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("homeListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.listen("mentionListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("mentionListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("mentionListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.listen("commentListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("commentListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("commentListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.listen("dmListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("dmListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("dmListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.listen("userListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("userListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("userListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.listen("feedListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.listen("feedListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.listen("feedListWgtBox","gestureend",this.gestureEnd.bind(this));
	
};

ListDefaultAssistant.prototype.selectSearchType = function(event){
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
		onChoose:  this.gotSearchType,
		toggleCmd: this.search_type,
    	placeNear: findPlace,
    	items: [
    		{label:"微博",command:"status"},
    		{label:"用户",command:"user"}
    	]
	});
};

ListDefaultAssistant.prototype.gotSearchType = function(command){
	if(command){
		this.controller.get('searchType').innerHTML = '<img src="images/search_'+command+'.png" />';
		this.search_type = command;
	}
};

ListDefaultAssistant.prototype.listItemRendered = function(a,b) {
	b.open = false;
};

ListDefaultAssistant.prototype.gestureStart = function(event) {
	this.gestureY = event.centerY;
};

ListDefaultAssistant.prototype.gestureEnd = function(event) {
	var _twHeight = this.controller.window.innerHeight;
	if((this.gestureY - event.centerY)>10){
		this.scrollToBottom();

	}else{
		this.scrollToTop();
	}
};

ListDefaultAssistant.prototype.gestureChange = function(event) {
	if(this._orientation === "up"){
		if(event.scale > 2){
			this.setFullScreen(true);
			Weibo.Prefs.fullScreen = true;
		}else if(event.scale < 0.6){
			this.setFullScreen(false);
			Weibo.Prefs.fullScreen = false;
		}
	}
};

ListDefaultAssistant.prototype.getPoints = function(e) {

    i = this.panelsScrollerModel.snapIndex;
    switch(i){
       case 0:
       category = "home";
       break;
       case 1:
       category = "mention";
       break;
       case 2:
       category = "comment";
       break;
       case 3:
       category = "dm";
       break;
       case 4:
       category = "my";
       break;
       case 5:
       category = "public";
       break;

    }
    clearTimeout(this.refreshTimeOut);
    this.goPanel(category);
};

ListDefaultAssistant.prototype.handleDragstart = function(evt){
	this.downY = evt.down.y;
};

ListDefaultAssistant.prototype.handleDragging = function(evt){
	
	//this.scroller = this.controller.getSceneScroller();
	var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller = this.controller.get(listWgt+'Box');
	
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	
	//if(Weibo.Prefs.fullScreen == true){
	
	if((this.title != "public" || this.title != "my")){
		if(this.pageY > 70 && this.pageY<250){
			this.showLoadNewBox(false);
			this.controller.get(listWgt+'Tip').show();
			this.controller.get(listWgt+'Img').show();
			this.controller.get(listWgt+'Img').addClassName('toptipImgUp');
			this.controller.get(listWgt+'Text').innerHTML = "松开即更新列表";
			
		}else if(this.pageY > 10 && this.pageY<70){
			this.showLoadNewBox(false);
			this.controller.get(listWgt+'Tip').show();
			this.controller.get(listWgt+'Img').show();
			this.controller.get(listWgt+'Img').removeClassName('toptipImgUp');
			this.controller.get(listWgt+'Text').innerHTML = "向下拉更新列表";
			
		}else{
			//this.controller.get(listWgt+'Tip').hide();
			this.controller.get(listWgt+'Img').hide();
			this.controller.get(listWgt+'Img').removeClassName('toptipImgUp');
			this.controller.get(listWgt+'Text').innerHTML = "";
		}
	}

};

ListDefaultAssistant.prototype.handleDragend = function(evt){
	
	//this.scroller = this.controller.getSceneScroller();
	var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller = this.controller.get(listWgt+'Box');
	
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	//this.controller.get("title").innerHTML += "o|"+this.pageY;

	this.pageY_abs = Math.abs(this.pageY);
	this.pageH = this.controller.get(listWgt).offsetHeight;

	var _h = this.controller.window.innerHeight;
		
	if(this.title != "public" || this.title != "my"){
		if(this.pageY > 70 && this.pageY<250){
			this._handleDragend = true;
			this.controller.get(listWgt+'Tip').show();
			this.controller.get(listWgt+'Img').hide();
			this.controller.get(listWgt+'Text').innerHTML = "最新数据加载中";
			this.showLoadNewBox(false);
			this.loadNew();

		}else if((this.pageY_abs+_h-10) > this.pageH && this.pageH > (_h-10)){
			if(Weibo.loading === false){
				this.loadMore();
			}

		}else{
			//this.controller.get(listWgt+'Tip').hide();
			this.controller.get(listWgt+'Img').hide();
			this.controller.get(listWgt+'Text').innerHTML = "";
		}
	}
};

ListDefaultAssistant.prototype.showCountTip = function(event){
	if(Weibo.Prefs.autoUpdate === true){
		Weibo.newStatusNum["comment"] = Weibo.newStatusNum["comment"] || 0;
		Weibo.newStatusNum["mention"] = Weibo.newStatusNum["mention"] || 0;
		Weibo.newStatusNum["dm"] = Weibo.newStatusNum["dm"] || 0;
		Weibo.newStatusNum["followers"] = Weibo.newStatusNum["followers"] || 0;
		var _count = Weibo.newStatusNum["comment"] + Weibo.newStatusNum["mention"] + Weibo.newStatusNum["dm"] + Weibo.newStatusNum["followers"];
		
		if(_count > 0){
			this.controller.get('countTip').innerHTML = _count;
			this.controller.get('countTip').show();
		}else{
			if(Weibo.newStatusNum["status"] > 0){
				this.controller.get('countTip').innerHTML = 'new';
				this.controller.get('countTip').show();
			}else{
				this.controller.get('countTip').hide();
			}
			
		}
	}
	//this.controller.window.setTimeout(this.showCountTipHandler, 2000);
	var thisA = this;
	//setTimeout(function(){thisA.showCountTip()}, 1*3000);
	this.controller.window.setTimeout(function(){thisA.showCountTip()}, 1*3000);
};

ListDefaultAssistant.prototype.pageClick = function(event,model){
	Weibo.Opt.pageClick(event,this.title,model,this.controller);
};

ListDefaultAssistant.prototype.handleKeyDown = function(e){
	if (Mojo.Char.isEnterKey(e.keyCode)){
	 	this.searchSubmit();
	 } 
};

ListDefaultAssistant.prototype.searchSubmit = function(e){
    	
	var keyword = this.keywordModel.value; 
	this.keywordModel.value = keyword;
    this.controller.modelChanged(this.keywordModel);
    
	 if(keyword){
	 	this.stageController.pushScene('search',keyword,{'type':this.search_type});
	 }
	 
};

ListDefaultAssistant.prototype.loadMyGroup = function() {

    var thisA = this;
    
    this.groupName = [];
	
	var url = "http://api.t.sina.com.cn/"+Weibo.Prefs.uid+"/lists.xml";
	var parameters = [['listType', '1']];
	var _url = Weibo.signRequest(url, parameters, "GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
              requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
				if (resp.status == 200) {
					var cats = resp.responseXML.getElementsByTagName("list");

					var oldcats = [{label:"全部",command:1}];
					var newcats = [];
					for (var i=0; i<cats.length; i++){
						var _name = cats[i].getElementsByTagName("name").item(0).textContent;
						var _id = cats[i].getElementsByTagName("id").item(0).textContent;
						newcats[i] = {label: _name,command: _id};
						thisA.groupName[_id] = _name;
					}
					oldcats.push.apply(oldcats, newcats);
					Weibo.list['mygroup'] = oldcats;
					thisA.myGroup = oldcats;

    			}
              }.bind(this)
       });

};

ListDefaultAssistant.prototype.selectSubMenu = function(event) {
	this.closeSearchBox();
	var findPlace = event.target || event.originalEvent.target;
	
	if(this.title === 'home'){
		if(this.myGroup){
			var _toggleCmd = this.title == this.titleSub ? 1 : this.titleSub;
			this.controller.popupSubmenu({
    			onChoose:  this.gotGroup,
    			toggleCmd: _toggleCmd,
        		placeNear: findPlace,
        		items: this.myGroup
    		});
    	}else{
    		this.loadMyGroup();
    	}
    	
    }else if(this.title === 'comment' || this.title === 'comment_by_me'){
		this.controller.popupSubmenu({
    		onChoose:  this.gotSubMenu,
    		toggleCmd: this.title,
        	placeNear: findPlace,
        	items: [
        		{label:"收到的评论",command:"comment"},
        		{label:"发出的评论",command:"comment_by_me"}
        	]
    	});   
    
    }else if(this.title === 'dm' || this.title === 'dm_sent'|| this.title === 'dm_user'){
		this.controller.popupSubmenu({
    		onChoose:  this.gotSubMenu,
    		toggleCmd: this.title,
        	placeNear: findPlace,
        	items: [
        		{label:"收到的私信",command:"dm"},
        		{label:"发出的私信",command:"dm_sent"},
        		{label:"私信用户列表",command:"dm_user"}
        	]
    	});   
    
    }
};

ListDefaultAssistant.prototype.gotGroup = function(command) {
    if(command) {	
    	Weibo.homeFeature = 0;
    	if(command == 1){
    		this.titleSub = this.title;
    		this.listTitle['home'] = 'home';
    		
    		this.homeShowTitle = '@'+Weibo.Prefs.screen_name+' ▼';
    		
    		this.load();
    	}else{
    		this.scrollToTop();
    		this.titleSub = command;
    		this.listTitle['home'] = command;
    		Weibo.list["home_"+command] = Weibo.list["home_"+command] || [];

    		this.homeShowTitle = this.groupName[command]+' ▼';

    		var thisA = this;
    		this.controller.window.setTimeout(
    			function(){
    				thisA.showFeedWgt('home');
    				thisA.homeModel.items = Weibo.list["home_"+command];
					thisA.controller.modelChanged(thisA.homeModel);
    				thisA.loadNew();
    			}, 1*500);
    		
    		
    	}

    	this.NavMenuModel.items[1].items[2].iconPath = "images/filter/all.png";
    	
    	this.NavMenuModel.items[1].items[1].label = this.homeShowTitle;
    	this.controller.modelChanged(this.NavMenuModel);
    }

};

ListDefaultAssistant.prototype.gotGroupUrl = function(id,type,count) {
	
	var _count = count || Weibo.Prefs.count;
	var _title = "home_"+id;
	
	Weibo.since_id[_title] = Weibo.since_id[_title] ? Weibo.since_id[_title] : 0;
	Weibo.max_id[_title] = Weibo.max_id[_title] ? Weibo.max_id[_title] : 0;
	
	var url = "http://api.t.sina.com.cn/"+Weibo.Prefs.uid+"/lists/"+id+"/statuses.json";
	if(type == 'new'){
		var parameters = [['per_page', _count],['since_id', Weibo.since_id[_title]]];
	}else{
		var parameters = [['per_page', _count],['max_id', Weibo.max_id[_title]]];
	}
	var _url = Weibo.signRequest(url, parameters, "GET");
	return _url;
};

ListDefaultAssistant.prototype.gotSubMenu = function(command) {
	if(command) {
    	this.title = this.titleSub = command;
    	var _title = this.getShowTitle(command);
    	this.listTitle[_title] = command;
    	
    	var t = this;
    	
    	var attr = this.getFeedWgtModel(command,'attr');
    	attr.itemTemplate = "tpl/"+command;
    	this.controller.modelChanged(attr);
    		
    	setTimeout(function(){t.load()}, 1*500);
    }
};

ListDefaultAssistant.prototype.loadMyTopic = function() {
	Mojo.Log.info("^^^^^^#loadMyTopic");
    var thisA = this;
    var url = "http://api.t.sina.com.cn/trends.json?user_id="+Weibo.Prefs.uid+"&count=25";
	var _url = Weibo.Oauth.oauthUrl(url,"GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
              requestHeaders:['Accept-Encoding','gzip,deflate'],
              //requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
				if (resp.status == 200) {
					Weibo.list['mytopic'] = resp.responseJSON;
					thisA.topicModel.items = resp.responseJSON;
    				thisA.controller.modelChanged(thisA.topicModel);
    			}
              }.bind(this),
              onFailure: function(resp){
				/*
				Mojo.Log.info("^^^^^^#topic_"+resp.status);
				if (resp.status == 401) {
    				Mojo.Controller.getAppController().showBanner({"messageText": 't'+resp.status}, {}, Weibo.MainStageName);
    				//thisA.loadMyTopic();
    			}
				*/
              	
              }.bind(this)
       });

    
};

ListDefaultAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBoxhome').show();
		this.controller.get('loadMoreBoxmention').show();
		this.controller.get('loadMoreBoxcomment').show();
		this.controller.get('loadMoreBoxdm').show();
		this.controller.get('loadMoreBoxmy').hide();
		this.controller.get('loadMoreBoxpublic').show();
	}else{
		this.controller.get('loadMoreBoxhome').hide();
		this.controller.get('loadMoreBoxmention').hide();
		this.controller.get('loadMoreBoxcomment').hide();
		this.controller.get('loadMoreBoxdm').hide();
		this.controller.get('loadMoreBoxmy').hide();
		this.controller.get('loadMoreBoxpublic').hide();
	}
};

ListDefaultAssistant.prototype.showLoadNewBox = function(flag){
	if(flag == true){
		this.controller.get('loadNewBox').show();
		this.controller.get('topTip').hide();
	}else{
		this.controller.get('loadNewBox').hide();
		this.controller.get('topTip').show();
	}
};

ListDefaultAssistant.prototype.loadTip = function(flag){
	var _title = this.getShowTitle(this.title);
	if(flag == true){
		Weibo.loading = true;
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox'+_title).addClassName('loadMoreBoxSelect');
		if(_title == 'my'){
			this.controller.get('loadMoreBox'+_title).hide();
		}else{
			this.controller.get('loadMoreBox'+_title).show();
		}
		this.controller.get('loadMoreBtn'+_title).hide();
		this.controller.get('loadMoreStart'+_title).show();
	}else{
		Weibo.loading = false;
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox'+_title).removeClassName('loadMoreBoxSelect');
		if(_title == 'my'){
			this.controller.get('loadMoreBox'+_title).hide();
		}else{
			this.controller.get('loadMoreBox'+_title).show();
		}
		this.controller.get('loadMoreBtn'+_title).show();
		this.controller.get('loadMoreStart'+_title).hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

ListDefaultAssistant.prototype.showData = function(data,sIndex) {
	this.loadTip(false);
	this.showLoadNewBox(false);
	
	var listWgt = Weibo.getFeedWgt(this.title);
	//this.controller.get(listWgt+'Tip').hide();
	this.controller.get(listWgt+'Text').innerHTML = "";
	this._handleDragend = false;
	
	if(this.title == 'my' || Weibo.list[this.title].length < 1){
		this.showLoadMoreBox(false);
	}
	
	var model = this.getFeedWgtModel(this.title);
	model.items = data;
	//this.controller.modelChanged(model);
	
	this.controller.get(listWgt).mojo.setLength(data.length);
	this.controller.get(listWgt).mojo.noticeUpdatedItems(0, model.items);
	
	//this.controller.get('feedListWgt').mojo.setLength(data.length);
	if(sIndex > -1){
		var thisA = this;
		this.controller.get(listWgt).mojo.revealItem(sIndex,true);
	}
	
};

ListDefaultAssistant.prototype.hideLoadTip = function() {
	this.loadTip(false);
	this.showLoadNewBox(false);
	
	var listWgt = Weibo.getFeedWgt(this.title);
	//this.controller.get(listWgt+'Tip').hide();
	this.controller.get(listWgt+'Text').innerHTML = "";
	this._handleDragend = false;
};

ListDefaultAssistant.prototype.showFailure = function(type) {
	var _type = type || "show";
	this.loadTip(false);
	if(_type === "hide" || this.title === "my" || Weibo.list[this.title].length < 1){
		this.showLoadMoreBox(false);
	}
	this.showLoadNewBox(false);
	
	var listWgt = Weibo.getFeedWgt(this.title);
	//this.controller.get(listWgt+'Tip').hide();
	this.controller.get(listWgt+'Text').innerHTML = "";
	this._handleDragend = false;
};

ListDefaultAssistant.prototype.cancelLoad = function() {
	Weibo.Api.cancelReq();
	this.loadTip(false);
	this.showLoadNewBox(false);
};

ListDefaultAssistant.prototype.viewTopic = function(event) {
	this.stageController.pushScene('search',this.topicModel.items[event.index].hotword);
};

ListDefaultAssistant.prototype.getFeedWgtModel = function(title,type) {
	Mojo.Log.info('##########getFeedWgtModel#');
	var _type = type ? type : 'model';
	var titleSub = title.substr(0,4);
	
	if(title == 'home' || titleSub == 'home'){
		return _type == 'model' ? this.homeModel : this.homeAttr;
		
	}else if(title == 'mention'){
		return _type == 'model' ? this.mentionModel : this.mentionAttr;
		
	}else if(title == 'comment' || title == 'comment_by_me'){
		return _type == 'model' ? this.commentModel : this.commentAttr;
		
	}else if(title == 'dm' || title == 'dm_user' || title == 'dm_sent'){
		return _type == 'model' ? this.dmModel : this.dmAttr;
		
	}else if(title == 'my'){
		return _type == 'model' ? this.userModel : this.userAttr;
		
	}else{
		return _type == 'model' ? this.statusModel : this.statusAttr;
	}
};

ListDefaultAssistant.prototype.getShowTitle = function(title) {

	var titleSub = title.substr(0,4);
	
	if(title == 'home' || titleSub == 'home'){
		return 'home';
		
	}else if(title == 'mention'){
		return 'mention';
		
		
	}else if(title == 'comment' || title == 'comment_by_me'){
		return 'comment';
		
		
	}else if(title == 'dm' || title == 'dm_user' || title == 'dm_sent'){
		return 'dm';
		
	}else if(title == 'my'){
		return 'my'
		
	}else{
		return 'public';
	}
};

ListDefaultAssistant.prototype.load = function() {
	Mojo.Log.info("^^^^^^ #listDefault_load");
	Weibo.Api.cancelReq();
	this.loadTip(true);
	this.showLoadMoreBox(false);
	
	Weibo.pageY[this.title] = Weibo.pageY[this.title] || 0;
	this.scroller = this.controller.getSceneScroller();

	var t = this;
	setTimeout(function(){
		t.controller.get("panels_scroller").mojo.setSnapIndex(t.paneIndex[t.title], 0);
	}, 50);

	this.scroller.mojo.scrollTo(0,0);
	Weibo.list["dm_user"] = [];
	
	setTimeout(function(){
		t.showFeedWgt(t.title);
		var model = t.getFeedWgtModel(t.title);
		if(t.newLoad === true){
			var url = Weibo.getUrl(t.title,'new');
			if(url){
				t.newLoad = false;
				Weibo.Api.loadItem(url,t.title,model,t.controller,'new',true);
			}
		}else{
			Weibo.Api.getCache(t.title,model,t.controller);
		}
	}, 50);

};

ListDefaultAssistant.prototype.loadNew = function(){

	this.cancelLoad();
	this.loadTip(true);
	this.showLoadMoreBox(false);
	
	var _dName = this.title === 'home' ? 'status' : this.title;
	Weibo.Dashboard[_dName] && Mojo.Controller.getAppController().closeStage(Weibo.Dashboard[_dName]);
	
	if(this.title == this.titleSub){
		var url = Weibo.getUrl(this.title,'new');
		if(this.title == 'home' && Weibo.homeFeature > 0){
			var _title = 'home_featrue_'+Weibo.homeFeature;
		}else{
			var _title = this.title;
		}
	}else{
		Weibo.homeFeature = 0;
		var url = this.gotGroupUrl(this.titleSub,'new');
		var _title = "home_"+this.titleSub;
	}

	this.showFeedWgt(_title);
	var model = this.getFeedWgtModel(_title);
	
	if(this.title === 'my'){
		Weibo.Api.loadUserInfo(Weibo.Prefs.screen_name,model,this.controller);
	}else{
		Weibo.list["dm_user"] = [];
		Weibo.Api.loadItem(url,_title,model,this.controller,'new',true);
	}
};

ListDefaultAssistant.prototype.loadMore = function(){
	this.loadTip(true);
	Weibo.loading = true;
	if(this.title == this.titleSub){
		var url = Weibo.getUrl(this.title,'old');
		if(this.title == 'home' && Weibo.homeFeature > 0){
			var _title = 'home_featrue_'+Weibo.homeFeature;
		}else{
			var _title = this.title;
		}
	}else{
		Weibo.homeFeature = 0;
		var url = this.gotGroupUrl(this.titleSub,'old');
		var _title = "home_"+this.titleSub;
	}
	
	this.showFeedWgt(this.title);
	var model = this.getFeedWgtModel(this.title);
	
    Weibo.Api.loadItem(url,_title,model,this.controller,'old');
};

ListDefaultAssistant.prototype.selectFeature = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
    	onChoose:  this.goFeature,
    	toggleCmd: Weibo.homeFeature,
        placeNear: findPlace,
        //manualPlacement: true,
        items: [
			{secondaryIconPath: 'images/filter/all.png',label:"全部",command:"0"},
			{secondaryIconPath: 'images/filter/original.png',label:"原创",command:"1"},
			{secondaryIconPath: 'images/filter/pics.png',label:"图片",command:"2"},
			{secondaryIconPath: 'images/filter/videos.png',label:"视频",command:"3"},
			{secondaryIconPath: 'images/filter/musics.png',label:"音乐",command:"4"}
		]
    });
};

ListDefaultAssistant.prototype.goFeature = function(command) {
	this.cancelLoad();
 	if(command) {
 		this.titleSub = this.title;
    	this.listTitle['home'] = 'home';
    		
    	this.homeShowTitle = '@'+Weibo.Prefs.screen_name+' ▼';
    	this.NavMenuModel.items[1].items[1].label = this.homeShowTitle;

 		if(command == 0){
    		Weibo.homeFeature = 0;
    		this.load();

    	}else{
	 		Weibo.list["home_featrue_"+command] = Weibo.list["home_featrue_"+command] || [];
	 		this.homeModel.items = Weibo.list["home_featrue_"+command];
			this.controller.modelChanged(this.homeModel);
			Weibo.homeFeature = command;
			this.loadNew();
		}

		this.NavMenuModel.items[1].items[2].iconPath = "images/filter/"+this.filterIcon[Weibo.homeFeature]+".png";
		this.controller.modelChanged(this.NavMenuModel);
 	}
};

ListDefaultAssistant.prototype.selectMenu = function(event) {

	this.closeSearchBox();

	var findPlace = event.target || event.originalEvent.target;
	
	var _c_num = Weibo.newStatusNum["comment"] > 0 ? ' ('+Weibo.newStatusNum["comment"]+')' : '';
	var _m_num = Weibo.newStatusNum["mention"] > 0 ? ' ('+Weibo.newStatusNum["mention"]+')' : '';
	var _d_num = Weibo.newStatusNum["dm"] > 0 ? ' ('+Weibo.newStatusNum["dm"]+')' : '';
	var _f_num = Weibo.newStatusNum["followers"] > 0 ? ' ('+Weibo.newStatusNum["followers"]+')' : '';
	
	var _h_icon = Weibo.newStatusNum["status"] > 0 ? '_new' : '';
	var _c_icon = Weibo.newStatusNum["comment"] > 0 ? '_new' : '';
	var _m_icon = Weibo.newStatusNum["mention"] > 0 ? '_new' : '';
	var _d_icon = Weibo.newStatusNum["dm"] > 0 ? '_new' : '';
	var _f_icon = Weibo.newStatusNum["followers"] > 0 ? '_new' : '';

	if(this.title === 'comment_by_me'){
		var _toggleCmd = 'comment';
	}else if(this.title === 'dm_sent' || this.title === 'dm_user' || this.title === 'dm'){
		var _toggleCmd = 'dm';
	}else{
		var _toggleCmd = this.title;
	}
	
	this.controller.popupSubmenu({
    	onChoose:  this.goPanel,
    	toggleCmd: _toggleCmd,
        placeNear: findPlace,
        //manualPlacement: true,
        items: [
			{secondaryIconPath: 'images/menu_top/home'+_h_icon+'.png',label:"首页",command:"home"},
			{secondaryIconPath: 'images/menu_top/mention'+_m_icon+'.png',label:"@我"+_m_num,command:"mention"},
			{secondaryIconPath: 'images/menu_top/comment'+_c_icon+'.png',label:"评论"+_c_num,command:"comment"},
			{secondaryIconPath: 'images/menu_top/dm'+_d_icon+'.png',label:"私信"+_d_num,command:"dm"},
			//{secondaryIconPath: 'images/menu_top/my.png',label:"资料",command:"my"},
			{secondaryIconPath: 'images/menu_top/my'+_f_icon+'.png',label:"资料"+_f_num,items:[
				{secondaryIconPath: 'images/menu_top/my_infos.png',label:"我的信息",command:"my"},
				{secondaryIconPath: 'images/menu_top/my_status.png',label:"我的微博",command:"status"},
				{secondaryIconPath: 'images/menu_top/my_followers'+_f_icon+'.png',label:"我的粉丝"+_f_num,command:"followers"},
				{secondaryIconPath: 'images/menu_top/my_friends.png',label:"我的关注",command:"friends"},
				{secondaryIconPath: 'images/menu_top/my_favs.png',label:"我的收藏",command:"favorites"},
			]},
			{secondaryIconPath: 'images/menu_top/public.png',label:"广场",command:"public"}
		]
    });
};

ListDefaultAssistant.prototype.goPanel = function(command) {    
 	this.cancelLoad();
 	if(command) {
    	this.newLoad = false;
			
		if(command === 'status'){
    		Weibo.Opt.userTimeline(Weibo.Prefs.screen_name);
    	}else if(command === 'followers'){
    		Weibo.Opt.userFollowers(Weibo.Prefs.screen_name);
    	}else if(command === 'friends'){
    		Weibo.Opt.userFriends(Weibo.Prefs.screen_name);
    	}else if(command === 'favorites'){
    		Weibo.Opt.favTimeline(Weibo.Prefs.screen_name);
    	}else{
		    
			this.showLoadMoreBox(false);
			this.showFeedWgt(command);
			var model = this.getFeedWgtModel(command);
			
			this.NavMenuModel.items[1].items = this.getNavItems(command);
			var ni_length = this.NavMenuModel.items[1].items.length;
			var _i = ni_length == 3 ? 2 : 3;

			if(ni_length == 4){
				this.NavMenuModel.items[1].items[2].iconPath = "images/filter/"+this.filterIcon[Weibo.homeFeature]+".png";
			}

			if(command === 'comment' || command === 'dm' || command === 'home' || command === 'dm_user'){
				if(command === 'home'){
					this.NavMenuModel.items[1].items[1].label = this.homeShowTitle;
				}else{
					this.NavMenuModel.items[1].items[1].label = '@'+Weibo.Prefs.screen_name+' ▼';
				}
			}else{
				this.NavMenuModel.items[1].items[1].label = '@'+Weibo.Prefs.screen_name;
			}
		
			var _icon = command === 'dm_user' ? 'dm' : command;
			
    		this.NavMenuModel.items[1].items[_i].iconPath = "images/menu_top/"+_icon+".png";
    		this.controller.modelChanged(this.NavMenuModel);
    		
    		if(command == 'home'){
    			this.title = command;
    			this.titleSub = this.listTitle['home'] || 'home';
    		}else{
    			if(Weibo.newStatusNum[command] && Weibo.newStatusNum[command] > 0){
    				this.title = this.titleSub = command;
    			}else{
    				this.title = this.titleSub = this.listTitle[command] || command;
    			}
    		}

    		var _tpl = this.title == "dm_user" ? "dm_user" : command;
    		var attr = this.getFeedWgtModel(command,'attr');
    		attr.itemTemplate = "tpl/"+_tpl;
    		this.controller.modelChanged(attr);
    	
			if(command === 'public'){
		    
		    	this.controller.get("panels_scroller").mojo.setSnapIndex(5, 0);
		    	
				this.showLoadMoreBox(false);
				model.items = [{name:"mytopic",title:"我的话题",row:"first",radiu:"top_left"},{name:"hotTp",title:"热门话题",row:"last",radiu:"top_right"},{name:"geoUser",title:"周边用户",row:"first"},{name:"geoStatus",title:"周边微博",row:"last"},{name:"hotRt",title:"热门转发",row:"first"},{name:"hotCm",title:"热门评论",row:"last"},{name:"public",title:"随便看看",row:"first",line:"rline",radiu:"bottom_left"},{name:"hotUser",title:"名人堂",row:"last",line:"noline",radiu:"bottom_right"}];
				this.controller.modelChanged(model);
				
				this.scrollToTop();
				this.subMenuModel.items[2].disabled = true;
				this.controller.modelChanged(this.subMenuModel);
				this.showLoadMoreBox(false);
			
			}else if(command === 'my'){
		    	
		    	this.controller.get("panels_scroller").mojo.setSnapIndex(4, 0);
		    	
				this.showLoadMoreBox(false);
				model.items = [{name:""}];
				this.controller.modelChanged(model);
				
				this.scrollToTop();
				
				if(Weibo.Prefs.myInfos && Weibo.Prefs.myInfos[0].screen_name == Weibo.Prefs.screen_name){
					this.userModel.items = Weibo.Prefs.myInfos;
					this.controller.modelChanged(this.userModel);
				}else{
					Weibo.Api.loadUserInfo(Weibo.Prefs.screen_name,this.userModel,this.controller);
				}
			
				this.subMenuModel.items[2].disabled = false;
				this.controller.modelChanged(this.subMenuModel);
				
				this.showLoadMoreBox(false);
			
			}else{
    			
			    //Weibo.homeFeature = 0;

			    this.controller.get("panels_scroller").mojo.setSnapIndex(this.paneIndex[command], 0);
		    
    			Weibo.Api.cancelReq();
    			this.subMenuModel.items[2].disabled = false;
				this.controller.modelChanged(this.subMenuModel);
				
				if(command === "comment" || command === "mention" || command === "dm" || command === "home"){
					var _dName = command === 'home' ? 'status' : command;
					Mojo.Controller.getAppController().closeStage(Weibo.Dashboard[_dName]);
					
					var _load = Weibo.newStatusNum[command] > 0 ? true : false;
				}
			
    			var t = this;
    			if(model.items.length < 1 || _load){
					
					this.refreshTimeOut = setTimeout(function(){t.load()}, 1*500);
    			}else{
					this.showLoadMoreBox(true);
				}
    			//this.load();
    			//this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listDefault'},command);
    		}
    	}
    }
};

ListDefaultAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
    
    var listWgt = Weibo.getFeedWgt(this.title);
    this.controller.get(listWgt).mojo.revealItem(0,false);
};

ListDefaultAssistant.prototype.scrollToBottom = function() {
	var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller = this.controller.get(listWgt+'Box');//this.controller.getSceneScroller();
	//var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller.mojo.scrollTo(undefined, -1 * this.controller.get(listWgt).getHeight());
	this.scroller.mojo.scrollTo(undefined, -1 * this.controller.get(listWgt).getHeight());
};

ListDefaultAssistant.prototype.scrollNext = function() {
	//this.scroller = this.controller.getSceneScroller();
	var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller = this.controller.get(listWgt+'Box');
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);

	this.pageY_abs = Math.abs(this.pageY);
	this.pageH = this.controller.get(listWgt).offsetHeight;	
		
	var _h = this.controller.window.innerHeight;
	if((this.pageY_abs+_h-10) > this.pageH && this.pageH > (_h-10)){
		if(Weibo.loading === false){
			this.loadMore();
		}
	}
};

ListDefaultAssistant.prototype.scrollPre = function() {
	//this.scroller = this.controller.getSceneScroller();
	var listWgt = Weibo.getFeedWgt(this.title);
	this.scroller = this.controller.get(listWgt+'Box');
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ListDefaultAssistant.prototype.openSearchBox = function() {
	if(this.searchBox_is_open == false){
		if(!Weibo.list['mytopic']){
			this.loadMyTopic();
		}
		this.searchBox_is_open = true;
		this.controller.get('scrim').show();
		this.controller.get('searchBox').addClassName('searchBox_open');
		
		this.keywordModel.disabled = false;
    	this.controller.modelChanged(this.keywordModel);
    	//this.controller.get('keyword').mojo.setValue('');
    	//this.controller.get('keyword').mojo.focus();
    	var t = this;
    	this.controller.window.setTimeout(function(){t.controller.get('keyword').mojo.focus();}, 1*500);
		
	}else{
		this.closeSearchBox();
	}
};

ListDefaultAssistant.prototype.closeSearchBox = function() {
	this.searchBox_is_open = false;
	this.controller.get('scrim').hide();
	this.controller.get('searchBox').removeClassName('searchBox_open');
	this.keywordModel.disabled = true;
    this.controller.modelChanged(this.keywordModel);
	
};

ListDefaultAssistant.prototype.handleKeyDownEvent = function(event) {
  if(this.searchBox_is_open === false){
    if(event.originalEvent.keyCode == 78){ //n
		var postData = [{"title":"update","titleName":"发布微博"}];
		this.stageController.pushScene('update',postData);
	
	}else if(event.originalEvent.keyCode == 82){ //r
    	this.loadNew();
    		
    }else if(event.originalEvent.keyCode == 80){ //p
    	this.stageController.pushScene("preferences");
    	
	}else if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
        
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
        
    }else if(event.originalEvent.keyCode == 83){ //s
    	this.openSearchBox();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
    	
    }else if(event.originalEvent.keyCode == 75){ //k
        this.goPanel("public");
        
    }else if(event.originalEvent.keyCode == 48){ //@ / option+a:38
        this.goPanel("mention");
        
    }else if(event.originalEvent.keyCode == 72){ //h /option+h:52
        this.goPanel("home");
        
    }else if(event.originalEvent.keyCode == 67){ //c / option+c:56
        this.goPanel("comment");
        
    }else if(event.originalEvent.keyCode == 77){ //m / option+m:59
       this.goPanel("dm");
       
    }else if(event.originalEvent.keyCode == 70){ //f
        if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;
			}else{
				this.setFullScreen(false);
				Weibo.Prefs.fullScreen = false;
			}
        }
        
    }else if(event.originalEvent.keyCode == 73){ //i
    	this.goPanel("my");
    	
    }else if(event.originalEvent.keyCode == 81){ //q

    }else if(event.originalEvent.keyCode == 188){ //,
    	var _pageY = this.scroller.mojo.getScrollPosition().top;
    	var listWgt = Weibo.getFeedWgt(this.title);
    	var _pageH = this.controller.get(listWgt).getHeight();
    	if(_pageY+_pageH<480){
    		this.loadMore();
    	}
    }
    
    //this.controller.get('test').innerHTML = event.originalEvent.keyCode;
  }
   
};


ListDefaultAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;

			}else{
			   
				if(this.downY > (_twHeight / 2)){
					this.selectMenu(evt);
				}else{
					this.setFullScreen(false);
					Weibo.Prefs.fullScreen = false;

				}
			}
		}else{
			if(this.downY > (_twHeight / 2)){
				this.selectMenu(evt);
			}
		}
    }
    
};

ListDefaultAssistant.prototype.handleCommand = function(event) {        

    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "update":
				var _camera = Weibo.Prefs.updateButton == 'camera' ? true : false;
				var postData = [{"title":"update","titleName":"发布微博","camera":_camera}];
				
				if(_camera){
					this.camClick();
				}else{
					this.stageController.pushScene('update',postData);
				}
				break;
			case "refresh":
				this.loadNew();
				break;
			case "do-group":
				this.selectSubMenu(event);
				break;
			case "do-select":
				this.selectMenu(event);
				break;
			case "do-search":
				this.openSearchBox();
				//this.stageController.pushScene('search');
				break;
			case "do-feature":
				this.selectFeature(event);
				break;
		}
		
	}else if (event.type == Mojo.Event.forward) {
		var postData = [{"title":"update","titleName":"发布微博"}];
		this.stageController.pushScene('update',postData);

	}else if (event.type == Mojo.Event.back) {
		if(this.searchBox_is_open == true){
			event.stop();
        	//event.stopPropagation();
			this.closeSearchBox();
		}else{
			var titleSub = this.title.substr(0,4);
			if(titleSub != 'home'){
				event.stop();
				this.goPanel("home");
			}
		}
	}
};

ListDefaultAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.NavMenuModel.visible = false;
        this.controller.modelChanged(this.NavMenuModel);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";

    }else{
		this.controller.enableFullScreenMode(false);
		this.NavMenuModel.visible = true;
        this.controller.modelChanged(this.NavMenuModel);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
    }
    
    var t = this;

    setTimeout(function(){
    	t.setListHeight(t.controller.window.innerHeight+50);
    	t.controller.get('horz_scrolling_contents').style.height = (t.controller.window.innerHeight+50)+'px';
  		t.controller.get('horz_scrolling_contents').style.width = t.controller.window.innerWidth*6+'px';
  		
    }, 500);

};

ListDefaultAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
	
	var window = this.controller.window;

  	this.setListHeight(window.innerHeight+50);
  	this.controller.get('horz_scrolling_contents').style.height = (window.innerHeight+50)+'px';
  	this.controller.get('horz_scrolling_contents').style.width = window.innerWidth*6+'px';
  	
  	this.setListPos(window.innerWidth);
  	
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ListDefaultAssistant.prototype.camClick = function(event){
    var nowtime = new Date(); 
	var longtime =nowtime.getTime();
	
    this.camfilename = "/media/internal/download/temp_"+longtime+".jpg";
    this.controller.stageController.pushScene({
            appId: 'com.palm.app.camera',
            name: 'capture'
        }, {
            sublaunch: true,
            filename: this.camfilename
        });
   
};

ListDefaultAssistant.prototype.selectCam = function(file){
	var postData = [{"title":"update","titleName":"发布微博","inputImg":file}];
	var thisA = this;
	
	setTimeout(function(){thisA.stageController.pushScene('update',postData)}, 100);
};

ListDefaultAssistant.prototype.showFeedWgt = function(title){
	var titleSub = title.substr(0,4);
	
	this.controller.get('homeListWgtBox').show();
	this.controller.get('mentionListWgtBox').show();
	this.controller.get('commentListWgtBox').show();
	this.controller.get('dmListWgtBox').show();
	this.controller.get('userListWgtBox').show();
	this.controller.get('feedListWgtBox').show();
};

ListDefaultAssistant.prototype.setListPos = function(w) {
	this.controller.get('homeListWgtBox').style.width = w+'px';
	this.controller.get('homeListWgtBox').style.left = '0px';
	
	this.controller.get('mentionListWgtBox').style.width = w+'px';
	this.controller.get('mentionListWgtBox').style.left = w+'px';
	
	this.controller.get('commentListWgtBox').style.width = w+'px';
	this.controller.get('commentListWgtBox').style.left = w*2+'px';
	
	this.controller.get('dmListWgtBox').style.width = w+'px';
	this.controller.get('dmListWgtBox').style.left = w*3+'px';
	
	this.controller.get('userListWgtBox').style.width = w+'px';
	this.controller.get('userListWgtBox').style.left = w*4+'px';
	
	this.controller.get('feedListWgtBox').style.width = w+'px';
	this.controller.get('feedListWgtBox').style.left = w*5+'px';
	
};

ListDefaultAssistant.prototype.setListHeight = function(h) {
	this.controller.get('homeListWgtBox').style.height = h+'px';
	this.controller.get('mentionListWgtBox').style.height = h+'px';
	this.controller.get('commentListWgtBox').style.height = h+'px';
	this.controller.get('dmListWgtBox').style.height = h+'px';
	this.controller.get('userListWgtBox').style.height = h+'px';
	this.controller.get('feedListWgtBox').style.height = h+'px';
};

ListDefaultAssistant.prototype.activate = function(params) {
	//this.showCountTip();
	this.controller.stageController.disableSceneScroller = true;
	
	var window = this.controller.window;
  	this.setListHeight((window.innerHeight+50));
  	this.setListPos(window.innerWidth);
  	
  	this.controller.get('horz_scrolling_contents').style.height = (window.innerHeight+50)+'px';
  	this.controller.get('horz_scrolling_contents').style.width = window.innerWidth*6+'px';

	if(params){
       Mojo.Log.info("^^^^^^#listDefault_activate_params");
       if(params.action == "panel"){
       		this.goPanel(params.panel);
       		
       }else if(params.action == "refresh"){
       		this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listDefault"},"home",true);   
       }else{
	       	if(params.filename){
		        this.selectCam(params.filename);
		    }
       }
       
    }
    
    if(Weibo.Prefs.updateButton == 'camera'){
		this.subMenuModel.items[0].iconPath = 'images/menu_camera.png';
	}else{
		this.subMenuModel.items[0].iconPath = 'images/menu_newStatus.png';
	}
    this.controller.modelChanged(this.subMenuModel);

	this.setFullScreen(Weibo.Prefs.fullScreen);
	
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
	
	if(!Weibo.Prefs.uid){
		this.controller.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "login"});
	}
	
	Mojo.Event.listen(this.controller.document, "keyup", this.handleKeyDown, true);
};

ListDefaultAssistant.prototype.deactivate = function(event) {
	Mojo.Log.info("^^^^^^#listDefault_deactivate");
	Mojo.Event.stopListening(this.controller.document, "keyup", this.handleKeyDown, true);
	this.closeSearchBox();
	//Weibo.Api.cancelReq();
};

ListDefaultAssistant.prototype.cleanup = function(event) {
	Mojo.Log.info("^^^^^^#listDefault_cleanup");
	//this.closeSearchBox();

	Mojo.Event.stopListening(this.controller.document, "keyup", this.handleKeyDown, true);
	Mojo.Event.stopListening(this.controller.get('scrim'), Mojo.Event.tap, this.closeSearchBox.bind(this) );

	this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));

	this.controller.stopListening("homeListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.homeModel));
    this.controller.stopListening("mentionListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.mentionModel));
    this.controller.stopListening("commentListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.commentModel));
    this.controller.stopListening("dmListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.dmModel));
    this.controller.stopListening("userListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.statusModel));
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this,this.statusModel));

	this.controller.stopListening('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
	this.controller.stopListening("topicListWgt", Mojo.Event.listTap,this.viewTopic.bindAsEventListener(this));

	this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));

	this.controller.stopListening('topMenu', Mojo.Event.tap,this.selectMenu.bind(this));
	this.controller.stopListening('countTip', Mojo.Event.tap,this.selectMenu.bind(this));

	this.controller.stopListening('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.stopListening('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));

	this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
	this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
	this.controller.stopListening("box", Mojo.Event.dragging, this.handleDragging.bind(this));
	//this.controller.stopListening("box", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	
	this.controller.stopListening("homeListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.stopListening("mentionListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.stopListening("commentListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	this.controller.stopListening("dmListWgtBox", Mojo.Event.dragEnd, this.handleDragend.bind(this));
	
	this.controller.stopListening("homeListWgtBox", Mojo.Event.handleDragging, this.handleDragging.bind(this));
	this.controller.stopListening("mentionListWgtBox", Mojo.Event.handleDragging, this.handleDragging.bind(this));
	this.controller.stopListening("commentListWgtBox", Mojo.Event.handleDragging, this.handleDragging.bind(this));
	this.controller.stopListening("dmListWgtBox", Mojo.Event.handleDragging, this.handleDragging.bind(this));
	
	this.controller.stopListening("homeListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("homeListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("homeListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.stopListening("mentionListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("mentionListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("mentionListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.stopListening("commentListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("commentListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("commentListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.stopListening("dmListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("dmListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("dmListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.stopListening("userListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("userListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("userListWgtBox","gestureend",this.gestureEnd.bind(this));
	
	this.controller.stopListening("feedListWgtBox","gesturestart",this.gestureStart.bind(this));
	this.controller.stopListening("feedListWgtBox","gesturechange",this.gestureChange.bind(this));
	this.controller.stopListening("feedListWgtBox","gestureend",this.gestureEnd.bind(this));

	this.controller.stopListening('searchType', Mojo.Event.tap,this.selectSearchType.bind(this));
    //Weibo.Api.cancelReq();
}