
function ListStatusAssistant(data) {
	this.url = data.url;
	this.para = data.para;
	this.title = data.title;
	this.name = data.name;
	this.titleName = data.titleName;
	this.type = data.type || "";
	this.loadType = data.loadType || '';
	this.tpl = data.tpl || "home";
	this.optionData = data.optionData || [];
	this._orientation = "up";
	
	this.geoType = "all";
	
	this.page = 1;
};

ListStatusAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	this.controller.get("headerText").innerHTML = this.titleName;
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
	
        
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
	
	this.controller.setupWidget("homeListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/home",
            listTemplate: "tpl/listTemplate",
            //renderLimit: 1000,
        },    
        this.statusModel = {
            items: []
        }
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);

	
    if(this.title == 'geo_status'){
    	this.getLocation();
    }else{
    	this.loadNew();
    }
    
    if(this.title === "home_hotRt" || this.title === "home_hotCm"){
    	this.controller.get("currentTransport").innerHTML = this.type == "daily" ? "今日" : "本周";
    	
    }else if(this.title === "geo_status"){
    	this.controller.get("currentTransport").innerHTML = "全部";
    	
    }else{
    	//this.controller.get("transport-picker").hide();
    	this.controller.get("currentTransport").innerHTML = this.type == "favs" ? "收藏" : "微博";
    }
    
    if(this.title === 'home_public'){
    	this.controller.get("transport-picker").hide();
    }else{
    	this.controller.get("transport-picker").show();
    }
    
    
    this.controller.listen('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    
    this.controller.listen('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.listen('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.listen('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.listen("homeListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
	
};

ListStatusAssistant.prototype.cancelLoad = function() {
	Weibo.Api.cancelReq();
	this.loadTip(false);
	if(Weibo.list[this.title].length < 1){
		this.showLoadMoreBox(false);
	}
};

ListStatusAssistant.prototype.selectOption = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	
	if(this.title === "home_hotRt" || this.title === "home_hotCm"){
		var _toggleCmd = this.type;
		var _items = [
				{label:"今日",command:"daily"},
				{label:"本周",command:"weekly"}
			];
			
	}else if(this.title === "geo_status"){
    	var _toggleCmd = this.geoType;
    	var _items = [
				{label:"全部",command:"all"},
				{label:"胖友",command:"webOS"}
			];

    }else{
    	var _toggleCmd = this.type;
    	var _items = [
				{label:"微博",command:"status"},
				{label:"关注",command:"friends"},
				{label:"粉丝",command:"followers"}
			];
		if(this.name == Weibo.Prefs.screen_name){
			_items.push({label:"收藏",command:"favs"});
		}else{
			_items.push({label:"个人信息",command:"userinfo"});
		}
    }
    
    this.controller.popupSubmenu({
    		onChoose:  this.gotOption,
    		toggleCmd: _toggleCmd,
        	placeNear: findPlace,
        	items: _items
    	});
};

ListStatusAssistant.prototype.gotOption = function(command) {
	if(command){
		if(this.title === "home_hotRt"){
			//var _url = "http://api.t.sina.com.cn/statuses/hot/repost_"+command+".json?count="+Weibo.Prefs.count;
			var _url = "http://api.t.sina.com.cn/statuses/hot/repost_"+command+".json";
			var _data = {"url":_url,"para":[['count', 30]],"title":"home_hotRt","titleName":"热门转发","type":command};
			this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listStatus'},_data);
			
		}else if(this.title === "home_hotCm"){
			var _url = "http://api.t.sina.com.cn/statuses/hot/comments_"+command+".json";
			var _data = {"url":_url,"para":[['count', 30]],"title":"home_hotRt","titleName":"热门评论","type":command};
			this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listStatus'},_data);
			
		}else if(this.title === "geo_status"){
			this.geoType = command;
			this.controller.get("currentTransport").innerHTML = command == "all" ? "全部" : "胖友";
			this.getLocation();
			
		}else{
			if(command === "status"){
				var _url = "http://api.t.sina.com.cn/statuses/user_timeline.json";
				var _para = [['screen_name', this.name],['count', Weibo.Prefs.count]];
				var _title = "home_user_timeline_"+this.name;
				var _data = {"url":_url,"para":_para,"title":_title,"name":this.name,"type":"status","titleName":this.name};
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listStatus"},_data);
			
			}else if(command === "favs"){
				var _url = "http://api.t.sina.com.cn/favorites.json";
				var _para = [['count', Weibo.Prefs.count]];
				var _title = "home_fav_"+this.name;
				var _data = {"url":_url,"para":_para,"title":_title,"name":this.name,"type":"favs","titleName":this.name,"loadType":"page"};
				this.stageController.pushScene("listStatus",_data);
				
			}else if(command === "userinfo"){
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "user"},this.name);
			
			}else{
				var _data = {"name":this.name,"type":command,"titleName":this.name};
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listUser"},_data);
			}
		
		}
	}
};

ListStatusAssistant.prototype.pageClick = function(event){
	Weibo.Opt.pageClick(event,this.title,this.statusModel,this.controller)
	//this.controller.modelChanged(this.statusModel.items[event.index], this);
};

ListStatusAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};

ListStatusAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox').addClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').hide();
		this.controller.get('loadMoreStart').show();
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox').removeClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').show();
		this.controller.get('loadMoreStart').hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

ListStatusAssistant.prototype.showData = function(data,sIndex) {
	this.loadTip(false);
	if(Weibo.list[this.title].length < 1 || this.title === "home_hotCm" || this.title === "home_hotRt"){
		this.controller.get('loadMoreBox').hide();
	}
	this.statusModel.items = data;
	this.controller.modelChanged(this.statusModel);
	if(sIndex > -1){
		this.controller.get('homeListWgt').mojo.revealItem(sIndex,true);
	}
};

ListStatusAssistant.prototype.showFailure = function() {
	this.loadTip(false);
	if(Weibo.list[this.title].length < 1 || this.title === "home_hotCm" || this.title === "home_hotRt"){
		this.controller.get('loadMoreBox').hide();
	}
};

ListStatusAssistant.prototype.getLocation = function() {
    this.loadTip(true);
	this.showLoadMoreBox(false);
    this.controller.serviceRequest('palm://com.palm.location', {
    	method:"getCurrentPosition",
    	parameters:{accuracy:1, maximumAge:0, responseTime:1},
    	onSuccess: this.getLocationSuccess.bind(this),
    	onFailure: this.getLocationFailure.bind(this)
    });
};

ListStatusAssistant.prototype.getLocationSuccess = function(response) {
    this.lat = response.latitude;
    this.lon = response.longitude;
	
	var base_app = this.geoType == "all" ? 0 : 1;

	var parameters = [['longitude', this.lon],['latitude', this.lat],['page', 1],['sort_type', 0],['base_app', base_app],['count', Weibo.Prefs.count]];
	
	
	var url = Weibo.signRequest(this.url, parameters, "GET");
	
	Weibo.list['geo_status'] = [];
	
	Weibo.Api.loadItem(url,this.title,this.statusModel,this.controller,'new');

};


ListStatusAssistant.prototype.getLocationFailure = function(error) {

	Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "获取GPS信息失败"}, {}, Weibo.MainStageName);
    if(error.errorCode == 5){
    	Mojo.Controller.errorDialog("Location services on the device are 'OFF', turn location services 'ON' and try again", this.controller.window);
    }
};

ListStatusAssistant.prototype.loadNew = function(){
	this.loadTip(true);
	this.showLoadMoreBox(false);
	Weibo.since_id[this.title] = 0;//Weibo.since_id[this.title] ? Weibo.since_id[this.title] : 0;
	
	var _count = (this.title === "home_hotRt" || this.title === "home_hotCm") ? 30 : Weibo.Prefs.count;
	
	var parameters = [['count', _count],['screen_name', this.name]];//this.para;
	
	if(this.loadType === 'page'){
		//var url = this.url+"&page=1";
		parameters.push(['page', 1]);
		var url = Weibo.signRequest(this.url, parameters, "GET");
	
	}else{
		//var url = this.url+"&since_id="+Weibo.since_id[this.title];
		parameters.push(['since_id', Weibo.since_id[this.title]]);
		var url = Weibo.signRequest(this.url, parameters, "GET");
	}
	
	var _title = this.title;
	Weibo.list[_title] = [];
	
	Weibo.Api.loadItem(url,_title,this.statusModel,this.controller,'new');
    
};

ListStatusAssistant.prototype.loadMore = function(){
	this.loadTip(true);
	
	if(this.title == 'geo_status'){
		var base_app = this.geoType == "all" ? 0 : 1;
		var parameters = [['longitude', this.lon],['latitude', this.lat],['sort_type', 0],['base_app', base_app],['count', Weibo.Prefs.count]];
	}else{
		var parameters = [['count', Weibo.Prefs.count],['screen_name', this.name]];//this.para;
	}
	
	if(this.loadType === 'page'){
		this.page = this.page + 1;
		//var url = this.url+"&page="+this.page;
		
		parameters.push(['page', this.page]);
		var url = Weibo.signRequest(this.url, parameters, "GET");
		
	}else{
		//var url = this.url+"&max_id="+Weibo.max_id[this.title];
		parameters.push(['max_id', Weibo.max_id[this.title]]);
		var url = Weibo.signRequest(this.url, parameters, "GET");
		
	}
	
	var _title = this.title;

    Weibo.Api.loadItem(url,_title,this.statusModel,this.controller,'old');
};

ListStatusAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

ListStatusAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('homeListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('homeListWgt').getHeight());
};

ListStatusAssistant.prototype.scrollNext = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);
};

ListStatusAssistant.prototype.scrollPre = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ListStatusAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "update":
				var postData = [{"title":"update","titleName":"发布微博"}];
				this.stageController.pushScene('update',postData);
				break;
			case "do-refresh":
				this.loadNew();
				break;
			case "do-back":
				this.controller.stageController.popScene();
				break;
		}
	}
};


ListStatusAssistant.prototype.handleKeyDownEvent = function(event){
    if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
        
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
       
    }else if(event.originalEvent.keyCode == 70){ //f
		if(this._orientation === "up"){
        	if(Weibo.Prefs.fullScreen == false){
            	this.setFullScreen(true);
            	Weibo.Prefs.fullScreen = true;
        	}else{
            	this.setFullScreen(false);
            	Weibo.Prefs.fullScreen = false;
        	}
        }
    	
    }else if(event.originalEvent.keyCode == 81){ //q
		this.controller.stageController.popScene();
		
    }else if(event.originalEvent.keyCode == 188){ //,
    	var _pageY = this.scroller.mojo.getScrollPosition().top;
    	var _pageH = this.controller.get('homeListWgt').getHeight();
    	if(_pageY+_pageH<480){
    		this.loadMore();
    	}
    }
    
    //this.controller.get('title').innerHTML = event.originalEvent.keyCode;
   
};

ListStatusAssistant.prototype.handleDragstart = function(evt){
	this.downY = evt.down.y;
};

ListStatusAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
        
		if(this._orientation === "up"){
		if(Weibo.Prefs.fullScreen == false){
            this.setFullScreen(true);
            Weibo.Prefs.fullScreen = true;

        }else{
           
        	if(this.downY > (_twHeight / 2)){
        		//this.selectMenu(evt);
        	}else{
            	this.setFullScreen(false);
            	Weibo.Prefs.fullScreen = false;

            }
        }
       }

    }
    
};

ListStatusAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();
    }
};

ListStatusAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ListStatusAssistant.prototype.activate = function(event) {
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}

	this.setFullScreen(Weibo.Prefs.fullScreen);
};

ListStatusAssistant.prototype.deactivate = function(event) {

};

ListStatusAssistant.prototype.cleanup = function(event) {
	this.controller.stopListening('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    
    this.controller.stopListening('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.stopListening('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.stopListening('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.stopListening("homeListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
}