
function ListTopicAssistant(mode) {
	this.mode = mode ? mode : 'public';
	this.showName = {"hourly":"最近","daily":"当日","weekly":"当周"};
	this.type = "hourly";
	this._orientation = "up";
	this.page  = 1;
};

ListTopicAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	//this.controller.get("headerText").innerHTML = this.titleName;
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);

    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
    var _tpl = this.mode === 'my' ? 'mytopic' : 'topic';
	
	this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/"+_tpl,
            listTemplate: "tpl/listTemplate",
            renderLimit: 100,
        },    
        this.statusModel = {
            items: []
        }
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	
    this.refresh("hourly");
    
    if(this.mode === 'my'){
    	this.controller.get("transport-picker").hide();
    	this.controller.get("headerText").innerHTML = "我的话题";
    }else{
    	this.controller.get("transport-picker").show();
    	this.controller.get("currentTransport").innerHTML = "最近";
    	this.controller.get("headerText").innerHTML = "热门话题";
    }

    this.controller.listen('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.listen('loadMoreBtn', Mojo.Event.tap,this.loadMoreTopic.bind(this));
    this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
	
};

ListTopicAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox').addClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').hide();
		this.controller.get('loadMoreStart').show();
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox').removeClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').show();
		this.controller.get('loadMoreStart').hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

ListTopicAssistant.prototype.selectOption = function(event) {
	var findPlace = event.target || event.originalEvent.target;

	var _toggleCmd = this.type;
	var _items = [
		{label:"最近",command:"hourly"},
		{label:"当日",command:"daily"},
		{label:"当周",command:"weekly"}
	];

    this.controller.popupSubmenu({
    		onChoose:  this.gotOption,
    		toggleCmd: _toggleCmd,
        	placeNear: findPlace,
        	items: _items
    	});
};

ListTopicAssistant.prototype.gotOption = function(command) {
	if(command){
		this.type = command;
		this.controller.get("currentTransport").innerHTML = this.showName[command];
		this.refresh(command);
	}
};

ListTopicAssistant.prototype.pageClick = function(event){
	var name = this.mode === 'my' ? event.item.hotword : event.item.name;
	this.stageController.pushScene("search",name);
};

ListTopicAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};

ListTopicAssistant.prototype.refresh = function(type){
	this.loadTip(true);
	this.showLoadMoreBox(false);
	this.scrollToTop();
	this.page = 1;
	if(this.mode === 'my'){
		this.loadMyTopic();
	}else{
		this.loadHotTopic(type);
	}
};

ListTopicAssistant.prototype.loadHotTopic = function(type){

	var url = "http://api.t.sina.com.cn/trends/"+type+".xml";
	//var parameters = [[]];
	var _url = Weibo.signRequest(url, null, "GET");
	//var _url = Weibo.Oauth.oauthUrl(url,"GET");
	//var oHeader = Weibo.Oauth.oauthHeader(url,"GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
			  //requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
			  requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: this.reqSuccess.bind(this),
              onFailure: this.reqFailure.bind(this)
	    });
    
};

ListTopicAssistant.prototype.loadMyTopic = function() {

    var thisA = this;
    var url = "http://api.t.sina.com.cn/trends.json";
    
    var parameters = [['user_id', Weibo.Prefs.uid],['count', Weibo.Prefs.count]];

	var _url = Weibo.signRequest(url, parameters, "GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
              requestHeaders:['Accept-Encoding','gzip,deflate'],
              //requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
				if (resp.responseJSON) {
					thisA.statusModel.items = resp.responseJSON;
    				thisA.controller.modelChanged(thisA.statusModel);
    				thisA.loadTip(false);
    				thisA.showLoadMoreBox(true);
    			}else{
    				thisA.showLoadMoreBox(false);
    			}
    			
              }.bind(this),
              onFailure: this.reqFailure.bind(this)
       });
    
};

ListTopicAssistant.prototype.loadMoreTopic = function(){
	this.loadTip(true);
	var thisA = this;
    var url = "http://api.t.sina.com.cn/trends.json";
    this.page = this.page + 1;
    var parameters = [['user_id', Weibo.Prefs.uid],['count', Weibo.Prefs.count],['page', this.page]];
    
	var _url = Weibo.signRequest(url, parameters, "GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
              requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
				if (resp.responseJSON) {
    				
    				var oldListNum = thisA.statusModel.items.length;
    				var _length = thisA.statusModel.items.length + resp.responseJSON.length;
    				
    				thisA.controller.get('feedListWgt').mojo.setLength(_length);
              		thisA.controller.get('feedListWgt').mojo.noticeUpdatedItems(oldListNum, resp.responseJSON);
              		//thisA.controller.get('feedListWgt').mojo.revealItem(sIndex,true);
    				
    				thisA.loadTip(false);
    				if(resp.responseJSON.length > (Weibo.Prefs.count-1)){
    					thisA.showLoadMoreBox(true);
    				}else{
    					thisA.showLoadMoreBox(false);
    				}
    			}else{
    				thisA.showLoadMoreBox(false);
    			}
    			
              }.bind(this),
              onFailure: this.reqFailure.bind(this)
       });

};

ListTopicAssistant.prototype.reqSuccess = function(resp) {
	Mojo.Log.info("^^^^^^#reqSuccess");
	var topics = resp.responseXML.getElementsByTagName("trend");
	
	var _items = [];
	for (var i=0; i<topics.length; i++){
		_items[i] = {name: topics[i].getElementsByTagName("name").item(0).textContent};
	}
	
	this.statusModel.items = _items;
	this.controller.modelChanged(this.statusModel);
	this.loadTip(false);
	this.showLoadMoreBox(false);
};

ListTopicAssistant.prototype.reqFailure = function(resp) {
	Mojo.Log.info("^^^^^^#reqFailure");
	this.loadTip(false);
	//this.controller.get('tips').innerHTML = Object.toJSON(resp);
};

ListTopicAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

ListTopicAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
};

ListTopicAssistant.prototype.scrollNext = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);
};

ListTopicAssistant.prototype.scrollPre = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ListTopicAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-refresh":
				this.refresh();
				break;
			case "do-back":
				this.controller.stageController.popScene();
				break;
		}
	}
};

ListTopicAssistant.prototype.handleKeyDownEvent = function(event){
    if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
        
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
       
    }else if(event.originalEvent.keyCode == 70){ //f
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;
			}else{
				this.setFullScreen(false);
				Weibo.Prefs.fullScreen = false;
			}
        }
    	
    }else if(event.originalEvent.keyCode == 81){ //q
		this.controller.stageController.popScene();
		
    }   
};

ListTopicAssistant.prototype.handleDragstart = function(evt){
	this.downY = evt.down.y;
};

ListTopicAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
        
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;

			}else{
			   
				if(this.downY > (_twHeight / 2)){
					//this.selectMenu(evt);
				}else{
					this.setFullScreen(false);
					Weibo.Prefs.fullScreen = false;

				}
			}
		}

    }
    
};

ListTopicAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();

    }
};

ListTopicAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ListTopicAssistant.prototype.activate = function(event) {
	this.setFullScreen(Weibo.Prefs.fullScreen);
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

ListTopicAssistant.prototype.deactivate = function(event) {
};

ListTopicAssistant.prototype.cleanup = function(event) {
    
    this.controller.stopListening('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
}