
function ListUserAssistant(data) {
	this.name = data.name;
	this.type = data.type ? data.type : "friends";
	this.title = "user_"+data.name+"_"+data.type;
	this.titleName = data.titleName;
	this.optionData = data.optionData || [];
	this._orientation = "up";
	this.showHotTypeName = {"default":"人气关注","ent":"影视名星","hk_famous":"港台名人","model":"模特","cooking":"美食&健康","sport":"体育名人","finance":"商界名人","tech":"IT互联网","singer":"歌手","writer":"作家","moderator":"主持人","medium":"媒体总编","stockplayer":"炒股高手"};
	this.geoType = "all";
	
};

ListUserAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	Weibo.Control.setTheme(this.controller);
	
	this.controller.get("headerText").innerHTML = this.titleName;
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
	
	
    //this.controller.setupWidget(Mojo.Menu.viewMenu, undefined, this.NavMenuModel ); 
        
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
	
	this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/userItem",
            listTemplate: "tpl/listTemplate",
            renderLimit: 500,
        },    
        this.statusModel = {
            items: []
        }
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);

	
    this.refresh();
    
    if(this.type === "hot"){
    	this.showLoadMoreBox(false);
    	this.controller.get("transport-picker").show();
    	this.controller.get("currentTransport").innerHTML = this.showHotTypeName[this.name];

	}else if(this.type === "geo"){
    	this.showLoadMoreBox(false);
    	this.controller.get("transport-picker").show();
    	this.controller.get("currentTransport").innerHTML = "全部";

    }else if(this.type === "friends" ||this.type === "followers"){
    	this.controller.get("transport-picker").show();
    	this.controller.get("currentTransport").innerHTML = this.type === "friends" ? "关注" : "粉丝";
    }else{
    	this.controller.get("transport-picker").hide();
    }
    
    this.controller.listen('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    this.controller.listen('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.listen('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.listen('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.itemClick.bindAsEventListener(this));
    this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    
    this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
	
};

ListUserAssistant.prototype.cancelLoad = function() {
	Weibo.Api.cancelReq();
	this.loadTip(false);
	if(Weibo.list[this.title].length < 1){
		this.showLoadMoreBox(false);
	}
};

ListUserAssistant.prototype.selectOption = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	
	if(this.type === "hot"){
		var _toggleCmd = this.name;
		var _items = [
				{label:"人气关注",command:"default"},
				{label:"影视名星",command:"ent"},
				{label:"港台名人",command:"hk_famous"},
				{label:"模特",command:"model"},
				{label:"美食&健康",command:"cooking"},
				{label:"体育名人",command:"sport"},
				{label:"商界名人",command:"finance"},
				{label:"IT互联网",command:"tech"},
				{label:"歌手",command:"singer"},
				{label:"作家",command:"writer"},
				{label:"主持人",command:"moderator"},
				{label:"媒体总编",command:"medium"},
				{label:"炒股高手",command:"stockplayer"}
				//]}
			];
	 }else if(this.type === "geo"){
    	var _toggleCmd = this.geoType;
    	var _items = [
				{label:"全部",command:"all"},
				{label:"胖友",command:"webOS"}
			];
    
    }else if(this.type === "friends" ||this.type === "followers"){
    	var _toggleCmd = this.type;
    	var _items = [
				{label:"微博",command:"status"},
				{label:"关注",command:"friends"},
				{label:"粉丝",command:"followers"}
			];
		if(this.name == Weibo.Prefs.screen_name){
			_items.push({label:"收藏",command:"favs"});
		}else{
			_items.push({label:"个人信息",command:"userinfo"});
		}
    }
    this.controller.popupSubmenu({
    		onChoose:  this.gotOption,
    		toggleCmd: _toggleCmd,
        	placeNear: findPlace,
        	items: _items
    	});
};

ListUserAssistant.prototype.gotOption = function(command) {
	if(command){
		if(this.type === "hot"){
			this.loadTip(true);
			this.showLoadMoreBox(false);
			this.scrollToTop();
			this.name = command;
			this.controller.get("currentTransport").innerHTML = this.showHotTypeName[this.name];
			Weibo.Api.loadHotUser(this.name,this.statusModel,this.controller);

		}else if(this.type === "geo"){
			this.geoType = command;
			this.controller.get("currentTransport").innerHTML = command == "all" ? "全部" : "胖友";
			this.refresh();
			
		}else if(this.type === "friends" || this.type === "followers"){
			
			if(command === "status"){
				var _url = "http://api.t.sina.com.cn/statuses/user_timeline.json";
				var _para = [['screen_name', this.name],['count', Weibo.Prefs.count]];
				var _title = "home_user_timeline_"+this.name;
				var _data = {"url":_url,"para":_para,"title":_title,"name":this.name,"type":"status","titleName":this.name};
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listStatus"},_data);
			
			}else if(command === "favs"){
				var _url = "http://api.t.sina.com.cn/favorites.json";
				var _para = [['count', Weibo.Prefs.count]];
				var _title = "home_fav_"+this.name;
				var _data = {"url":_url,"para":_para,"title":_title,"name":this.name,"type":"favs","titleName":this.name,"loadType":"page"};
				this.stageController.pushScene("listStatus",_data);
			
			}else if(command === "userinfo"){
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "user"},this.name);
			
			}else{
				var _data = {"name":this.name,"type":command,"titleName":this.name};
				this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listUser"},_data);
			}
		}
	}
};

ListUserAssistant.prototype.itemClick = function(event){
	var _userInfo = [];
	    _userInfo.push(this.statusModel.items[event.index]);
	    
	if(Weibo.Prefs.clickUser === "status"){
		Weibo.Opt.userTimeline(event.item.screen_name);

	}else{
		this.stageController.pushScene("user",this.statusModel.items[event.index].screen_name,_userInfo);
	}
};

ListUserAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};

ListUserAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox').addClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').hide();
		this.controller.get('loadMoreStart').show();
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox').removeClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').show();
		this.controller.get('loadMoreStart').hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

ListUserAssistant.prototype.showData = function(data,sIndex) {
	this.loadTip(false);
	if(this.type === "hot"){
    	this.showLoadMoreBox(false);
    }
	this.statusModel.items = data;
	this.controller.modelChanged(this.statusModel);
	if(sIndex > -1){
		this.controller.get('feedListWgt').mojo.revealItem(sIndex,true);
	}

	if(this.name === Weibo.Prefs.screen_name && Weibo.newStatusNum["followers"] > 0){
		Weibo.Api.resetCount(4);
		Weibo.newStatusNum["followers"] = 0;
		Mojo.Controller.getAppController().closeStage(Weibo.Dashboard["followers"]);
	}
};

ListUserAssistant.prototype.showFailure = function() {
	this.loadTip(false);
};

ListUserAssistant.prototype.showNone = function() {
	this.loadTip(false);
	this.controller.get('loadMoreBox').hide();
};

ListUserAssistant.prototype.refresh = function(){
	this.loadTip(true);
	this.showLoadMoreBox(false);
	if(this.type === "hot"){
		Weibo.Api.loadHotUser(this.name,this.statusModel,this.controller);

	}else if(this.type === "geo"){
		Weibo.list['geoUser'] = [];
		this.getLocation();
	}else{
		
		Weibo.cursor[this.title] = -1;
		Weibo.list[this.title] = [];
		Weibo.Api.loadUserItem(this.name,Weibo.cursor[this.title],this.statusModel,this.controller,this.type);
	}
    
};

ListUserAssistant.prototype.getLocation = function() {
    this.controller.serviceRequest('palm://com.palm.location', {
    	method:"getCurrentPosition",
    	parameters:{accuracy:1, maximumAge:0, responseTime:1},
    	onSuccess: this.getLocationSuccess.bind(this),
    	onFailure: this.getLocationFailure.bind(this)
    });
};

ListUserAssistant.prototype.getLocationSuccess = function(response) {
    this.lat = response.latitude;
    this.lon = response.longitude;

	this.pageGeo = 1;

	//Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "获取GPS信息"+this.lat+"/"+this.lon}, {}, Weibo.MainStageName);
	var base_app = this.geoType == "all" ? 0 : 1;

	Weibo.Api.loadGeoUser({lat:this.lat,lon:this.lon,page:1,app:base_app},this.statusModel,this.controller);

};


ListUserAssistant.prototype.getLocationFailure = function(error) {

	Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "获取GPS信息失败"}, {}, Weibo.MainStageName);
    if(error.errorCode == 5){
    	Mojo.Controller.errorDialog("Location services on the device are 'OFF', turn location services 'ON' and try again", this.controller.window);
    }
};

ListUserAssistant.prototype.loadMore = function(){
	if(this.type == "geo"){
		if(this.lat && this.lon){
			this.pageGeo = this.pageGeo + 1;
			var base_app = this.geoType == "all" ? 0 : 1;
			Weibo.Api.loadGeoUser({lat:this.lat,lon:this.lon,page:this.pageGeo,app:base_app},this.statusModel,this.controller);
		}
	}else{
		if(this.type != "hot"){
			if(Weibo.cursor[this.title] > 0){
				this.loadTip(true);
				Weibo.Api.loadUserItem(this.name,Weibo.cursor[this.title],this.statusModel,this.controller,this.type);
			}
		}
	}
};

ListUserAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

ListUserAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
};

ListUserAssistant.prototype.scrollNext = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);
};

ListUserAssistant.prototype.scrollPre = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ListUserAssistant.prototype.handleKeyDownEvent = function(event) {

    if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
    
    }else if(event.originalEvent.keyCode == 82){ //r
    	this.refresh();
    	   
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
       
    }else if(event.originalEvent.keyCode == 70){ //f
        if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;
			}else{
				this.setFullScreen(false);
				Weibo.Prefs.fullScreen = false;
			}
        }
    	
    }else if(event.originalEvent.keyCode == 81){ //q
		this.controller.stageController.popScene();
		
    }else if(event.originalEvent.keyCode == 188){ //,
    	var _pageY = this.scroller.mojo.getScrollPosition().top;
    	var _pageH = this.controller.get('feedListWgt').getHeight();
    	if(_pageY+_pageH<480){
    		this.loadMore();
    	}
    }
    
    //this.controller.get('title').innerHTML = event.originalEvent.keyCode;
  
   
};

ListUserAssistant.prototype.backMain = function(command) {    
	var app_controller = Mojo.Controller.getAppController();
	var stage_controller = app_controller.getStageController(Weibo.MainStageName);
	var top_scene = stage_controller.getScenes();
	//Mojo.Controller.getAppController().showBanner({"messageText": top_scene[0].sceneName}, {}, Weibo.MainStageName);
	
	if(top_scene[0].sceneName != "listDefault"){
		this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listDefault'});
	}else{
		this.stageController.popScene();
	}
	
};

ListUserAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "update":
				var postData = [{"title":"update","titleName":"发布微博"}];
				this.stageController.pushScene('update',postData);
				break;
			case "do-refresh":
				this.refresh();
				break;
			case "do-back":
				this.backMain();
				//this.controller.stageController.popScene();
				break;
		}
	}
};

ListUserAssistant.prototype.handleDragstart = function(evt){
	//this.controller.get('title').innerHTML = "a"+evt.down.y;
	this.downY = evt.down.y;
};

ListUserAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
        
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;

			}else{
			   
				if(this.downY > (_twHeight / 2)){
					//this.selectMenu(evt);
				}else{
					this.setFullScreen(false);
					Weibo.Prefs.fullScreen = false;

				}
			}
		}

    }
    
};

ListUserAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();

    }
};

ListUserAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ListUserAssistant.prototype.activate = function(event) {
	this.setFullScreen(Weibo.Prefs.fullScreen);
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

ListUserAssistant.prototype.deactivate = function(event) {
};

ListUserAssistant.prototype.cleanup = function(event) {
    
    this.controller.stopListening('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    this.controller.stopListening('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.stopListening('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.stopListening('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.itemClick.bindAsEventListener(this));
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
}