
function ListUserDmAssistant(user) {
	this.user = user;
	Weibo.list["listUserDmAll"] = [];
	Weibo.markerIndex["listUserDmAll"] = 0;
	this._orientation = "up";
	this.page  = 1;
};

ListUserDmAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	this.controller.get("headerText").innerHTML = "与"+this.user+"的对话";
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
	
    /* 
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
	*/
	this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/userDmItem",
            listTemplate: "tpl/listTemplate",
            renderLimit: 300,
        },    
        this.statusModel = {
            items: ''
        }
    );

	this.controller.setupWidget('messageTextWidget',
		this.messageTextWidgetAttributes = {
		    //inputName: "messageTextElement",
		    hintText: $L('Enter message here...'),
		    multiline: true,
		    focus: true,
		    enterSubmits: true,
			//requiresEnterKey: true,
		    //modelProperty: "value",
			changeOnKeyPress: true
		},
		this.messageTextWidgetModel = {value : ''}
	);
	    
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);

    this.loadNew();
    
    //this.controller.listen('transport-picker', Mojo.Event.tap,this.selectOption.bind(this));
    this.controller.listen('transport-picker', Mojo.Event.tap,this.loadNew.bind(this));
    
    this.controller.listen('SendButton',Mojo.Event.tap, this.sendDm.bind(this));
    
    this.controller.listen('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.listen('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.listen('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
	
};

ListUserDmAssistant.prototype.cancelLoad = function() {
	Weibo.Api.cancelReq();
	this.loadTip(false);
	if(Weibo.list['listUserDmAll'].length < 1){
		this.showLoadMoreBox(false);
	}
};

ListUserDmAssistant.prototype.sendDm = function() {
	var message = this.messageTextWidgetModel.value; 	 
    
    if(message){
    	var url = "http://api.t.sina.com.cn/direct_messages/new.json";

		var parameters = [['screen_name', this.user],['text', message]];

		var postBody = Weibo.signRequest(url, parameters, "POST");

		var req = new Ajax.Request(url, {
			method : 'post', 
			evalJSON : 'force',
			postBody: postBody,
			contentType: 'application/x-www-form-urlencoded',
			onSuccess: this.sendSuccess.bind(this),
            onFailure: this.sendFailure.bind(this)
		});
		/*
		var url = "http://api.t.sina.com.cn/direct_messages/new.json?screen_name="+this.user+"&text="+message;
    	var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
        	
        	var request = new Ajax.Request(url, {
				requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
				method: "post",
                evalJSON: "true",
                onSuccess: this.sendSuccess.bind(this),
                onFailure: this.sendFailure.bind(this)
            });
		*/
    }

};

ListUserDmAssistant.prototype.sendSuccess = function(transport) {
	
	var thisA = this;
	if (transport.status == 200) {
		this.messageTextWidgetModel.value = '';
    	this.controller.modelChanged(this.messageTextWidgetModel);
    	
    	this.controller.window.setTimeout(function(){thisA.loadNew()}, 1*1000);
    	//this.loadNew();
    	
		Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Success"}, {}, Weibo.MainStageName);

	}else{
		this.sendFailure();
	}
};

ListUserDmAssistant.prototype.sendFailure = function(transport) {
    //Mojo.Log.info("^^^^^^ "+Object.toJSON(transport));
    Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Failure"}, {}, Weibo.MainStageName);

	
};


ListUserDmAssistant.prototype.selectOption = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	
};

ListUserDmAssistant.prototype.gotOption = function(command) {
	
};

ListUserDmAssistant.prototype.pageClick = function(event){
	Weibo.Opt.pageClick(event,"listUserDmAll",this.statusModel,this.controller)
	//this.controller.modelChanged(this.statusModel.items[event.index], this);
};

ListUserDmAssistant.prototype.load = function(page){
	var thisA = this;
	var url = "http://api.t.sina.com.cn/direct_messages/with.json?";
	//var oHeader = Weibo.Oauth.oauthHeader(url,"GET");
	var parameters = [['count', Weibo.Prefs.count],['screen_name', this.user],['page', page]];
	var _url = Weibo.signRequest(url, parameters, "GET");
	
	this.req = new Ajax.Request(_url, {
			method: "get",
			//requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
			requestHeaders:['Accept-Encoding','gzip,deflate'],
			onSuccess: function(resp){
    			if(resp.responseJSON.length > 0){
    				
    				var newItems = formatDmItems(resp.responseJSON);
    			
    				if(Weibo.list["listUserDmAll"].length > 0){
    					if(Weibo.list["listUserDmAll"][Weibo.markerIndex["listUserDmAll"]] && Weibo.list["listUserDmAll"][Weibo.markerIndex["listUserDmAll"]].is_marker){
         					Weibo.list["listUserDmAll"][Weibo.markerIndex["listUserDmAll"]].marker_class = 'old_marker';
         				}
    					var marker = {is_marker: true,marker_class: 'new_marker'};
    					Mojo.Log.info("^^^^^^loadDM_"+Weibo.list["listUserDmAll"].length);
    					Weibo.list["listUserDmAll"].push(marker);
    					Weibo.markerIndex["listUserDmAll"] = Weibo.list["listUserDmAll"].length-1;

    				}else{
    					Weibo.markerIndex["listUserDmAll"] = 0;
    					//Weibo.list["listUserDmAll"] = newItems;
    				}
    				
    				Weibo.list["listUserDmAll"] = Weibo.list["listUserDmAll"].concat(newItems);
    				thisA.loadTip(false);
    				var _r_length = resp.responseJSON.length;
    				if(_r_length < 3/4 * Weibo.Prefs.count){
    					thisA.showLoadMoreBox(false);
    				}
    				
    				thisA.statusModel.items = Weibo.list["listUserDmAll"];//formatDmItems(resp.responseJSON);
    				thisA.controller.modelChanged(thisA.statusModel);
    				var _sIndex = Weibo.markerIndex["listUserDmAll"]+1;
    				Mojo.Log.info("^^^^^^loadDM_mark_"+_sIndex+"|"+Weibo.list["listUserDmAll"].length);
					thisA.controller.get('feedListWgt').mojo.revealItem(_sIndex,true);
				}else{
					thisA.loadTip(false);
					thisA.showLoadMoreBox(false);
				}
			}.bind(this),
			onFailure: function(resp){
            	thisA.loadTip(false);
			}.bind(this)
		});

    
};

ListUserDmAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};

ListUserDmAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};

ListUserDmAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox').addClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').hide();
		this.controller.get('loadMoreStart').show();
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox').removeClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').show();
		this.controller.get('loadMoreStart').hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

ListUserDmAssistant.prototype.loadNew = function(){
	this.loadTip(true);
	this.showLoadMoreBox(false);
	Weibo.list["listUserDmAll"] = [];
	this.page = 1;
	this.load(1);  
};

ListUserDmAssistant.prototype.loadMore = function(){
	this.loadTip(true);
	this.page = this.page + 1;
	this.load(this.page);
};

ListUserDmAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

ListUserDmAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
};

ListUserDmAssistant.prototype.scrollNext = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);
};

ListUserDmAssistant.prototype.scrollPre = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ListUserDmAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "update":
				var postData = [{"title":"update","titleName":"发布微博"}];
				this.stageController.pushScene('update',postData);
				break;
			case "do-refresh":
				this.loadNew();
				break;
			case "do-back":
				this.controller.stageController.popScene();
				break;
		}
	}
};

ListUserDmAssistant.prototype.handleKeyDownEvent = function(event) {

    if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
        
    }else if(event.originalEvent.keyCode == 82){ //r
    	this.loadNew();
        
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
       
    }else if(event.originalEvent.keyCode == 70){ //f
        if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;
			}else{
				this.setFullScreen(false);
				Weibo.Prefs.fullScreen = false;
			}
        }
    	
    }else if(event.originalEvent.keyCode == 81){ //q
		this.controller.stageController.popScene();
		
    }else if(event.originalEvent.keyCode == 188){ //,
    	var _pageY = this.scroller.mojo.getScrollPosition().top;
    	var _pageH = this.controller.get('feedListWgt').getHeight();
    	if(_pageY+_pageH<480){
    		this.loadMore();
    	}
    }
    
    //this.controller.get('title').innerHTML = event.originalEvent.keyCode;
  
   
};

ListUserDmAssistant.prototype.handleDragstart = function(evt){
	//this.controller.get('title').innerHTML = "a"+evt.down.y;
	this.downY = evt.down.y;
};

ListUserDmAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
        
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;

			}else{
			   
				if(this.downY > (_twHeight / 2)){
					//this.selectMenu(evt);
				}else{
					this.setFullScreen(false);
					Weibo.Prefs.fullScreen = false;

				}
			}
		}

    }
    
};

ListUserDmAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);

		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);

		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();

    }
};

ListUserDmAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ListUserDmAssistant.prototype.activate = function(event) {
	this.setFullScreen(Weibo.Prefs.fullScreen);
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

ListUserDmAssistant.prototype.deactivate = function(event) {
};

ListUserDmAssistant.prototype.cleanup = function(event) {
	//this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.viewInfo.bindAsEventListener(this));
	this.controller.stopListening('transport-picker', Mojo.Event.tap,this.loadNew.bind(this));
    
    this.controller.stopListening('SendButton',Mojo.Event.tap, this.sendDm.bind(this));
    
    this.controller.stopListening('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));
    this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.stopListening('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.stopListening('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
}