function OauthAssistant(type) {
	this.type = type || 'new';
};

OauthAssistant.prototype.setup = function() {
    
    this.stageController = this.controller.stageController;
	Weibo.Cookie.loadAccounts();

    var thisA = this;
    var attr = {
		//minFontSize:18,
		virtualpagewidth: this.controller.window.innerWidth,
		//virtualpageheight: 32 
	};

	this.controller.setupWidget('browser', attr, {});
    this.reloadModel = {
		label: $L('Reload'),
		icon: 'refresh',
		command: 'refresh'
	};
    this.stopModel = {
		label: $L('Stop'),
		icon: 'load-progress',
		command: 'stop'
	};
    this.cmdMenuModel = {
		visible: true,
		items: [{ icon: 'back', command: 'do-back'},{}, this.reloadModel]
	};
    this.controller.setupWidget(Mojo.Menu.commandMenu, {menuClass:'no-fade'}, this.cmdMenuModel);
	Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.titleChanged.bind(this));
	Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadProgress, this.loadProgress.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadStarted, this.loadStarted.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadStopped, this.loadStopped.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewLoadFailed, this.loadStopped.bind(this));
    Mojo.Event.listen(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.titleChanged.bind(this));
    
    this.controller.listen('testBtn', Mojo.Event.tap,this.loadMain.bind(this));

    Weibo.Oauth.getRequestToken(
    	function() {
    		this.url = Weibo.Oauth.getUserAuthorizationURL();
    		//thisA.controller.get('browser').innerHTML = this.url+"aaaaaaa";
    		//thisA.controller.get('browser').mojo.openURL("http://www.noteday.com");
    		thisA.openUrl(this.url);
		}, 
		function(xhr){
    		thisA.controller.get('browser').innerHTML = "Error,请重新注销后授权登录";//Object.toJSON(xhr)
    	}
    );
    
};

OauthAssistant.prototype.loadMain = function(){
	//Weibo.goHome('home');
	//this.controller.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listDefault"});
	this.controller.stageController.pushScene("listDefault");
};

OauthAssistant.prototype.openUrl = function(url){
	//this.controller.get('title').innerHTML = 'aaa';
	this.callbackURL = "http://api.t.sina.com.cn/oauth/a";
	this.controller.get('browser').mojo.openURL(url);
};

OauthAssistant.prototype.titleChanged = function(event) {
    var callbackUrl=event.url;
    var thisA = this;
    //thisA.controller.get('title').innerHTML = callbackUrl;
    
    var responseVars=callbackUrl.split("?");
    
    if( responseVars[0]==this.callbackURL+'/' || responseVars[0]==this.callbackURL){
    	//this.controller.get('title').innerHTML = "abc";
    	var nvps = responseVars[1].split('&');
    	var nvp = nvps[1];
    	var equals = nvp.indexOf('=');
    	var _value = decodeURIComponent(nvp.substring(equals + 1));
    	
    	this.controller.get('browser').hide();
		this.controller.get('tips').innerHTML = "验证登录中";

    	Weibo.Oauth.getAccessToken(_value,
    		function(uid,access_token,access_token_secret) {
				thisA.verify(uid,access_token,access_token_secret);
				thisA.controller.get('browser').hide();
				thisA.controller.get('tips').innerHTML = "验证登录中";
				thisA.controller.get('tips').show();
				//thisA.controller.get('title').innerHTML = '授权成功';//+a+'/'+b;
				//thisA.controller.stageController.pushScene("listDefault");
				//thisA.controller.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listDefault"});
			}, 
			function(xhr){
    			//thisA.controller.get('title').innerHTML = 'ERROR';
    			thisA.controller.get('tips').innerHTML = "登录失败";
    			thisA.controller.get('tips').show();
    		}
    	);
    	
    }
    
};

OauthAssistant.prototype.verify = function(uid,access_token,access_token_secret) {
	
	var url = "http://api.t.sina.com.cn/account/verify_credentials.json?";
	var _url = Weibo.Oauth.oauthUrl(url,"GET",access_token,access_token_secret);
	var thisA = this;
	var req = new Ajax.Request(_url, {
              method: "get",
              requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
					if(resp.responseJSON){
						var _rData = resp.responseJSON;
					}else{
						var _rData = JSON.parse(resp.responseText);
					}
					
					Weibo.Prefs.screen_name = _rData.screen_name;
					Weibo.Prefs.access_token = access_token;
                    Weibo.Prefs.access_token_secret = access_token_secret;
                    Weibo.Prefs.uid = uid;
					Weibo.Cookie.savePrefs();

					var account = {};
					account.access_token = access_token;
					account.access_token_secret = access_token_secret;
					account.uid = uid;
					account.screen_name = Weibo.Prefs.screen_name;

					var old_account = Weibo.Cookie.getAccountById(uid);
					if(old_account){
						Mojo.Log.info("^^^^^^ oauth_updateAccount");
						Weibo.Cookie.updateAccount(account);
					}else{
						Mojo.Log.info("^^^^^^ oauth_createAccount");
						Weibo.Cookie.createAccount(account);
					}

					thisA.controller.get('tips').innerHTML = "授权登录成功";
					//thisA.controller.get('title').innerHTML = '授权成功_OK_'+resp.responseJSON.screen_name;
					//thisA.controller.get('testBtn').show();
					//Weibo.goHome('home');
					Weibo.list = [];
					Weibo.ids = [];
					Weibo.since_id = [];
					Weibo.max_id = [];
					Weibo.gap_max_id = [];
					Weibo.markerIndex = [];
					Weibo.gapMarkerIndex = [];
					Weibo.newStatusNum = [];
					Weibo.cursor = [];
					Weibo.Cookie.loadPrefs();
					//Weibo.goHome('home');
					
					if(this.type === "add"){
						var params = {action: "refresh"};
						thisA.controller.stageController.popScenesTo("listDefault", params);
					}else{
						thisA.controller.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "listDefault"},"home",true);
					}
					
              }.bind(this),
              onFailure: function(resp){
              		//thisA.controller.get('title').innerHTML = '授权成功_Error';
              		thisA.controller.get('tips').innerHTML = "验证失败";
              }.bind(this)
        });

};

OauthAssistant.prototype.handleCommand = function(event) {
    if (event.type == Mojo.Event.command) {
		switch (event.command) {
		    case 'refresh':
				this.controller.get('tips').hide();
				this.controller.get('browser').show();
				this.controller.get('browser').mojo.reloadPage();
				break;
		    case 'stop':
				this.controller.get('browser').mojo.stopLoad();
				break;
			case "do-back":
				if(this.type === "add"){
					this.controller.stageController.popScene();
				}else{
					this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'login'});
				}
				break;
		}
    }
};

OauthAssistant.prototype.loadStarted = function(event) {
 	this.cmdMenuModel.items.pop(this.reloadModel);
 	this.cmdMenuModel.items.push(this.stopModel);
 	this.controller.modelChanged(this.cmdMenuModel);
  	this.currLoadProgressImage = 0;
};

OauthAssistant.prototype.loadStopped = function(event) {
 	this.cmdMenuModel.items.pop(this.stopModel);
 	this.cmdMenuModel.items.push(this.reloadModel);
 	this.controller.modelChanged(this.cmdMenuModel);
};

OauthAssistant.prototype.loadProgress = function(event) {
  	var percent = event.progress;
 	try {
 		if (percent > 100) {
 			percent = 100;
 		}
 		else if (percent < 0) {
 			percent = 0;
 		}

 		this.currLoadProgressPercentage = percent;

 		var image = Math.round(percent / 4.1);
 		if (image > 23) {
 			image = 23;
 		}

 		if (image < this.currLoadProgressImage) {
 			return;
 		}

 		if (this.currLoadProgressImage != image) {

 			if (this.loadProgressAnimator) {
 				this.loadProgressAnimator.cancel();
 				delete this.loadProgressAnimator;
 			}

 			var icon = this.controller.select('div.load-progress')[0];
 			if (icon) {
 				this.loadProgressAnimator = Mojo.Animation.animateValue(Mojo.Animation.queueForElement(icon),
                                            "linear", this._updateLoadProgress.bind(this), {
 					from: this.currLoadProgressImage,
 					to: image,
 					duration: 0.5
 				});
 			}
 		}
 	}
 	catch (e) {
 		Mojo.Log.logException(e, e.description);
 	}
};

OauthAssistant.prototype._updateLoadProgress = function(image) {

 	image = Math.round(image);
 	if (this.currLoadProgressImage == image) {
 		return;
 	}
 	var icon = this.controller.select('div.load-progress');
 	if (icon && icon[0]) {
 		icon[0].setStyle({'background-position': "0px -" + (image * 48) + "px"});
 	}
 	this.currLoadProgressImage = image;
};
 
OauthAssistant.prototype.activate = function(event) {

};

OauthAssistant.prototype.deactivate = function(event) {

};

OauthAssistant.prototype.cleanup = function(event) {
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadProgress, this.loadProgress);
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadStarted, this.loadStarted);
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadStopped, this.loadStopped);
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewLoadFailed, this.loadStopped);
    Mojo.Event.stopListening(this.controller.get('browser'),Mojo.Event.webViewTitleUrlChanged, this.titleChanged);
};
