function PmAssistant(name) {
	this.name = name;
	this.smileBoxOpen = false;
}

PmAssistant.prototype.setup = function() {
	thisA = this;
	this.stageController = this.controller.stageController;
	this.stageController.setWindowOrientation('up');
	
	this.controller.get("title").innerHTML = "私信给:"+this.name;

	this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'send', command: 'do-update',disabled:true}]
        	}
        );
	
	this.controller.setupWidget(
            "content",
            {
                  //hintText: $L("写点什么"),
				  multiline:true,
				  autoFocus:true,
				  //focusMode:Mojo.Widget.focusInsertMode,
				  changeOnKeyPress:true
            },
            this.textModel = {value : "",disabled: false});
            
     
     
     //this.controller.listen('back', Mojo.Event.tap, this.handleBack.bind(this));

	 this.panelsScrollerModel= {mode: "horizontal-snap"};
    
    this.horizontalScroller = this.controller.get('scrollBox');

		
	var elements = this.controller.select('.snap');
	this.panelsScrollerModel.snapElements = {x: elements, y: []};
	this.panelsScrollerModel.snapIndex = 0;
		
	this.controller.setupWidget('scrollBox', {}, this.panelsScrollerModel);
	this.controller.listen('scrollBox', Mojo.Event.propertyChanged, this.getPoints.bind(this));

	this.controller.setupWidget('post_spinner_wgt',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	 
	 //this.controller.listen(document, 'shaking', this.clearText.bindAsEventListener(this));
	 //Mojo.Event.listen(this.controller.document, "shaking", this.clearText.bindAsEventListener(this), true);
	 //Mojo.Event.listen(this.controller.get('mention_button'), Mojo.Event.tap, this.mentionClick.bind(this) );
	 Mojo.Event.listen(this.controller.get('counter_number'), Mojo.Event.tap, this.clearText.bind(this) );

	 Mojo.Event.listen(this.controller.get('smileBtn'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	 Mojo.Event.listen(this.controller.get('smile_scrim'), Mojo.Event.tap, this.closeSmileBox.bind(this) );
     
     this.controller.listen('smileBox', Mojo.Event.tap, this.smileClick.bind(this));
     this.controller.listen('content', Mojo.Event.propertyChange, this.updateCharCount.bindAsEventListener(this));

};

PmAssistant.prototype.updateCharCount = function() {
	
	var thisA = this;
	updateCharCountNow();
	function updateCharCountNow() {
		var numchars  = thisA.textModel.value.length;
		Weibo.pmText[thisA.name] = thisA.textModel.value;

		var iLength = 0; 
		for(var i = 0;i<numchars;i++){
			if ((thisA.textModel.value.charCodeAt(i) < 0) || (thisA.textModel.value.charCodeAt(i) > 255)){
				iLength=iLength+2;
			}else{
				iLength=iLength+1;
			}
		}
		var nnn = (iLength/2).ceil();
		var charleft = 140 - nnn;

		if(charleft<1){
			thisA.DisableNewButton();
			
		}else{
			if(nnn <1){
				thisA.DisableNewButton();
			}else{
				thisA.EnableNewButton();
			}
			
		}
		
		var _s = charleft.toString();
		_s = _s == '140' ? '140' : _s + '  <font color="red">×</font>';
		thisA.controller.get("counter_number").innerHTML = _s;	
	}
	
};

PmAssistant.prototype.clearText = function(event) {
	Weibo.pmText[this.name] = "";
	this.textModel.value = '';
    this.controller.modelChanged(this.textModel);
    event.stop();
    this.focusInput();
	this.controller.get("counter_number").innerHTML = '140';

	this.DisableNewButton();

};

PmAssistant.prototype.openSmileBox = function() {
	this.getCursor();
	this.smileBoxOpen = true;
	this.controller.get('smile_scrim').show();
	this.controller.get('smileBox').addClassName('smileBox_open');
};

PmAssistant.prototype.getCursor = function(command) { 
var text = this.controller.get('content');
	var _scp = 0;
	var result = text.mojo.getValue();
    if (result) {
        this.pos = text.mojo.getCursorPosition();
        if(this.pos.selectionStart == 0){
        	this.pos.selectionStart = this.pos.selectionEnd = result.length;
        }
    }else{
		this.pos = [];
	}
};

PmAssistant.prototype.smileClick = function(event){
		
	var eventSrc = event.target;
	
	var target = eventSrc.id;
	var str = eventSrc.title;
	
	var text = this.controller.get('content');
	
	if (target === "face"){
	
    	var result = text.mojo.getValue();
    	if (!result) {
        	var _value = "["+str+"]";
        	var _scp = _value.length;
        	this.pos = [];
    	}else{
    		if(!this.pos){
    			this.pos = text.mojo.getCursorPosition();
    		}
    		
    		var _value = result.substr(0, this.pos.selectionStart) + "["+str+"]" + result.substr(this.pos.selectionEnd);
    		var _scp = this.pos.selectionStart + 2 + str.length;
    	}
    	this.pos.selectionStart = this.pos.selectionEnd = _scp;
    	event.stopPropagation();
    	this.controller.get('content').mojo.setValue(_value);
    	this.controller.get('content').mojo.focus(); 
    	this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
	}
};

PmAssistant.prototype.getPoints = function(e) {
    
    this.controller.get('scroller_page_0').removeClassName('current_page');
    this.controller.get('scroller_page_1').removeClassName('current_page');
    this.controller.get('scroller_page_2').removeClassName('current_page');
    this.controller.get('scroller_page_3').removeClassName('current_page');
    this.controller.get('scroller_page_4').removeClassName('current_page');
       
    i = this.panelsScrollerModel.snapIndex;
    //this.controller.getselect('.current_page').removeClassName('current_page');
    this.controller.get('scroller_page_'+i).addClassName('current_page');
    
    
};

PmAssistant.prototype.mentionClick = function(event){
	this.stageController.pushScene("suggestionsUser");
};

PmAssistant.prototype.closeSmileBox = function(event) {
	this.smileBoxOpen = false;
	this.controller.get('smile_scrim').hide();
	this.controller.get('smileBox').removeClassName('smileBox_open');
	this.focusInput();
};

PmAssistant.prototype.focusInput = function() {

	this.pos = this.pos || [];
	var text = this.controller.get('content');
	var result = text.mojo.getValue() || '';
	if(!this.pos){
    	this.pos = text.mojo.getCursorPosition();
    	this.pos.selectionStart = this.pos.selectionEnd = result.length;
    }
	this.controller.get('content').mojo.focus();
	this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
};

PmAssistant.prototype.handleBack = function(){
	this.stageController.popScene()	
};

PmAssistant.prototype.updateSuccess = function(transport) {
    this.controller.stageController.popScene();
    Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "发送成功"}, {}, Weibo.MainStageName);
};

PmAssistant.prototype.updateFailure = function(transport) {
    this.controller.get("add-title").update("失败");
	this.okButton.mojo.deactivate();
    this.okButtonActive = false;
    this.okButtonModel.disabled = false;
    this.controller.modelChanged(this.okButtonModel);
	
};

PmAssistant.prototype.DisableNewButton = function () {
	this.subMenuModel.items[2].disabled = true;
	this.controller.modelChanged(this.subMenuModel);

};

PmAssistant.prototype.EnableNewButton = function () {
	this.subMenuModel.items[2].disabled = false;
	this.controller.modelChanged(this.subMenuModel);
};

PmAssistant.prototype.showSpinner = function () {
	this.controller.get("post_spinner").show();
	this.spinnerModel.spinning = true;
    this.controller.modelChanged(this.spinnerModel);
};

PmAssistant.prototype.hideSpinner = function () {
	this.controller.get("post_spinner").hide();
	this.spinnerModel.spinning = false;
    this.controller.modelChanged(this.spinnerModel);
};

PmAssistant.prototype.sendDm = function() {
	
	var message = this.textModel.value; 
    
    if(message){
    	this.DisableNewButton();
    	this.showSpinner();

		var url = "http://api.t.sina.com.cn/direct_messages/new.json";

		var parameters = [['screen_name', this.name],['text', message]];

		var postBody = Weibo.signRequest(url, parameters, "POST");

		var req = new Ajax.Request(url, {
			method : 'post', 
			evalJSON : 'force',
			postBody: postBody,
			contentType: 'application/x-www-form-urlencoded',
			onSuccess: this.sendSuccess.bind(this),
            onFailure: this.sendFailure.bind(this)
		});

		/*
    	var url = "http://api.t.sina.com.cn/direct_messages/new.json?screen_name="+this.name+"&text="+message;
    	var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
        	
        	var request = new Ajax.Request(url, {
				requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
				method: "post",
                evalJSON: "true",
                onSuccess: this.sendSuccess.bind(this),
                onFailure: this.sendFailure.bind(this)
            });
		*/
    }

};

PmAssistant.prototype.sendSuccess = function(transport) {
	
	var thisA = this;
	if (transport.status == 200) {
		//this.messageTextWidgetModel.value = '';
    	//this.controller.modelChanged(this.messageTextWidgetModel);
    	
    	//this.controller.window.setTimeout(function(){thisA.loadNew()}, 1*1000);
    	//this.loadNew();
    	Weibo.pmText[thisA.name] = '';
    	this.stageController.popScene();
    	
		Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Success"}, {}, Weibo.MainStageName);

	}else{
		this.sendFailure();
	}
};

PmAssistant.prototype.sendFailure = function(transport) {
    //Mojo.Log.info("^^^^^^ "+Object.toJSON(transport));
    Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Failure"}, {}, Weibo.MainStageName);
    this.EnableNewButton();
    this.hideSpinner();

	
};

PmAssistant.prototype.loadFailure = function(transport) {
};

PmAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-update":
				this.sendDm();
				//this.DisableNewButton();
				break;
			case "do-back":
            	this.stageController.popScene();
            	break;
		}
	}else if (event.type == Mojo.Event.back) {
		if(this.smileBoxOpen == true){
			event.stop();
        	//event.stopPropagation();
			this.closeSmileBox();
		}
	}
};

PmAssistant.prototype.activate = function(event) {
	Weibo.Control.setFullScreen(this.controller);

	if(Weibo.pmText[this.name]){
		this.textModel.value = Weibo.pmText[this.name];
		this.controller.modelChanged(this.textModel);
		this.EnableNewButton();
		this.updateCharCount();
		var str_len = Weibo.pmText[this.name].length;
		this.controller.get('content').mojo.focus(); 
		this.controller.get('content').mojo.setCursorPosition(str_len,str_len);
	}else{
		Weibo.pmText[this.name] = "";
	}
};

PmAssistant.prototype.deactivate = function(event) {

};

PmAssistant.prototype.cleanup = function(event) {
	Mojo.Event.stopListening(this.controller.get('smileBtn'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	Mojo.Event.stopListening(this.controller.get('smile_scrim'), Mojo.Event.tap, this.closeSmileBox.bind(this) );
     
	Mojo.Event.stopListening(this.controller.get('counter_number'), Mojo.Event.tap, this.clearText.bind(this) );

	this.controller.stopListening('smileBox', Mojo.Event.tap, this.smileClick.bind(this));
	this.controller.stopListening('content', Mojo.Event.propertyChange, this.updateCharCount.bindAsEventListener(this));
};
