function SogouMapAssistant(lat,long) {
	this.lat=lat;
	this.long=long;
}

SogouMapAssistant.prototype.setup = function() {
     this.spinnerSAttrs = {
		spinnerSize: Mojo.Widget.spinnerLarge,
		modelProperty: 'spinning'
	};
	
	this.spinnerModel = {
		spinning: false
	};
	
	this.controller.setupWidget('spinnerDiv', this.spinnerSAttrs, this.spinnerModel);

	this.Spinner(this.spinnerModel,false);
	
 	this.showMap(this.lat,this.long);
};

SogouMapAssistant.prototype.showMap = function(lat,lon){

	var myLatlng = new sogou.maps.LatLng(lat,lon);
	
	if(this.marker){
		this.marker.setMap(null);
	}
 
	var MyOptions  = {
		zoom: 14,
		center: myLatlng,
		//draggable: true,
		mapControlType:3,
		mapTypeId: sogou.maps.MapTypeId.ROADMAP
	};

	this.map = new sogou.maps.Map(this.controller.get("map_canvas"), MyOptions);

	this.marker = new sogou.maps.Marker({'position': myLatlng,map: this.map});
	
};

SogouMapAssistant.prototype.Spinner = function(model, flag){
	model.spinning = flag;
	this.controller.modelChanged(model);
};

SogouMapAssistant.prototype.aboutToActivate = function(callback) {
	callback.defer();
};

SogouMapAssistant.prototype.hideTip = function() {
	this.controller.get("spinner_div").hide();
	this.Spinner(this.spinnerModel,false);
};

SogouMapAssistant.prototype.activate = function(event) {

};

SogouMapAssistant.prototype.deactivate = function(event) {

};

SogouMapAssistant.prototype.cleanup = function(event) {

};
