
function SuggestionsUserAssistant(type,pos) {
	this.type = type || 'mention';
	this.pos = pos;
};

SuggestionsUserAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	
	var _icon = this.type === 'mention' ? 'mention' : 'dm';
	this.controller.get("search-bar-select").innerHTML = '<img src="images/'+_icon+'.png" />';
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
	
	this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{}]
        	}
        );
	
	this.controller.setupWidget(
            "search_field",
            this.textType = {
                hintText: 'Enter Search item',
				//textFieldName:	'name', 
				//modelProperty:		'originalValue', 
				multiline:		false,
				disabledProperty: 'disabled',
				autoFocus:  true,
				focus: 		true, 
				modifierState: 	Mojo.Widget.capsLock,
				limitResize: 	true, 
				holdToEnable:  false, 
				focusMode:		Mojo.Widget.focusAppendMode,
				changeOnKeyPress: true,
				textReplacement: false,
				enterSubmits: false,
				requiresEnterKey: false
            },
             this.textModel = {value : ''});
	
	this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/suggestionUserItem",
            listTemplate: "tpl/listTemplate",
            renderLimit: 100,
        },    
        this.statusModel = {
            items: []
        }
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	
	this.handleKeyDown = this.handleKeyDown.bindAsEventListener(this);
	Mojo.Event.listen(this.controller.document, "keyup", this.handleKeyDown, true);
	
	//this.controller.listen(this.controller.sceneElement, Mojo.Event.keyup, this.handleKeyDown.bind(this));
    
    this.controller.listen('search_btn', Mojo.Event.tap,this.submitSearch.bind(this));

    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.itemClick.bindAsEventListener(this));
    
    this.controller.listen("searchUser", Mojo.Event.tap,this.searchUser.bindAsEventListener(this));
    
    
	
};

SuggestionsUserAssistant.prototype.handleKeyDown = function(e){
    	
	if (Mojo.Char.isEnterKey(e.keyCode)){
		var keyword = this.textModel.value; 
		Mojo.Log.info("^^^^^^#skey"+this.textModel.value);
    	this.textModel.value = keyword;
    	this.controller.modelChanged(this.textModel);
    	
	 	if(keyword){
	 		this.searchWords(keyword);
	 	}
	 } 
};

SuggestionsUserAssistant.prototype.searchUser = function() {
    
    var keyword = this.textModel.value; 
		 
	this.stageController.pushScene("search",keyword,{type:"user",operate:"mention",pos:this.pos});

};

SuggestionsUserAssistant.prototype.submitSearch = function() {
    
    var keyword = this.textModel.value; 
		 
    this.textModel.value = keyword;
    this.controller.modelChanged(this.textModel);

	Mojo.Log.info("^^^^^^#key"+keyword);
	if(keyword){
		this.searchWords(keyword);
	}else{

	}

};

SuggestionsUserAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

SuggestionsUserAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
};

SuggestionsUserAssistant.prototype.searchWords = function(k) {
	
	if(k){
		this.gotItem(k);
	}

};

SuggestionsUserAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

SuggestionsUserAssistant.prototype.gotItem = function(k){
	this.loadTip(true);
	var thisA = this;
	this.scrollToTop();
	this.controller.get('result').hide();
	var url = "http://api.t.sina.com.cn/search/suggestions/at_users.json?q="+k+"&type=0&range=2&count=30";
	//var oHeader = Weibo.Oauth.oauthHeader(url,"GET");
	var _url = Weibo.Oauth.oauthUrl(url,"GET");
	
	var req = new Ajax.Request(_url, {
              method: "get",
			  requestHeaders:['Accept-Encoding','gzip,deflate'],
			  //requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){
              	Mojo.Log.info("^^^^^^#gotItem_success_"+resp.status);
              	if(resp.responseJSON && resp.responseJSON.length > 0){
              		Weibo.list['suggestionsUser'] = resp.responseJSON;
              		thisA.statusModel.items = resp.responseJSON;
					thisA.controller.modelChanged(thisA.statusModel);
				}else{
					thisA.statusModel.items = [];
					thisA.controller.modelChanged(thisA.statusModel);
					thisA.controller.get('result').show();
				}
				thisA.loadTip(false);
              }.bind(this),
              onFailure: function(resp){
              	thisA.loadTip(false);
              	Mojo.Log.info("^^^^^^#gotItem_failure_"+resp.status);
              }
         });
};

SuggestionsUserAssistant.prototype.itemClick = function(event){
	var str = "@"+this.statusModel.items[event.index].nickname+" ";

	var params = {action: "insert", text: str,pos:this.pos};

	this.stageController.popScenesTo("update", params);
					
	//this.stageController.popScene("update");
};


SuggestionsUserAssistant.prototype.refresh = function(){

    
};


SuggestionsUserAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

SuggestionsUserAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
	this.scroller.mojo.scrollTo(0, -1 * this.controller.get('feedListWgt').getHeight());
};

SuggestionsUserAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-back":
				this.controller.stageController.popScene();
				break;
		}
	}
};

SuggestionsUserAssistant.prototype.activate = function(event) {
	if(Weibo.list['suggestionsUser']){
        this.statusModel.items = Weibo.list['suggestionsUser'];
		this.controller.modelChanged(this.statusModel);
	}
	Weibo.Control.setFullScreen(this.controller);
};

SuggestionsUserAssistant.prototype.deactivate = function(event) {
	Mojo.Event.stopListening(this.controller.document, "keyup", this.handleKeyDown, true);
};

SuggestionsUserAssistant.prototype.cleanup = function(event) {
	//this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.viewInfo.bindAsEventListener(this));
	Mojo.Event.stopListening(this.controller.document, "keyup", this.handleKeyDown, true);
	
	//this.controller.listen(this.controller.sceneElement, Mojo.Event.keyup, this.handleKeyDown.bind(this));
    
    this.controller.stopListening('search_btn', Mojo.Event.tap,this.submitSearch.bind(this));

    this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.itemClick.bindAsEventListener(this));
    
    this.controller.stopListening("searchUser", Mojo.Event.tap,this.searchUser.bindAsEventListener(this));
}