function TalkAssistant(sceneAssistant,onSuccess,onFailure) {
    this.sceneAssistant = sceneAssistant;
    this.onSuccess = onSuccess;
    this.onFailure = onFailure;
};
    
TalkAssistant.prototype.setup = function(widget) {
    this.widget = widget;
  
    this.okButtonModel = {label: $L("说完了"), disabled: false};
    this.sceneAssistant.setupWidget("okButton", {type: Mojo.Widget.activityButton},this.okButtonModel);
    this.okButtonActive = false;
    this.okButton = this.sceneAssistant.get("okButton");
    this.sayingHandler = this.endTalk.bindAsEventListener(this);
    this.sceneAssistant.listen("okButton", Mojo.Event.tap,this.sayingHandler);
      
    this.cancelButtonModel = {label: $L("取消"), disabled: false};
    this.sceneAssistant.setupWidget("cancelButton", {type: Mojo.Widget.defaultButton},this.cancelButtonModel);
    this.sceneAssistant.listen("cancelButton", Mojo.Event.tap,this.exitTalk.bind(this));
};

TalkAssistant.prototype.endTalk = function() {
	this.okButton.mojo.activate();
    this.okButtonActive = true;
	this.okButtonModel.label = "识别中";
    this.okButtonModel.disabled = true;
    this.sceneAssistant.modelChanged(this.okButtonModel);

    var t = this;
    setTimeout(function(){
	   Weibo.Voice.xfRecEnd(t.widget.mojo,t.onSuccess,t.onFailure);
    },500);
};

TalkAssistant.prototype.exitTalk = function() {
	Weibo.Voice.xfRecStop();
	this.widget.mojo.close();
};

TalkAssistant.prototype.activate = function() {

};

TalkAssistant.prototype.deactivate = function() {

};

TalkAssistant.prototype.cleanup = function() {
    this.sceneAssistant.stopListening("okButton", Mojo.Event.tap,this.sayingHandler);
    this.sceneAssistant.stopListening("cancelButton", Mojo.Event.tap,this.widget.mojo.close);

};