function UpdateAssistant(data) {
	this.status = data[0].status || [];
	this.oldText = data[0].oldText || "";
	this.inputImg = data[0].inputImg || "";
	this.cameraImg = data[0].cameraImg || "";
	if(data[0].status){
		this.id = data[0].id || data[0].status.id;
		this.oldText = data[0].status.oldText || "";
	}
	this.title = data[0].title;
	this.titleName = data[0].titleName;
	
	this.cid = data[0].cid;
	this.reContent = data[0].reContent || "";
	
	this.postSet = data[0].postSet;
	
	this.openCamera = data[0].camera || false;

	//this.auth = auth;
	this.imgurl = '';
	this.orange = false;
	this.latitude = '';
    this.longitude = '';
    
    this.smileBoxOpen = false;

    this.voice = true;
};

UpdateAssistant.prototype.setup = function() {
	
	//var thisA = this;
	
	if(this.openCamera === true){
    	this.camClick();
    	//var thisA = this;
    	//setTimeout(function(){thisA.camClick()}, 20);
    }
	
	this.stageController = this.controller.stageController;
	Weibo.Control.setTheme(this.controller);
	
	this.controller.stageController.setWindowOrientation('up');
	
	this.controller.get("title").update(this.titleName);
	
	
	this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'send', command: 'do-update',disabled:true}]
        	}
        );

	this.controller.setupWidget(
            "content",
            this.textType = {
                  //hintText: $L("写点什么"),
				  multiline:true,
				  autoFocus:true,
				  focus:true,
				  focusMode:Mojo.Widget.focusAppendMode,
				  //emoticons:true,
				  changeOnKeyPress:true
            },
            this.textModel = {value : this.oldText,disabled: false});      
	
	this.controller.setupWidget("checkItem_1_value",
         this.attributes = {
             trueValue: "true",
             falseValue: "false" 
         },
         this.checkItem_1_Model = {
             value: false,
             disabled: false
         });
     
     this.controller.setupWidget("checkItem_2_value",
         this.attributes = {
             trueValue: "true",
             falseValue: "false" 
         },
         this.checkItem_2_Model = {
             value: false,
             disabled: false
         });
	
	
	if(this.title === "comment" || this.title === 'reply'){
		 
         this.controller.get("checkBox").show();
         this.controller.get("addImgae").hide();
         this.controller.get("miniOperateBox").show();
         
         this.textModel.value = this.reContent;
    	 this.controller.modelChanged(this.textModel);
		 
		 this.controller.get("checkItem_1_text").innerHTML = "同时转发到我的微博";
         
         if(this.status.retweeted_status){
         	this.controller.get("checkItem_2").show();
         	this.controller.get("checkItem_2_text").innerHTML = "同时评论给原文作者 <a href='#'>"+this.status.retweeted_status.user.screen_name+"</a>";
         }
         
         var _user = this.status.user.screen_name;
         var _text = this.status.text;
         
         this.controller.get("showContent").innerHTML = '<a href="#">@'+_user+'</a>：'+_text;
         
	}else if(this.title === "repost"){

         this.EnableNewButton();
         this.controller.get("checkBox").show();
         this.controller.get("addImgae").hide();
         this.controller.get("miniOperateBox").show();
         
         this.controller.get("checkItem_1_text").innerHTML = "同时评论给 <a href='#'>"+this.status.user.screen_name+"<a/>";
         
         if(this.status.retweeted_status){
         	this.controller.get("checkItem_2").show();
         	this.controller.get("checkItem_2_text").innerHTML = "同时评论给原文作者 <a href='#'>"+this.status.retweeted_status.user.screen_name+"</a>";
         }

         var _user = this.status.retweeted_status ? this.status.retweeted_status.user.screen_name : this.status.user.screen_name;
         var _text = this.status.retweeted_status ? this.status.retweeted_status.text : this.status.text;
         
         this.controller.get("showContent").innerHTML = '<a href="#">@'+_user+'</a>：'+_text;

         
	}else{
		this.controller.get("checkBox").hide();
        this.controller.get("addImgae").show();
        this.controller.get("miniOperateBox").hide();
	}
	 
	this.panelsScrollerModel= {mode: "horizontal-snap"};
    this.horizontalScroller = this.controller.get('scrollBox');

		
	var elements = this.controller.select('.snap');
	this.panelsScrollerModel.snapElements = {x: elements, y: []};
	this.panelsScrollerModel.snapIndex = 0;
		
	this.controller.setupWidget('scrollBox', {}, this.panelsScrollerModel);
	this.controller.listen('scrollBox', Mojo.Event.propertyChanged, this.getPoints.bind(this));

	this.controller.setupWidget('post_spinner_wgt',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	
	if(this.inputImg){
		var _preTitle = this.inputImg.substr(0,4);
		if(_preTitle == 'http'){
			this.imgDownload(this.inputImg);
		}else{
			this.selectCam(this.inputImg);
		}
		
	}

	var phoneModelName = Mojo.Environment.DeviceInfo.modelName;
	if(phoneModelName == 'Pixi'){
		this.controller.get('mic_button').hide();
	}else{
		this.controller.get('mic_button').show();
		Weibo.Voice.xfInit(this.noVoice.bind(this));
	}

	 //this.controller.listen(document, 'shaking', this.clearText.bindAsEventListener(this));
	 //Mojo.Event.listen(this.controller.document, "shaking", this.clearText.bindAsEventListener(this), true);
	 Mojo.Event.listen(this.controller.get('counter_number'), Mojo.Event.tap, this.clearText.bind(this) );
	 Mojo.Event.listen(this.controller.get('location_button'), Mojo.Event.tap, this.updateLocation.bind(this) );
	 
	 Mojo.Event.listen(this.controller.get('mic_button'), Mojo.Event.tap, this.startTalk.bind(this) );

	 Mojo.Event.listen(this.controller.get('topic_button'), Mojo.Event.tap, this.topicClick.bind(this) );
	 Mojo.Event.listen(this.controller.get('mention_button'), Mojo.Event.tap, this.mentionClick.bind(this) );
	 Mojo.Event.listen(this.controller.get('mention_button_mini'), Mojo.Event.tap, this.mentionClick.bind(this) );

	 Mojo.Event.listen(this.controller.get('smileBtn'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	 Mojo.Event.listen(this.controller.get('smileBtn_mini'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	 Mojo.Event.listen(this.controller.get('smile_scrim'), Mojo.Event.tap, this.closeSmileBox.bind(this) );

	 this.controller.listen('delBtn', Mojo.Event.tap, this.delImage.bind(this));
	 this.controller.listen('content', Mojo.Event.propertyChange, this.updateCharCount.bindAsEventListener(this));
	 //this.updateHandler = this.updateStatus.bind(this);
	 
	 this.controller.listen('img_button', Mojo.Event.tap, this.selectImgMenu.bind(this));
	 
	 this.controller.listen('selectImg', Mojo.Event.tap, this.ajustImg.bind(this));
     this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
     this.controller.listen(this.controller.sceneElement, Mojo.Event.keyup, this.handleKeyUpEvent.bind(this));
     
     this.controller.listen('smileBox', Mojo.Event.tap, this.smileClick.bind(this));
     
     this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    
};

UpdateAssistant.prototype.noVoice = function(event) {
	this.voice = false;
	//this.controller.get('mic_button').hide();
};

UpdateAssistant.prototype.ajustImg = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
    	onChoose:  this.gotAjustImg,
    	//toggleCmd: this.title,
        placeNear: findPlace,
        items: [
        		{label:"调整图片",command:"ajust"},
        		{label:"删除图片",command:"delete"}
        	]
    });
	//this.stageController.pushScene({name:"ajust", disableSceneScroller: true},this.imgurl);
	//this.stageController.pushScene("ajust",this.imgurl);
};

UpdateAssistant.prototype.gotAjustImg = function(command) {
	 if(command){
	 	if(command === "ajust"){
	 		//this.stageController.pushScene("ajust",this.imgurl);
			this.stageController.pushScene("imgEffect",this.imgurl);
	 	}else{
	 		this.delImage();
	 	}
	 }
};

UpdateAssistant.prototype.getPoints = function(e) {
    
    this.controller.get('scroller_page_0').removeClassName('current_page');
    this.controller.get('scroller_page_1').removeClassName('current_page');
    this.controller.get('scroller_page_2').removeClassName('current_page');
    this.controller.get('scroller_page_3').removeClassName('current_page');
    this.controller.get('scroller_page_4').removeClassName('current_page');
       
    var i = this.panelsScrollerModel.snapIndex;
    //this.controller.getselect('.current_page').removeClassName('current_page');
    this.controller.get('scroller_page_'+i).addClassName('current_page');
    
};

UpdateAssistant.prototype.selectImgMenu = function(event) {
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
    	onChoose:  this.gotImgType,
    	toggleCmd: this.title,
        placeNear: findPlace,
        items: [
        		{label:"图册",command:"photos"},
        		{label:"相机",command:"camera"}
        	]
    });
};

UpdateAssistant.prototype.gotImgType = function(command) {
	 if(command){
	 	if(command === "photos"){
	 		this.selectImg();
	 	}else{
	 		this.camClick();
	 	}
	 }
};


UpdateAssistant.prototype.openSmileBox = function() {
	this.pos = this.getCursor();
	this.smileBoxOpen = true;
	this.controller.get('smile_scrim').show();
	this.controller.get('smileBox').addClassName('smileBox_open');
};

UpdateAssistant.prototype.closeSmileBox = function(event) {
	this.smileBoxOpen = false;
	this.controller.get('smile_scrim').hide();
	this.controller.get('smileBox').removeClassName('smileBox_open');
	this.focusInput();
};

UpdateAssistant.prototype.focusInput = function() {

	this.pos = this.pos || [];
	var text = this.controller.get('content');
	var result = text.mojo.getValue() || '';
	if(!this.pos){
    	this.pos = text.mojo.getCursorPosition();
    	this.pos.selectionStart = this.pos.selectionEnd = result.length;
    }
	this.controller.get('content').mojo.focus();
	this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
};

UpdateAssistant.prototype.clearText = function(event) {
	Weibo.updateText[this.title] = "";
	this.textModel.value = '';
    this.controller.modelChanged(this.textModel);
    event.stop();
    this.focusInput();
	this.controller.get("counter_number").innerHTML = '140';
	if(this.imgurl == ''){
		this.DisableNewButton();
	}
};

UpdateAssistant.prototype.handleKeyDownEvent = function(event) {
	if(this.orange == true && event.originalEvent.keyCode == 13 ){
		this.updateStatus();
		event.originalEvent.returnValue = false;
	}
	if(event.originalEvent.keyCode == 129) {
        this.orange = true;
    }
	//this.controller.get("title").innerHTML = event.originalEvent.keyCode;
};

UpdateAssistant.prototype.handleKeyUpEvent = function(event) {
	if(event.originalEvent.keyCode == 129) {
        this.orange = false;
    }
};

UpdateAssistant.prototype.selectImg = function(event){
	var thisA = this;
	var params = {
			kinds: ['image'],
			onSelect: function(file){
				thisA.controller.get("img").src = file.fullPath;
				thisA.controller.get('selectImg').show();
				thisA.imgurl = file.fullPath;
				thisA.mediaType = file.attachmentType;
				thisA.EnableNewButton();
			}
		};
	Mojo.FilePicker.pickFile(params, this.stageController);
};

UpdateAssistant.prototype.delImage = function (event){
	//this.controller.get('selectImg').innerHTML = '';
	//this.controller.get('delBtn').innerHTML = '';
	
	this.controller.get("img").src = '';
	this.controller.get('selectImg').hide();
	
	this.imgurl = '';
	this.updateCharCount();
};

UpdateAssistant.prototype.camClick = function(event){
    var nowtime = new Date(); 
	var longtime =nowtime.getTime();
	
    this.camfilename = "/media/internal/download/temp_"+longtime+".jpg";
    this.controller.stageController.pushScene({
            appId: 'com.palm.app.camera',
            name: 'capture'
        }, {
            sublaunch: true,
            filename: this.camfilename
        });
   
};

UpdateAssistant.prototype.updateStatus = function() {
	Mojo.Log.info("^^^^^^ update_updateStatus#"+this.title);
	var thisA = this;

	this.DisableNewButton();
	this.showSpinner();

	var content = this.textModel.value; 
		 
    this.textModel.value = content;
    this.controller.modelChanged(this.textModel);
    
    this.checkItem_1_value = this.checkItem_1_Model.value === "true" ? 1 : 0;
    this.checkItem_2_value = this.checkItem_2_Model.value === "true" ? 2 : 0;
    
	if(this.title === "reply"){
		//content = encodeURIComponent(content);
		var url = "http://api.t.sina.com.cn/statuses/reply.json";
		var parameters = [['id', this.id],['cid', this.cid],['comment', content],['without_mention', '1']];

	}else if(this.title === "comment"){
		//content = encodeURIComponent(content);
		var checkItem_2_value = this.checkItem_2_Model.value === "true" ? 1 : 0;
		var url = "http://api.t.sina.com.cn/statuses/comment.json";
		var parameters = [['id', this.id],['comment', content],['without_mention', '1'],['comment_ori', checkItem_2_value]];
		
	}else if(this.title === "repost"){
		if(!content){
			content = "转发微博";
        }else{
        	//content = encodeURIComponent(content);
        }
		
		var _is_comment = this.checkItem_1_value + this.checkItem_2_value;
		var url = "http://api.t.sina.com.cn/statuses/repost.json?id="+this.id+"&status="+content+"&is_comment="+_is_comment;
		var parameters = [['id', this.id],['status', content],['is_comment', _is_comment]];

		
	}else{
		if(this.latitude){
			var _location = '&lat='+this.latitude+'&long='+this.longitude;
			var parameters = [['status', content],['lat', this.latitude],['long', this.longitude]];
			
		}else{
			var _location = '';
			var parameters = [['status', content]];
			
		}
		//content = encodeURIComponent(content);
        var url = "http://api.t.sina.com.cn/statuses/update.json";
	}
        
	if(this.imgurl){
		//Mojo.Log.info("^^^^^^#"+this.imgurl);
		if(!content){
			content = "分享图片";
        }else{
        	//content = encodeURIComponent(content);
        }
        
        if(this.latitude){
        	var postBody = [{'key': 'status', 'data': content},{'key': 'lat', 'data': this.latitude},{'key': 'long', 'data': this.longitude},];
        }else{
        	var postBody = [{'key': 'status', 'data': content}];
        } 
        	
		var url = "http://api.t.sina.com.cn/statuses/upload.json?status="+content+_location;
		
		var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
		var thisA = this;
				
		this.controller.serviceRequest("palm://com.palm.downloadmanager", {
			method: "upload",
			parameters: {
				"customHttpHeaders": ["Authorization:"+oHeader],
				"url": "http://api.t.sina.com.cn/statuses/upload.json",
				"fileName": this.imgurl,
				"fileLabel": "pic",
				"contentType": this.mediaType,
				"postParameters": postBody,
				"subscribe":true
			},
			onSuccess : function (resp){
				//if(resp.httpCode == 200){
				if (!resp.completed && resp.subscribed) {
					return;
					}

					if(resp.httpCode != 200){
					thisA.updateFailure(resp);
					//return;
					}else{
						Weibo.updateText[this.title] = "";
						//this.controller.stageController.popScene();
						this.backMain();
					Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Success"}, {}, Weibo.MainStageName);
					}
				//this.controller.get("checkInfo").update(resp.httpCode+'|' + Object.toJSON(resp));
				
			}.bind(this),		
			onFailure : this.updateFailure.bind(this)
		});
		
	}else{
        if(!content && this.title != "repost"){
			this.updateFailure();
        }else{
        	if(this.title === 'update'){
        		//content = encodeURIComponent(content);
        	}

			var postBody = Weibo.signRequest(url, parameters, "POST");

			var req = new Ajax.Request(url, {
				method : 'post', 
				evalJSON : 'force',
				postBody: postBody,
				contentType: 'application/x-www-form-urlencoded',
				onSuccess: this.updateSuccess.bind(this),
                onFailure: this.updateFailure.bind(this)
			});

        }
        
	}

};

UpdateAssistant.prototype.updateSuccess = function(transport) {
	
	var thisA = this;
	if (transport.status == 200) {
		Weibo.updateText[this.title] = "";
		var returnList = transport.responseJSON;
		
		if(this.title === "comment" || this.title === "reply"){

			var is_repost = this.checkItem_1_value;//this.checkItem_1_Model.value;

			if(is_repost === 1){
				var content = returnList.text+this.oldText;

        		var url = "http://api.t.sina.com.cn/statuses/repost.json?id="+returnList.status.id+"&status="+content;

				var parameters = [['id', returnList.status.id],['status', content]];

				var postBody = Weibo.signRequest(url, parameters, "POST");

				var req = new Ajax.Request(url, {
					method : 'post', 
					evalJSON : 'force',
					postBody: postBody,
					contentType: 'application/x-www-form-urlencoded',
					onSuccess: function(){
						//Mojo.Log.info('>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>cr3');
					},
				});
				
			}
		}
		
		//this.controller.stageController.popScene();
		
		Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Success"}, {}, Weibo.MainStageName);
		this.backMain();

	}else{
		this.updateFailure();
	}
};

UpdateAssistant.prototype.updateFailure = function(transport) {
    Mojo.Log.info("^^^^^^F: "+Object.toJSON(transport));
    //this.controller.get("add-title").update("失败");
    Mojo.Controller.getAppController().showBanner({icon:"sailor.png",messageText: "Send Failure"}, {}, Weibo.MainStageName);
    this.EnableNewButton();
    this.hideSpinner();
	
};


UpdateAssistant.prototype.DisableNewButton = function () {
	//if(this.title != "repost"){
		this.subMenuModel.items[2].disabled = true;
		this.controller.modelChanged(this.subMenuModel);
	//}

};

UpdateAssistant.prototype.EnableNewButton = function () {
	this.subMenuModel.items[2].disabled = false;
	this.controller.modelChanged(this.subMenuModel);
};

UpdateAssistant.prototype.showSpinner = function () {
	this.controller.get("post_spinner").show();
	this.spinnerModel.spinning = true;
    this.controller.modelChanged(this.spinnerModel);
};

UpdateAssistant.prototype.hideSpinner = function () {
	this.controller.get("post_spinner").hide();
	this.spinnerModel.spinning = false;
    this.controller.modelChanged(this.spinnerModel);
};


UpdateAssistant.prototype.loadFailure = function(transport) {

};

UpdateAssistant.prototype.updateCharCount = function() {
	
	var thisA = this;
	updateCharCountNow();
	function updateCharCountNow() {
		var numchars  = thisA.textModel.value.length;
		Weibo.updateText[thisA.title] = thisA.textModel.value;
		var iLength = 0; 
		for(var i = 0;i<numchars;i++){
			if ((thisA.textModel.value.charCodeAt(i) < 0) || (thisA.textModel.value.charCodeAt(i) > 255)){
				iLength=iLength+2;
			}else{
				iLength=iLength+1;
			}
		}
		var nnn = (iLength/2).ceil();
		var charleft = 140 - nnn;

		if(charleft<1){
			thisA.DisableNewButton();
			/*
			thisA.textModel.disabled = true;
			thisA.controller.modelChanged(thisA.textModel);
			thisA.controller.showAlertDialog({
							onChoose: function(value) {
								thisA.textModel.disabled = false;
								thisA.controller.modelChanged(thisA.textModel);
							},
    						title: $L("字数太多了！"),
    						choices:[{label:$L("知道了"), value:"OK"}]
						});
						*/
		}else{
			if(nnn <1){
				thisA.DisableNewButton();
			}else{
				thisA.EnableNewButton();
			}
			
		}
		var _s = charleft.toString();
		_s = _s == '140' ? '140' : _s + '  <font color="red">×</font>';
		thisA.controller.get("counter_number").innerHTML = _s;		
	};
	
};


UpdateAssistant.prototype.selectCam = function(file){
	//this.controller.get('selectImg').innerHTML = '<img src="'+file+'" height="25" width="25" />';
	//this.controller.get('delBtn').innerHTML = '<a href="#" id="delText">删除</a> &nbsp; &nbsp; ';
	
	this.controller.get("img").src = file;
	this.controller.get('selectImg').show();
	
	this.imgurl = file;
	this.mediaType = "image";
	var thisA = this;
	this.EnableNewButton();
	
	if(Weibo.Prefs.ajustCamera === true){
		setTimeout(function(){thisA.stageController.pushScene("ajust",thisA.imgurl)}, 100);
	}
};


UpdateAssistant.prototype.smileClick = function(event){
		
	var eventSrc = event.target;
	
	var target = eventSrc.id;
	var str = eventSrc.title;
	
	var text = this.controller.get('content');
	
	if (target === "face"){
	
    	var result = text.mojo.getValue();
    	if (!result) {
        	var _value = "["+str+"]";
        	var _scp = _value.length;
        	this.pos = [];
    	}else{
    		if(!this.pos){
    			this.pos = text.mojo.getCursorPosition();
    		}
    		
    		var _value = result.substr(0, this.pos.selectionStart) + "["+str+"]" + result.substr(this.pos.selectionEnd);
    		var _scp = this.pos.selectionStart + 2 + str.length;
    	}
    	this.pos.selectionStart = this.pos.selectionEnd = _scp;
    	event.stopPropagation();
    	this.controller.get('content').mojo.setValue(_value);
    	this.controller.get('content').mojo.focus(); 
    	this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
	}
};

UpdateAssistant.prototype.topicClick = function(event){

	var text = this.controller.get('content');
	this.pos = this.getCursor();

	var result = text.mojo.getValue();
    if (!result) {
        var _value = "##";
        var _scp = 1;
    }else{	
    	if(!this.pos){
    		this.pos = text.mojo.getCursorPosition();
		}
		var _value = result.substr(0, this.pos.selectionStart) + "##" + result.substr(this.pos.selectionEnd);
    	var _scp = this.pos.selectionStart + 1;
    }
    this.pos.selectionStart = this.pos.selectionEnd = _scp;
    event.stopPropagation();
    this.controller.get('content').mojo.setValue(_value);
    this.controller.get('content').mojo.focus(); 
    this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
	
};

UpdateAssistant.prototype.insertText = function(str,pos){

	var text = this.controller.get('content');
	//var pos = this.getCursor();

	var result = text.mojo.getValue();
    if (!result) {
        var _value = str;
        var _scp = str.length;
    }else{	
    	
		var _value = result.substr(0, pos.selectionStart) + str + result.substr(pos.selectionEnd);
    	var _scp = pos.selectionStart + str.length;
    }
    pos.selectionStart = pos.selectionEnd = _scp;
    //event.stopPropagation();
    this.controller.get('content').mojo.setValue(_value);
    this.controller.get('content').mojo.focus(); 
    this.controller.get('content').mojo.setCursorPosition(pos.selectionStart,pos.selectionEnd);
	
};

UpdateAssistant.prototype.mentionClick = function(event){
	//var text = this.controller.get('content');
	var pos = this.getCursor();
	
	this.stageController.pushScene("suggestionsUser","mention",pos);
};

UpdateAssistant.prototype.getCursor = function(command) { 
	var text = this.controller.get('content');
	var pos = [];
	var result = text.mojo.getValue();
    if (result) {
        pos = text.mojo.getCursorPosition();
        if(pos.selectionStart == 0){
        	//pos.selectionStart = pos.selectionEnd = result.length;
        }
    }
    return pos;
};

UpdateAssistant.prototype.backMain = function(command) {    
	var app_controller = Mojo.Controller.getAppController();
	var stage_controller = app_controller.getStageController(Weibo.MainStageName);
	var top_scene = stage_controller.getScenes();
	//Mojo.Controller.getAppController().showBanner({"messageText": top_scene[0].sceneName}, {}, Weibo.MainStageName);
	
	if(top_scene[0].sceneName != "listDefault"){
		this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listDefault'});
	}else{
		this.stageController.popScene();
	}
	
};

UpdateAssistant.prototype.updateLocation = function() {
    Mojo.Log.info("^^^^^^ UpdateAssistant#UpdateLocation");
    
    //this.updateLocationIndicator.show();
    this.controller.get('readable_location').show();
    this.controller.get('readable_location').innerHTML = '正在获取GPS信息';
    
    this.controller.serviceRequest('palm://com.palm.location', {
    	method:"getCurrentPosition",
    	parameters:{accuracy:1, maximumAge:0, responseTime:1},
    	onSuccess: this.updateLocationSuccess.bind(this),
    	onFailure: this.updateLocationFailure.bind(this)
    });
};

UpdateAssistant.prototype.updateLocationSuccess = function(response) {
    Mojo.Log.info("^^^^^^ UpdateAssistant#UpdateLocationSuccess");
    
    this.latitude = response.latitude;
    this.longitude = response.longitude;
    
    //this.updateLocationIndicator.hide();
    this.updateReadableLocation();
};

UpdateAssistant.prototype.updateLocationFailure = function(error) {
    Mojo.Log.info("^^^^^^ PostAssistant#UpdateLocationFailure");
    this.controller.get('readable_location').innerHTML = '获取GPS信息失败';
    //this.updateLocationIndicator.hide();
    
    //Mojo.Log.error(Object.toJSON(error));
    
    if(error.errorCode == 5){
    	Mojo.Controller.errorDialog("Location services on the device are 'OFF', turn location services 'ON' and try again", this.controller.window);
    }
};

UpdateAssistant.prototype.updateReadableLocation = function() {
    Mojo.Log.info("^^^^^^ UpdateAssistant#UpdateReadableLocation");
    this.controller.get('readable_location').innerHTML = '已获取GPS位置,正在获取位置信息';
    this.controller.serviceRequest('palm://com.palm.location', {
    	method:"getReverseLocation",
    	parameters:{latitude: this.latitude, longitude: this.longitude},
    	onSuccess: this.updateReadableLocationSuccess.bind(this),
    	onFailure: this.updateReadableLocationFailure.bind(this)
    });
};

UpdateAssistant.prototype.updateReadableLocationSuccess = function(response) {
    Mojo.Log.info("^^^^^^ UpdateAssistant#UpdateReadableLocationSuccess");
    
    //this.updateLocationIndicator.hide();
    
    Mojo.Log.info("Location Length", response.address.length);
    
    this.controller.get("readable_location").update(response.address);
};

UpdateAssistant.prototype.updateReadableLocationFailure = function(error) {
    Mojo.Log.info("^^^^^^ UpdateAssistant#UpdateReadableLocationFailure");
    
    //this.updateLocationIndicator.hide();
    this.controller.get('readable_location').innerHTML = '获取位置信息失败';
    //Mojo.Log.info(Object.toJSON(error));
};

UpdateAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-update":
				this.updateStatus();
				//this.DisableNewButton();
				break;
			case "do-back":
            	this.backMain();
            	//this.stageController.popScene();
            	break;
		}
	}else if (event.type == Mojo.Event.back) {
		if(this.smileBoxOpen == true){
			event.stop();
        	//event.stopPropagation();
			this.closeSmileBox();
		}
	}
};

UpdateAssistant.prototype.handleDragstart = function(evt){
	this.downY = evt.down.y;
};

UpdateAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var _abc = evt.velocity.y;
	if (LengthX<1300){
		return;
    }else{
        
		if(Weibo.Prefs.fullScreen == false){
            this.controller.enableFullScreenMode(true);
            Weibo.Prefs.fullScreen = true;

        }else{
            this.controller.enableFullScreenMode(false);
            Weibo.Prefs.fullScreen = false;
        }

    }
    
};

UpdateAssistant.prototype.imgDownload = function(url) {   
	var thisA = this;
	Mojo.Log.info("^^^^^^#"+url);
	
	var nowtime = new Date(); 
	var longtime =nowtime.getTime();
	this.imgName = "img_"+longtime+".jpg";
	
	for(var i = 0; i < 2; i++) {
		Mojo.Log.info("^^^^^^#aa");
		this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
		 	method: 'download',
			parameters: {
				target: url,
				targetFilename : this.imgName,
				keepFilenameOnRedirect: false,
				subscribe: (i == 1)
			},
			onSuccess : function (e){
					
				if(e.completed){
					Mojo.Log.info("^^^^^^#success");
					thisA.imgurl = "/media/internal/downloads/"+thisA.imgName;
					thisA.mediaType = "image";
					thisA.controller.get("img").src = thisA.imgurl;
					thisA.controller.get('selectImg').show();
				}
						
			}.bind(this),			
			onFailure : function (e){
				
			}.bind(this)
		});
	}
};

UpdateAssistant.prototype.startTalk = function(){
	
	this.pos = this.getCursor();
	if(this.voice){
		var t = this;
		this.controller.serviceRequest("palm://com.palm.audio/systemsounds", {
		    method: "playFeedback",
		    parameters: {
		        name: "dtmf_2"
		    },
		    onSuccess:{},
		    onFailure:{}
		});

		Weibo.Voice.xfRecBegin();
		this.controller.showDialog({
			template: 'update/talk-dialog',
			assistant: new TalkAssistant(t.controller,t.gotVoice.bind(this),t.gotVoiceFailure),
			preventCancel:true
		});

	}else{
		this.controller.showAlertDialog({
			onChoose: function(value) {},
			title: $L("错误Error"),
			message: $L("语音识别初始化错误，请确认是否安装了JustSay，否则无法使用该功能"),
			allowHTMLMessage:true,
			choices:[{label:$L("知道了"), value:""} ]
        });
	}
};

UpdateAssistant.prototype.gotVoice = function(text){

	// this.textModel.value = text;
	// this.controller.modelChanged(this.textModel);
	

	// var str_len = text.length;
	// this.controller.get('content').mojo.focus(); 
	// this.controller.get('content').mojo.setCursorPosition(str_len,str_len);
	// this.controller.get('content').mojo.focus();

	var _text = this.controller.get('content');
	var result = _text.mojo.getValue();

	if (!result) {
    	var _value = text;
    	var _scp = _value.length;
    	this.pos = [];
	}else{
		if(!this.pos){
			this.pos = _text.mojo.getCursorPosition();
		}
		
		var _value = result.substr(0, this.pos.selectionStart) + text + result.substr(this.pos.selectionEnd);
		var _scp = this.pos.selectionStart + text.length;
	}

    this.pos.selectionStart = this.pos.selectionEnd = _scp;

    this.controller.get('content').mojo.setValue(_value);
    this.controller.get('content').mojo.focus(); 
    this.controller.get('content').mojo.setCursorPosition(this.pos.selectionStart,this.pos.selectionEnd);
	
	this.EnableNewButton();
	this.updateCharCount();
};

UpdateAssistant.prototype.gotVoiceFailure = function(){
	var window = Mojo.Controller.getAppController().getActiveStageController().activeScene().window;
	Mojo.Controller.errorDialog("语音识别失败，请重试！",window);
};

UpdateAssistant.prototype.activate = function(event) {
	Weibo.Control.setFullScreen(this.controller);
	if(event){
       Mojo.Log.info("^^^^^^ update_params#");
		if(event.action == "insert"){
       		this.insertText(event.text,event.pos);
       		
       	}else if(event.action == "ajustImg"){
       		this.imgurl = "/media/internal/download/temp.png";
       		this.controller.get("img").src = this.imgurl;
			this.controller.get('selectImg').show();
       		//this.controller.get('selectImg').innerHTML = '<img src="'+this.imgurl+'" height="25" width="25" />';
			
       	}
       	
       	if (event && event.filename){
        	this.selectCam(event.filename);
    	}
    	
    }else{
    
		if(this.oldText){
			this.EnableNewButton();
			this.updateCharCount();
		}
		
		if(this.title == "repost"){
			this.EnableNewButton();
		}
	
		if(Weibo.updateText[this.title] && this.title === "update"){
			this.textModel.value = Weibo.updateText[this.title];
    		this.controller.modelChanged(this.textModel);
    		this.EnableNewButton();
    		this.updateCharCount();
    		var str_len = Weibo.updateText[this.title].length;
    		this.controller.get('content').mojo.focus(); 
    		this.controller.get('content').mojo.setCursorPosition(str_len,str_len);
		}else{
			Weibo.updateText[this.title] = "";
		}
		if(this.postSet === "first"){
			this.controller.get("content").mojo.setCursorPosition(0,0);
		}
    
    }
    
    if(!Weibo.Prefs.uid){
		this.controller.stageController.swapScene({transition: Mojo.Transition.crossFade,name: "login"});
	}
    
};
	
UpdateAssistant.prototype.deactivate = function(event) {
};

UpdateAssistant.prototype.cleanup = function(event) {

	Weibo.Voice.xfKill();

	Mojo.Event.stopListening(this.controller.get('counter_number'), Mojo.Event.tap, this.clearText.bind(this) );
	Mojo.Event.stopListening(this.controller.get('location_button'), Mojo.Event.tap, this.updateLocation.bind(this) );
	 
	Mojo.Event.stopListening(this.controller.get('mic_button'), Mojo.Event.tap, this.startTalk.bind(this) );

	Mojo.Event.stopListening(this.controller.get('topic_button'), Mojo.Event.tap, this.topicClick.bind(this) );
	Mojo.Event.stopListening(this.controller.get('mention_button'), Mojo.Event.tap, this.mentionClick.bind(this) );
	Mojo.Event.stopListening(this.controller.get('mention_button_mini'), Mojo.Event.tap, this.mentionClick.bind(this) );

	Mojo.Event.stopListening(this.controller.get('smileBtn'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	Mojo.Event.stopListening(this.controller.get('smileBtn_mini'), Mojo.Event.tap, this.openSmileBox.bind(this) );
	Mojo.Event.stopListening(this.controller.get('smile_scrim'), Mojo.Event.tap, this.closeSmileBox.bind(this) );
     
	//this.controller.stopListening('delBtn', Mojo.Event.tap, this.delImage.bind(this));
	this.controller.stopListening('content', Mojo.Event.propertyChange, this.updateCharCount.bindAsEventListener(this));
	this.controller.stopListening('img_button', Mojo.Event.tap, this.selectImgMenu.bind(this));

    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keyup, this.handleKeyUpEvent.bind(this));
     
    this.controller.stopListening('smileBox', Mojo.Event.tap, this.smileClick.bind(this));
     
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
};