
function UserAssistant(name,data) {
	this.name = name;
	this.data = data || [];
	this.is_friend = false;
	this._orientation = "up";
};

UserAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
	
	this.controller.get('headerText').innerHTML = this.name;
        
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
	
	this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/user",
            listTemplate: "tpl/listTemplate",
            renderLimit: 2,
        },    
        this.statusModel = {
            items: this.data
        }
    );
	
	if(this.data[0]){
		this.controller.modelChanged(this.statusModel);
	}else{
		this.refresh();
	}
	this.isFriend();
	
	//this.controller.get("transport-picker").hide();
	//this.controller.listen('transport-picker', Mojo.Event.tap,this.selectMenu.bind(this));
	this.controller.listen("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
	this.controller.listen("transport-picker", Mojo.Event.tap,this.followUser.bind(this));

};

UserAssistant.prototype.selectMenu = function(event){
	var thisA = this;
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
    	onChoose:  this.gotMenuItem,
        placeNear: findPlace,
        items: [
        	{label:"@"+thisA.name,command:"mention"},
        	{label:"私信",command:"pm"},
        	{label:"加入黑名单",command:"block"}
        ]
    });   
};

UserAssistant.prototype.gotMenuItem = function(command){
	if(command){
	
	}
};

UserAssistant.prototype.loadTip = function(flag){
	
	if(flag == true){
		this.controller.get('loadingTip').addClassName('loading');
	}else{
		this.controller.get('loadingTip').removeClassName('loading');
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

};

UserAssistant.prototype.showData = function(data) {
	this.loadTip(false);
	this.statusModel.items = data;
	this.controller.modelChanged(this.statusModel);
};

UserAssistant.prototype.showFailure = function() {
	this.loadTip(false);
};

UserAssistant.prototype.refresh = function(){
	Mojo.Log.info("^^^^^^#user_refresh");
	this.loadTip(true);
	Weibo.Api.loadUserInfo(this.name,this.statusModel,this.controller);
};

UserAssistant.prototype.pageClick = function(event){
	var eventSrc = event.originalEvent.target || event.target;
	var target = eventSrc.id;
	if(target === "user_follow"){
		this.followUser();
	}else{
		Weibo.Opt.pageClick(event,"user_item_info",this.statusModel,this.controller)
		//this.controller.modelChanged(this.statusModel.items[event.index], this);
	}
};

UserAssistant.prototype.backMain = function(command) {    
	var app_controller = Mojo.Controller.getAppController();
	var stage_controller = app_controller.getStageController(Weibo.MainStageName);
	var top_scene = stage_controller.getScenes();
	//Mojo.Controller.getAppController().showBanner({"messageText": top_scene[0].sceneName}, {}, Weibo.MainStageName);
	
	if(top_scene[0].sceneName != "listDefault"){
		this.stageController.swapScene({transition: Mojo.Transition.crossFade,name: 'listDefault'});
	}else{
		this.stageController.popScene();
	}
	
};

UserAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-back":
				//this.controller.stageController.popScene();
				this.backMain();
				break;
			case "do-refresh":
				this.refresh();
				break;
		}
	}
};

UserAssistant.prototype.isFriend = function() {
	var thisA = this;
	var url = "http://api.t.sina.com.cn/friendships/show.json?target_screen_name="+this.name;
	var _url = Weibo.Oauth.oauthUrl(url,"GET");
	
	var req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(e){
              			Mojo.Log.info("^^^^^^#iffriend");
              			var target = e.responseJSON.source;

						if(target.following === true){
							thisA.controller.get("user_follow").innerHTML = "取消关注";
							thisA.controller.get("currentTransport").innerHTML = "取消关注";
							thisA.is_friend = true;
						}else{
							thisA.controller.get("user_follow").innerHTML = "关注TA";
							thisA.controller.get("currentTransport").innerHTML = "关注TA";
							thisA.is_friend = false;
						}
    					
              		}
            });
};

UserAssistant.prototype.followUser = function() {
	Mojo.Log.info("^^^^^^#User_followUser_"+this.name);
	var thisA = this;
	var _type = this.is_friend == true ? 'destroy' : 'create';
	//var name = encodeURIComponent(this.name);
	var url = "http://api.t.sina.com.cn/friendships/"+_type+".json";

    var parameters = [['screen_name', this.name]];

	var postBody = Weibo.signRequest(url, parameters, "POST");

	var req = new Ajax.Request(url, {
        method : 'post', 
        evalJSON : 'force',
        postBody: postBody,
        contentType: 'application/x-www-form-urlencoded',
        onSuccess: function(e){
						Mojo.Log.info("^^^^^^#User_followUser_"+e.status);
						if(thisA.is_friend == true){
							thisA.controller.get("user_follow").innerHTML = "关注TA";
							thisA.controller.get("currentTransport").innerHTML = "关注TA";
							thisA.is_friend = false;
						}else{
							thisA.controller.get("user_follow").innerHTML = "取消关注";
							thisA.controller.get("currentTransport").innerHTML = "取消关注";
							thisA.is_friend = true;
						}
    					
              		} 
		});

};

UserAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();

    }
};

UserAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

UserAssistant.prototype.activate = function(event) {
	this.setFullScreen(Weibo.Prefs.fullScreen);
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

UserAssistant.prototype.deactivate = function(event) {

};

UserAssistant.prototype.cleanup = function(event) {
	this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
	this.controller.stopListening("transport-picker", Mojo.Event.tap,this.followUser.bind(this));
}