
function ViewCommentAssistant(cid,data) {
	this.cid = cid;
	this.data = data || [];
	this.page = 1;
};

ViewCommentAssistant.prototype.setup = function() {
	
	this.stageController = this.controller.stageController;
	
	this.controller.setupWidget(Mojo.Menu.appMenu, Weibo.MenuAttr, Weibo.MenuModel);
    
    this.controller.setupWidget(Mojo.Menu.commandMenu, 
			this.subMenuAttr = {
            	spacerHeight: 0,
            	menuClass: 'no-fade'
            },
			this.subMenuModel = {
            	visible: true,
            	items: [{ icon: 'back', command: 'do-back'},{},{ icon:'refresh', command: 'do-refresh'}]
        	}
        );
	
	this.controller.setupWidget("statusBox", 
        this.statusBoxAttr = {
            itemTemplate: "tpl/comment_status",
            listTemplate: "tpl/listTemplate",
        },    
        this.statusBoxModel = {
            items: []
        }
    );
    var _statusData = [];
        _statusData.push(this.data);
    this.statusBoxModel.items = _statusData;
	this.controller.modelChanged(this.statusBoxModel);
    
    this.controller.setupWidget("feedListWgt", 
        this.statusAttr = {
            itemTemplate: "tpl/comment_replylist",
            listTemplate: "tpl/listTemplate",
            renderLimit: 300,
        },    
        this.statusModel = {
            items: []
        }
    );
    
    this.controller.setupWidget('spinnerBox',
    	this.spinnerSAttrs = {
			spinnerSize: Mojo.Widget.spinnerSmall,
			modelProperty: 'spinning'
		},
	
		this.spinnerModel = {
			spinning: false
		}
	);
    
    
    this.controller.listen('transport-picker', Mojo.Event.tap,this.selectMenu.bind(this));
    this.controller.listen('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));

	this.controller.listen('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.listen('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.listen('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.listen('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    
    this.controller.listen("statusBox", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    this.controller.listen("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.listen("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.listen("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));
    this.controller.listen("feedListWgt", Mojo.Event.dragEnd, this.handleDragend.bind(this));
    
    this.refresh();
	
};

ViewCommentAssistant.prototype.handleDragstart = function(evt){
	this.downY = evt.down.y;
};

ViewCommentAssistant.prototype.handleDragend = function(evt){
	
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;

	this.pageY_abs = Math.abs(this.pageY);
	this.pageH = this.controller.get('feedListWgt').offsetHeight + this.controller.get('statusBox').offsetHeight;

	var _h = this.controller.window.innerHeight;
		
	if((this.pageY_abs+_h-10) > this.pageH && this.pageH > (_h-10)){
		if(Weibo.loading === false){
			this.loadMore();
		}

	}
};

ViewCommentAssistant.prototype.handleKeyDownEvent = function(event) {

    if(event.originalEvent.keyCode == 84){ //t
        this.scrollToTop();
        
    }else if(event.originalEvent.keyCode == 82){ //r
    	this.refresh();
    	
    }else if(event.originalEvent.keyCode == 67){ //c
		Weibo.Opt.comment(this.data);
		
	}else if(event.originalEvent.keyCode == 90){ //z
    	Weibo.Opt.repost(this.data);
        
    }else if(event.originalEvent.keyCode == 66){//b
        this.scrollToBottom();
    	
    }else if(event.originalEvent.keyCode == 32){ //space
    	this.scrollNext();
    	
    }else if(event.originalEvent.keyCode == 190){ //.
    	this.scrollPre();
       
    }else if(event.originalEvent.keyCode == 70){ //f
        if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;
			}else{
				this.setFullScreen(false);
				Weibo.Prefs.fullScreen = false;
			}
        }
        //this.controller.modelChanged(Weibo.NavMenuModel);
    	
    }else if(event.originalEvent.keyCode == 81){ //q
		this.controller.stageController.popScene();
		
    }else if(event.originalEvent.keyCode == 188){ //,
    	var _pageY = this.scroller.mojo.getScrollPosition().top;
    	var _pageH = this.controller.get('feedListWgt').getHeight();
    	if(_pageY+_pageH<480){
    		this.loadMore();
    	}
    }
   
};

ViewCommentAssistant.prototype.handleFlick = function(evt){
	var LengthX = Math.sqrt(evt.velocity.x*evt.velocity.x);
	var LengthY = Math.sqrt(evt.velocity.y*evt.velocity.y);
	var _twHeight = this.controller.window.innerHeight;

	//this.controller.get('test').innerHTML = Object.toJSON(evt);
	if (LengthX<1300 || LengthY > 600){
		return;
    }else{
        
		if(this._orientation === "up"){
			if(Weibo.Prefs.fullScreen == false){
				this.setFullScreen(true);
				Weibo.Prefs.fullScreen = true;

			}else{
			   
				if(this.downY > (_twHeight / 2)){
					this.selectMenu(evt);
				}else{
					this.setFullScreen(false);
					Weibo.Prefs.fullScreen = false;

				}
			}
		}else{
			if(this.downY > (_twHeight / 2)){
				this.selectMenu(evt);
			}
		}

    }
    
};

ViewCommentAssistant.prototype.cancelLoad = function() {
	Weibo.Api.cancelReq();
	if(Weibo.list[this.title]){
		this.loadTip(false);
	}
};

ViewCommentAssistant.prototype.selectMenu = function(event){
	var thisA = this;
	var findPlace = event.target || event.originalEvent.target;
	this.controller.popupSubmenu({
    	onChoose:  this.gotMenuItem,
        placeNear: findPlace,
        items: [
        	{label:"@"+thisA.data.user.screen_name,command:"mention"},
        	{label:"转发",command:"repost"},
        	{label:"评论",command:"comment"},
        	{label:"复制",command:"copy"},
        	{label:"刷新",command:"refresh"},
        ]
    });   
};

ViewCommentAssistant.prototype.gotMenuItem = function(command){
	if(command){
		if(command == 'mention'){
			Weibo.Opt.mention(this.data.user.screen_name);
		}else if(command == 'repost'){
			Weibo.Opt.repost(this.data);
		}else if(command == 'comment'){
			Weibo.Opt.comment(this.data);
		}else if(command == 'copy'){
			var _text = this.data.user.screen_name+":"+this.data.OldText;
			Weibo.Opt.copyText(_text);
		}else if(command == 'refresh'){
			this.refresh();
		}
	}
};

ViewCommentAssistant.prototype.pageClick = function(event){
	Weibo.Opt.pageClick(event,this.title,this.statusModel,this.controller);
	//this.controller.modelChanged(this.statusModel.items[event.index], this);
};

ViewCommentAssistant.prototype.showLoadMoreBox = function(flag){
	if(flag == true){
		this.controller.get('loadMoreBox').show();
	}else{
		this.controller.get('loadMoreBox').hide();
	}
};


ViewCommentAssistant.prototype.loadTip = function(flag){

	if(flag == true){
		Weibo.loading = true;
		this.controller.get('loadingTip').addClassName('loading');
		this.controller.get('loadMoreBox').addClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').hide();
		this.controller.get('loadMoreStart').show();
	}else{
		Weibo.loading = false;
		this.controller.get('loadingTip').removeClassName('loading');
		this.controller.get('loadMoreBox').removeClassName('loadMoreBoxSelect');
		this.controller.get('loadMoreBox').show();
		this.controller.get('loadMoreBtn').show();
		this.controller.get('loadMoreStart').hide();
	}
	this.spinnerModel.spinning = flag;
	this.controller.modelChanged(this.spinnerModel);

	if(this.statusModel.items.length > 0){
		this.controller.get('loadMoreBox').show();
		this.isLoadMore = true;
	}else{
		this.controller.get('loadMoreBox').hide();
		this.isLoadMore = false;
	}

};

ViewCommentAssistant.prototype.showData = function(data,sIndex) {
	this.loadTip(false);
	if(data.length > 0){
		this.controller.get('commentTitle').show();
		var oldData = this.statusModel.items || [];
		var newDataLength = data.length - oldData.length;
		
		
		if(newDataLength < (Weibo.Prefs.count-2)){
			this.controller.get('loadMoreBox').hide();
			this.isLoadMore = false;
		}else{
			this.controller.get('loadMoreBox').show();
			this.isLoadMore = true;
		}
	}
	
	this.statusModel.items = data;
	this.controller.modelChanged(this.statusModel);
	if(sIndex > -1){
		this.controller.get('feedListWgt').mojo.revealItem(sIndex,true);
	}
};

ViewCommentAssistant.prototype.showFailure = function(type) {
	var _type = type || "show";
	this.loadTip(false);
	if(type === "hide"){
		this.controller.get('loadMoreBox').hide();
		this.isLoadMore = false;
	}
};

ViewCommentAssistant.prototype.refresh = function(){
    this.loadTip(true);
    this.showLoadMoreBox(false);
    this.page = 1;
    this.isLoadMore = true;
    this.statusModel.items = [];
    this.controller.modelChanged(this.statusModel);
    var url = "http://api.t.sina.com.cn/statuses/comments.json";
	var parameters = [['count', Weibo.Prefs.count],['id', this.cid],['page', this.page]];
	var _url = Weibo.signRequest(url, parameters, "GET");
	
    this.title = "comment_show";//+this.cid;
    Weibo.list[this.title] = [];
    Weibo.Api.loadItem(_url,this.title,this.statusModel,this.controller,'new');
};

ViewCommentAssistant.prototype.loadMore = function(){
	if(this.isLoadMore){
		this.loadTip(true);
		Weibo.loading = true;
		this.page = this.page + 1;
		var url = "http://api.t.sina.com.cn/statuses/comments.json";
		var parameters = [['count', Weibo.Prefs.count],['id', this.cid],['page', this.page]];
		var _url = Weibo.signRequest(url, parameters, "GET");
	    this.title = "comment_show";//+this.cid;
	    Weibo.Api.loadItem(_url,this.title,this.statusModel,this.controller,'old');
	}
};

ViewCommentAssistant.prototype.scrollToTop = function() {
	this.scroller = this.controller.getSceneScroller();
    this.scroller.mojo.scrollTo(0, 0);
    this.scroller.mojo.scrollTo(0, 0);
};

ViewCommentAssistant.prototype.scrollToBottom = function() {
	this.scroller = this.controller.getSceneScroller();
	this.scroller.mojo.scrollTo(0, -1 * (this.controller.get('feedListWgt').getHeight()+this.controller.get('statusBox').getHeight()));
	this.scroller.mojo.scrollTo(0, -1 * (this.controller.get('feedListWgt').getHeight()+this.controller.get('statusBox').getHeight()));
};

ViewCommentAssistant.prototype.scrollNext = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY-180), true);
};

ViewCommentAssistant.prototype.scrollPre = function() {
	this.scroller = this.controller.getSceneScroller();
	this.pageY = this.scroller.mojo.getScrollPosition().top;
	this.scroller.mojo.scrollTo(undefined,  (this.pageY+180), true);
};

ViewCommentAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
		switch(event.command) {
			case "do-refresh":
				this.refresh();
				break;
			case "do-back":
				this.controller.stageController.popScene();
				break;
		}
		
	}else if (event.type == Mojo.Event.forward) {
		Weibo.Opt.comment(this.data);
	}
};

ViewCommentAssistant.prototype.setFullScreen = function(type) {
	if(type == true){
		this.controller.enableFullScreenMode(true);
		this.subMenuModel.visible = false;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.loadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "-24px";
        this.controller.get('bottomBox').style.bottom = "-24px";
		this.controller.get('otherHeader').hide();
		this.controller.get('spaceBox').hide();

    }else{
		this.controller.enableFullScreenMode(false);
		this.subMenuModel.visible = true;
		this.controller.modelChanged(this.subMenuModel);
		//this.stageController.unloadStylesheet("stylesheets/top.css");
		this.controller.get('topBox').style.top = "20px";
        this.controller.get('bottomBox').style.bottom = "-15px";
		this.controller.get('otherHeader').show();
		this.controller.get('spaceBox').show();

    }
};

ViewCommentAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	if(this._orientation === "left" || this._orientation === "right" || this._orientation === "down"){
		if(Weibo.Prefs.orient === true){
			this.setFullScreen(true);
		}
	}else{
		this.setFullScreen(Weibo.Prefs.fullScreen);
	}
};

ViewCommentAssistant.prototype.activate = function(event) {

	this.setFullScreen(Weibo.Prefs.fullScreen);
	//this.stageController.setWindowOrientation('up');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

ViewCommentAssistant.prototype.deactivate = function(event) {
};

ViewCommentAssistant.prototype.cleanup = function(event) {
	//this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.viewInfo.bindAsEventListener(this));
	this.controller.stopListening('transport-picker', Mojo.Event.tap,this.selectMenu.bind(this));
    this.controller.stopListening('loadMoreBtn', Mojo.Event.tap,this.loadMore.bind(this));

	this.controller.stopListening('loadingTip', Mojo.Event.tap,this.cancelLoad.bind(this));
	this.controller.stopListening('spinnerBox', Mojo.Event.tap,this.cancelLoad.bind(this));
    
    this.controller.stopListening('topBox', Mojo.Event.tap,this.scrollToTop.bind(this));
    this.controller.stopListening('bottomBox', Mojo.Event.tap,this.scrollToBottom.bind(this));
    
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    
    this.controller.stopListening("statusBox", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    this.controller.stopListening("feedListWgt", Mojo.Event.listTap,this.pageClick.bindAsEventListener(this));
    
    this.controller.stopListening("box", Mojo.Event.flick, this.handleFlick.bind(this));
    this.controller.stopListening("box", Mojo.Event.dragStart, this.handleDragstart.bind(this));

    this.controller.stopListening("feedListWgt", Mojo.Event.dragEnd, this.handleDragend.bind(this));

};