function ViewImageAssistant(url,durl,src) {
	this.url = url;
	this.src = src;
	this.ext = getFileExt(this.url);
	this.ext = this.ext.toLowerCase();

	this.originalUrl = durl;
};

ViewImageAssistant.prototype.setup = function() {
	
	this.controller.enableFullScreenMode(true);
	var nowtime = new Date(); 
	var longtime =nowtime.getTime();

	this.showSmallImg();
	
	if(this.ext=="gif") {
		this.alt = false;
		this.imgName = "img_"+longtime+".gif";
	} else {
		this.alt = true;
		this.imgName = "img_"+longtime+".jpg";
	}

	if(this.alt){
		this.controller.setupWidget('imgDiv', 
			this.imgattributes = {
				noExtractFS : false,
				autoSize: false, 
				limitZoom: true
			},
			this.imgmodel = {
				//backgroundImage : 'images/glacier.png',
				background: 'black',
				//onLeftFunction : this.wentLeft.bind(this),
				//onRightFunction : this.wentRight.bind(this)
			}
		);
	}

	this.myPhotoDivElement = this.controller.get('imgDiv');
	
	this.showHide = this.showHide.bind(this);
	this.controller.listen('imgDiv', Mojo.Event.tap, this.showHide);
	this.controller.listen('imgAlt', Mojo.Event.tap, this.showHide);
	
	this.controller.setupWidget(Mojo.Menu.commandMenu,
		this.menuattributes = {
            spacerHeight: 0,
            menuClass: 'fade'
        },
		this.menumodel = {
            visible: false,
            items: [
				{icon:'back', command: 'do-back'},
				{},
				{iconPath: 'images/menu_save.png', command: "do-download",disabled: false}
            ]
        }
    );
    
    this.controller.listen(this.myPhotoDivElement, Mojo.Event.imageViewChanged, this.imageLoadEnd.bind(this));

    this.spinnerModel = {spinning: true};
    this.spinnerAtt = {spinnerSize: 'large'};
    this.controller.setupWidget("spinner", this.spinnerAtt, this.spinnerModel);

    this.controller.listen(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
    
};

ViewImageAssistant.prototype.imageLoadEnd = function(event) {
    this.spinnerModel.spinning = false;
    this.controller.modelChanged(this.spinnerModel);
    this.controller.get("scrim").hide();
	this.controller.get("smallDiv").hide();
};

ViewImageAssistant.prototype.showHide = function(event) {
	this.controller.toggleMenuVisible(Mojo.Menu.commandMenu);
},

ViewImageAssistant.prototype.handleCommand = function(event) {        
    if(event.type == Mojo.Event.command) {
        switch(event.command) {
        	case "do-back":
                this.controller.stageController.popScene();
                break;
			case "do-download":
            	this.menumodel.items[1].disabled = true;
				this.controller.modelChanged(this.menumodel);
				this.imgDownload();
			   break;
				
        }
    }
};

ViewImageAssistant.prototype.imgDownload = function() {   
	for(var i = 0; i < 2; i++) {
		this.controller.get("loadStatus").innerHTML = "下载中:";
		this.controller.serviceRequest('palm://com.palm.downloadmanager/', {
		 	method: 'download',
			parameters: {
				target: this.originalUrl,
				//mime: "image/jpeg",
				targetFilename : this.imgName,
				//targetDir : "/media/internal/weibo/",
				keepFilenameOnRedirect: false,
				subscribe: (i == 1)
			},
			onSuccess : function (e){
						
				if(e.completed){
					this.loadText = filesize(e.amountTotal);
					this.controller.get("loadStatus").innerHTML = "下载完成 "+this.loadText;
					//$("testDiv").update(Object.toJSON(resp));
				}else{
					if(!isNaN(e.amountReceived) && !isNaN(e.amountTotal)) {
						this.progress = Math.round((e.amountReceived/e.amountTotal)*100);
						//this.time.elapsed = ((new Date()).getTime() - this.time.start)/1000;
						this.loadText = this.progress;
						this.controller.get("loadStatus").innerHTML = "下载中:"+this.loadText+"%";
					}
				}
						
			}.bind(this),			
			onFailure : function (e){
				this.menumodel.items[1].disabled = false;
				this.controller.modelChanged(this.menumodel);
				this.controller.showAlertDialog({
					onChoose: function() {},
					title: $L("下载失败！"),
					choices:[
						{label:$L("OK"), value:""}
					]
				});
			}.bind(this)
		});
	}
};

ViewImageAssistant.prototype.handleKeyDownEvent = function(event) {
    if(event.originalEvent.keyCode == 81){ //q
        this.controller.stageController.popScene();
    }
};

ViewImageAssistant.prototype.orientationChanged = function(orientation){
	this._orientation = orientation;
	
	this.controller.enableFullScreenMode(true);
	var window = this.controller.window;
	if(this.alt){
  		this.myPhotoDivElement.mojo.manualSize(window.innerWidth, window.innerHeight);
  	}else{
  		this.controller.get("imgAltDiv").style.width = window.innerWidth+'px';
  		this.controller.get("imgAltDiv").style.height = (window.innerHeight+0)+'px';
  		
  		if(Weibo.Prefs.orient === true && (this._orientation === "left" || this._orientation === "right")){
			this.controller.get("imgAlt").style.height = (window.innerHeight-10)+'px';
			this.controller.get("imgAlt").style.width = "auto";
		}else{
			this.controller.get("imgAlt").style.width = (window.innerWidth-10)+'px';
			this.controller.get("imgAlt").style.height = "auto";
		}
  		
  	}
};

ViewImageAssistant.prototype.activate = function(event) {
	this.controller.enableFullScreenMode(true);
	
	//this.controller.stageController.setWindowOrientation('free');
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
	
	var window = this.controller.window;
  	
	if(this.alt){
		this.myPhotoDivElement.mojo.centerUrlProvided(this.url);
		
  		this.myPhotoDivElement.mojo.manualSize(window.innerWidth, window.innerHeight);
	}else{
	
		this.controller.get("imgAltDiv").style.width = window.innerWidth+'px';
  		this.controller.get("imgAltDiv").style.height = (window.innerHeight+0)+'px';
  		
		var t = this;
		this.tsuImage = new Image();
		this.tsuImage.src = this.url;
		this.tsuImage.onload = function(){
			
			t.controller.get("imgAlt").src = t.tsuImage.src;
			
			var ImgW = t.tsuImage.width;
			var ImgH = t.tsuImage.height;
			
			if(ImgW > ImgH || ImgW == ImgH){
				t.controller.get("imgAlt").style.width = (window.innerWidth-10)+'px';
				t.controller.get("imgAlt").style.height = "auto";
			}else{
				t.controller.get("imgAlt").style.height = (window.innerHeight-10)+'px';
				t.controller.get("imgAlt").style.width = "auto";
			}
			
			
			t.controller.get("imgAlt").style.left = "0px";
			t.controller.get("imgAlt").style.top = "0px";
			t.spinnerModel.spinning = false;
			t.controller.modelChanged(t.spinnerModel);
			t.controller.get("scrim").hide();
			t.controller.get("smallDiv").hide();
		};
	}
	
};

ViewImageAssistant.prototype.showSmallImg = function() {

	var window = this.controller.window;
	//this.controller.get("smallDiv").style.width = window.innerWidth+'px';
	//this.controller.get("smallDiv").style.height = (window.innerHeight)+'px';

	var t = this;
	this.s_img = new Image();
	this.s_img.src = this.src;
	this.s_img.onload = function(){
		
		t.controller.get("smallImg").src = t.s_img.src;

		var ImgW = t.s_img.width;
		var ImgH = t.s_img.height;
		
		if(ImgW > ImgH || ImgW == ImgH){
			t.controller.get("smallImg").style.width = (window.innerWidth)+'px';
			t.controller.get("smallImg").style.height = "auto";
		}else{
			t.controller.get("smallImg").style.height = (window.innerHeight)+'px';
			t.controller.get("smallImg").style.width = "auto";
		}

		t.controller.get("smallImg").style.left = "0px";
		t.controller.get("smallImg").style.top = "0px";

	};

};

ViewImageAssistant.prototype.deactivate = function(event) {
	if(Weibo.Prefs.orient === true){
		this.controller.stageController.setWindowOrientation('free');
	}else{
		this.controller.stageController.setWindowOrientation('up');
	}
};

ViewImageAssistant.prototype.cleanup = function(event) {
	this.controller.stopListening("imgDiv", Mojo.Event.tap,this.showHide);
    this.controller.stopListening(this.controller.sceneElement, Mojo.Event.keydown, this.handleKeyDownEvent.bind(this));
};

var filesize = function(bytes) {
	var sizes = new Array(" Bytes", " KB", " MB", " GB", " TB", " PB", " EB", " ZB", " YB");
	
	var i = 0;
	while(bytes >= 1024) {
		i++;
		bytes /= 1024;
	}
	return (Math.round(bytes*100)/100)+sizes[i];
}
