Weibo.getFeedWgt = function(title) {
	var titleSub = title.substr(0,4);
	
	if(title == 'home' || titleSub == 'home'){
		return 'homeListWgt';
		
	}else if(title == 'mention'){
		return 'mentionListWgt';
		
	}else if(title == 'comment' || title == 'comment_by_me'){
		return 'commentListWgt';
		
	}else if(title == 'dm' || title == 'dm_user' || title == 'dm_sent'){
		return 'dmListWgt';
		
	}else if(title == 'my'){
		return 'userListWgt';
		
	}else{
		return 'feedListWgt';
	}
};

Weibo.Api = ({
	
	removeCache:function() {
		var timelines_cache = new Lawnchair({table: "account_cache_"+Weibo.Prefs.uid, adaptor: "webkit"});
    	timelines_cache.nuke();

	},

	saveCache:function(cacheKey,items) {
    	Mojo.Log.info("^^^^^^ #SaveCache_"+cacheKey);
    	var timelines_cache = new Lawnchair({table: "account_cache_"+Weibo.Prefs.uid, adaptor: "webkit"});
    	timelines_cache.remove(cacheKey);
    
    	//save the new cache
    	var current_timeline_items = items;
    
    	//save only the latest 10 and remove markers before saving'em
    	var to_cache = [];
    	for(var i=0; i < 10; i++){
       		if(current_timeline_items[i] && current_timeline_items[i].is_marker === false){
       			to_cache.push(current_timeline_items[i]);
       		}
       		
    	}

    	var current_since_id = to_cache[0].id;
    	var current_max_id = to_cache[to_cache.length-1].id;
    
    	var t= this;
    	timelines_cache.save({
                          key: cacheKey, 
                          //since_id: current_since_id, 
                          max_id: current_max_id,
                          items: to_cache
                          });
    
    	delete timelines_cache;
    
	},
	
	getCache: function(cacheKey,model,controller) {
    	Mojo.Log.info("^^^^^^ #getCache_"+cacheKey);
    	var thisA = this;
    	
    	if(Weibo.list[cacheKey] && Weibo.list[cacheKey].length > 0 && Weibo.since_id[cacheKey] > -1){
			Mojo.Log.info("^^^^^^#getCache_oldList");
			model.items = Weibo.list[cacheKey];
    		controller.modelChanged(model);

    		this.refreshTimeOut = setTimeout(function(){thisA.refresh(cacheKey,model,controller)}, 1*1000);

    	}else{
    		
    		var no_cache_handler = function(a) {
    			Mojo.Log.info("^^^^^^#noCache");
    			thisA.refresh(cacheKey,model,controller);
    			return;
    		}.bind(this);

    		var timeline_cache = new Lawnchair({table: "account_cache_"+Weibo.Prefs.uid, adaptor: "webkit", onError:no_cache_handler});

    		timeline_cache.get(cacheKey, function(a){ 
      
      			if(a){
					Mojo.Log.info("^^^^^^#getCache_yes");
					Weibo.max_id[cacheKey] = a.max_id;
					Weibo.list[cacheKey] = a.items;
					thisA.loadFromCache(a,cacheKey,model,controller);
      			}else{
      				Mojo.Log.info("^^^^^^#gotnoCache");
      				thisA.refresh(cacheKey,model,controller);
      			}
     
    		});
    	}
    
    	//delete timeline_cache;
	},
	
	loadFromCache: function(data,cacheKey,model,controller) {
    	Mojo.Log.info("^^^^^^#loadFromCache_"+cacheKey);
    	model.items = data.items;
    	controller.modelChanged(model);
    
    	var t = this;
    	this.refreshTimeOut = setTimeout(function(){t.refresh(cacheKey,model,controller)}, 1*1000);
    	//this.refresh();
    	
	},

	refresh: function(cacheKey,model,controller){
		Mojo.Log.info("^^^^^^#refresh_"+cacheKey);
		var url = Weibo.getUrl(cacheKey,'new');
		if(url){
			Weibo.Api.loadItem(url,cacheKey,model,controller,'new',true);
		}
	},

	loadCount: function(title){
		var titleSub = title.substr(0,4);
		if(title === 'home' || title === 'geo_status' || titleSub === 'home' || title === 'mention' || title === 'searchStatus'){
			var _count = true;
		}else{
			var _count = false;
		}
		return _count;
	},

	changeMarker: function(title,controller){
		if(Weibo.list[title][Weibo.markerIndex[title]] && Weibo.list[title][Weibo.markerIndex[title]].is_marker){
			Weibo.list[title][Weibo.markerIndex[title]].marker_class = 'old_marker';
			var _marker = [{is_marker: true,marker_class: 'old_marker'}];
			var listWgt = Weibo.getFeedWgt(title);
			controller.get(listWgt).mojo.noticeUpdatedItems(Weibo.markerIndex[title], _marker);
		}
     },
		
    loadItem:function(url,title,model,controller,type,if_cache) {
    	Mojo.Log.info("^^^^^^#loadItem"+title);
		var thisA = this;
		
		this.req = new Ajax.Request(url, {
              method: "get",
			  //requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
			  requestHeaders:['Accept-Encoding','gzip,deflate'],
              onSuccess: function(resp){

				if(resp.responseJSON){
					var _r = resp.responseJSON;
				}else{
					var _r = JSON.parse(resp.responseText);
				}

				var _count = Weibo.Api.loadCount(title);
				Weibo.Api.resetCountType(title);
				
				if(title === "home"){
					Weibo.newStatusNum['status'] = 0;
				}else{
					Weibo.newStatusNum[title] = 0;
				}

              	if(type === 'new'){
              		Mojo.Log.info("^^^^^^#loadItem_new");
              		if(_count){
						thisA.countNewItem(_r,title,model,controller,if_cache);
					}else{
              			thisA.gotNewItem(_r,title,model,controller,if_cache);
					}
				}else if(type === 'gap'){
					Mojo.Log.info("^^^^^^#loadItem_gap");
              		if(_count){
						thisA.countGapItem(_r,title,model,controller,if_cache);
					}else{
              			thisA.gotGapItem(_r,title,model,controller,if_cache);
					}
              	}else{
              		Mojo.Log.info("^^^^^^#loadItem_old");
              		if(_count){
						thisA.countOldItem(_r,title,model,controller);
					}else{
              			thisA.gotOldItem(_r,title,model,controller);
					}
              	}
              	
              }.bind(this),
              onFailure: this.loadItem_Failure.bind(this,controller)
        });
    },

    remainList:function(title) {
		if(Weibo.list[title].length > 50){
			Weibo.list[title] = Weibo.list[title].slice(0,50);
		}
	},
    
    gotNewItem:function(data,title,model,controller,if_cache) {
		Mojo.Log.info("^^^^^^#gotNewItem_"+title);
		Weibo.list[title] = Weibo.list[title] || [];

		Weibo.Api.remainList(title);

		var thisA = this;

		if(title === "dm_user"){
			var _rData = data.users;
			Weibo.dm_user_next_cursor = data.next_cursor;
			Weibo.dm_user_previous_cursor = data.previous_cursor;
		}else{
			var _rData = data;
		}
			
		if(title == 'geo_status'){
			_rData = _rData.statuses;
		}
						
		if(_rData.length > 0){
			if(title === "searchUser" || title === "dm_user"){
				var _newItems = formatUserItems(_rData);
				var _newItems_max_id = 0;
			}else{
				var _data = formatItems(_rData);
				var _newItems = _data.list;
				var _newItems_max_id = _data.max_id;
			}
		
			var marker = {is_marker: true,marker_class: 'new_marker'};
     			
     		if(Weibo.list[title].length > 0 && Weibo.since_id[title] > 0){

     			Weibo.Api.changeMarker(title,controller);
     			
     			//add gap marker
				var gap = false;
				var tweets = Weibo.list[title];
				if(title == "comment"){
        			gap = thisA.detectGap(tweets[tweets.length - 1], _newItems[0],_newItems.length);
				}
        		//add gap
				if(gap == true) {
        			var gap_marker = {is_gap: true,max_id:_data.max_id};
        			_newItems.push(gap_marker);
        			Weibo.gapMarkerIndex[title] = _newItems.length-1;
					var sIndex = 0;//Weibo.gapMarkerIndex[title]-1;
					//Weibo.gap_max_id[title] = _data.max_id;
        				
				//add marker
				}else{
     				var marker = {is_marker: true,marker_class: 'new_marker'};
     				_newItems.push(marker);
     				Weibo.markerIndex[title] = _newItems.length-1;
     				var sIndex = 0;//Weibo.markerIndex[title]-1;
				}
     				
     		}else{
     			Weibo.list[title] = [];
     			Weibo.max_id[title] = _newItems_max_id;
     			var sIndex = 0;
     		}
     			
			Weibo.since_id[title] = _newItems[0].id;
					
        	Weibo.list[title] = _newItems.concat(Weibo.list[title]);

			if(controller){
				controller.assistant.scrollToTop();
				controller.assistant.showData(Weibo.list[title],sIndex);
			}
					
			if(if_cache){
				thisA.saveCache(title,Weibo.list[title]);
			}

		}else{
			if(Weibo.list[title].length > 0){
				controller.assistant.showFailure();
			}else{
				controller.assistant.showFailure('hide');
			}
			
		}
    
	},
	
	gotOldItem:function(data,title,model,controller) {
		Mojo.Log.info("^^^^^^#gotOldItem_"+title);
		Weibo.list[title] = Weibo.list[title] || [];
		var thisA = this;
			
		if(title === "dm_user"){
			var _rData = data.users;
			Weibo.dm_user_next_cursor = data.next_cursor;
			Weibo.dm_user_previous_cursor = data.previous_cursor;
		}else{
			var _rData = data;
			
		}
		
		if(title == 'geo_status'){
			_rData = _rData.statuses;
		}
			
		if(_rData.length > 0){
				
			if(title === "searchUser" || title === "dm_user"){
				var _oldItems = formatUserItems(_rData);
			}else{
				var _data = formatItems(_rData);
				var _oldItems = _data.list;
				Weibo.max_id[title] = _data.max_id;
			}
		
			var marker = [{is_marker: true,marker_class: 'new_marker'}];
     			
     		if(Weibo.list[title].length > 0){

     			Weibo.Api.changeMarker(title,controller);
     				
     			var oldListNum = Weibo.list[title].length || 0;
     			var _oldItems2 = marker.concat(_oldItems);
     					
     			//Weibo.list[title].push(marker);
     			Weibo.markerIndex[title] = Weibo.list[title].length;
     				
     		}
     			
        	//Weibo.list[title] = Weibo.list[title].concat(_oldItems2);
        	Weibo.list[title].push.apply(Weibo.list[title], _oldItems2);
        	
        	var sIndex = Weibo.markerIndex[title]+1;
			//controller.assistant.showData(Weibo.list[title],sIndex);
			var listWgt = Weibo.getFeedWgt(title);
			controller.get(listWgt).mojo.setLength(Weibo.list[title].length);
          	controller.get(listWgt).mojo.noticeUpdatedItems(oldListNum, _oldItems2);
          	//controller.get(listWgt).mojo.noticeAddedItems(oldListNum, _oldItems2);
          	
          	controller.get(listWgt).mojo.revealItem(sIndex,true);
          			
			controller.assistant.loadTip(false);

		}else{
			controller.assistant.showFailure("hide");
		}

	},
	
	countNewItem:function(data,title,model,controller,if_cache) {
		Mojo.Log.info("^^^^^^#countNewItem_"+title+"_");
		Weibo.list[title] = Weibo.list[title] || [];

		Weibo.Api.remainList(title);

		var thisA = this;
			
		var _rData = data;
		
		if(title == 'geo_status'){
			_rData = _rData.statuses;
		}
				
		var _data = formatItems(_rData);

		var newItems = _data.list;
			
		if(_data.ids){
			Weibo.ids[title] = _data.ids;

			var url = "http://api.t.sina.com.cn/statuses/counts.json";
			//var _url = Weibo.Oauth.oauthUrl(url,"GET");
			
			var parameters = [['ids', _data.ids]];
			var _url = Weibo.signRequest(url, parameters, "GET");

			this.req = new Ajax.Request(_url, {
          		method: "get",
          		evalJSON: 'force',
          		requestHeaders:['Accept-Encoding','gzip,deflate'],
          		onSuccess: function(r){
          			var _newItems = countStatus(newItems,r.responseJSON);
     			
     				if(Weibo.list[title].length > 0 && Weibo.since_id[title] > 0){

     					Weibo.Api.changeMarker(title,controller);

						//add gap marker
						var gap = false;
						var tweets = Weibo.list[title];
						if(title != "searchStatus"){
        					gap = thisA.detectGap(tweets[tweets.length - 1], _newItems[0],_newItems.length);
						}
        				//add gap
						if(gap == true) {
        					var gap_marker = {is_gap: true,max_id:_data.max_id};
        					_newItems.push(gap_marker);
        					Weibo.gapMarkerIndex[title] = _newItems.length-1;
							var sIndex = 0;//Weibo.gapMarkerIndex[title]-1;
							//Weibo.gap_max_id[title] = _data.max_id;
        				
						//add marker
						}else{
     						var marker = {is_marker: true,marker_class: 'new_marker'};
     						_newItems.push(marker);
     						Weibo.markerIndex[title] = _newItems.length-1;
     						var sIndex = 0;//Weibo.markerIndex[title]-1;
						}
     				
     				}else{
     					Mojo.Log.info("^^^^^^#countNewItem_nolist");
     					Weibo.list[title] = [];
     					Weibo.max_id[title] = _data.max_id;
     					var sIndex = 0;
     				}
     			
					Weibo.since_id[title] = _newItems[0].id;
					
					
          			Weibo.list[title] = _newItems.concat(Weibo.list[title]);

					if(controller){
						controller.assistant.scrollToTop();
						controller.assistant.showData(Weibo.list[title],sIndex);
					}
					
					if(if_cache){
						thisA.saveCache(title,Weibo.list[title]);
					}
				
          		}.bind(this),
          		onFailure: this.loadItem_Failure.bind(this,controller)
    		});
    	}else{
			controller.assistant.showFailure();
    	}
        

	},
	
	countOldItem:function(data,title,model,controller) {
		Mojo.Log.info("^^^^^^#countOldItem_"+title+"_");
		Weibo.list[title] = Weibo.list[title] || [];
		var thisA = this;
	
		var _rData = data;

		if(title == 'geo_status'){
			_rData = _rData.statuses;
		}
					
		var _data = formatItems(_rData);

		var oldItems = _data.list;
			
		if(_data.ids){

			Weibo.max_id[title] = _data.max_id;
			Weibo.ids[title] = _data.ids;

			var url = "http://api.t.sina.com.cn/statuses/counts.json";
			
			var parameters = [['ids', _data.ids]];
			var _url = Weibo.signRequest(url, parameters, "GET");

			this.req = new Ajax.Request(_url, {
          		method: "get",
          		requestHeaders:['Accept-Encoding','gzip,deflate'],
          		onSuccess: function(r){
          			Mojo.Log.info("^^^^^^#countOldItem_count");
          			var _oldItems = countStatus(oldItems,r.responseJSON);
          			
          			var marker = [{is_marker: true,marker_class: 'new_marker'}];
     			
     				if(Weibo.list[title].length > 0){

     					Weibo.Api.changeMarker(title,controller);
     					
     					var oldListNum = Weibo.list[title].length || 0;

     					var _oldItems2 = marker.concat(_oldItems);
     					
     					Weibo.markerIndex[title] = Weibo.list[title].length;
     				
     				}
     			
          			
          			//Weibo.list[title] = Weibo.list[title].concat(_oldItems2);
          			Weibo.list[title].push.apply(Weibo.list[title], _oldItems2);
          			
          			var sIndex = Weibo.markerIndex[title]+1;
          			
          			var listWgt = Weibo.getFeedWgt(title);
          			controller.get(listWgt).mojo.setLength(Weibo.list[title].length);
          			controller.get(listWgt).mojo.noticeUpdatedItems(oldListNum, _oldItems2);
          			//controller.get(listWgt).mojo.noticeAddedItems(oldListNum, _oldItems2);

          			controller.get(listWgt).mojo.revealItem(sIndex,true);
          			
					controller.assistant.loadTip(false);
				
          		},
          		onFailure: this.loadItem_Failure.bind(this,controller)
    		});
    	}else{
    		//Mojo.Controller.getAppController().showBanner({"messageText": '_k'+resp.status}, {}, Weibo.MainStageName);
			controller.assistant.showFailure();

    	}
       

	},
	
	gotGapItem:function(data,title,model,controller) {
		Mojo.Log.info("~~~~~~#gotGapItem_"+title);
		Mojo.Log.info("~~~~~~#Gap_max_id"+Weibo.gap_max_id[title]);
		var thisA = this;
		var before_gap_tweets = [];
    	var after_gap_tweets = [];
    	var gap_tweets = [];
    	
		if (Weibo.gap_max_id[title] && Weibo.list[title]) {
			
			var scope = Weibo.gapMarkerIndex[title];
			Mojo.Log.info("~~~~~~#Gap_"+scope);
			
			for(var i = 0; i < scope+1; i++){
    		  before_gap_tweets.push(Weibo.list[title][i]);
    	  	}
    	  	for(var i = scope+1; i < Weibo.list[title].length; i++){
    		  after_gap_tweets.push(Weibo.list[title][i]);
    	  	}

			var _rData = data;

			
			if(title == 'geo_status'){
				_rData = _rData.statuses;
			}
						
			var _data = formatItems(_rData);
			var oldItems = _data.list;

			if(Weibo.list[title][Weibo.gapMarkerIndex[title]] && Weibo.list[title][Weibo.gapMarkerIndex[title]].is_gap){
         		Weibo.list[title][Weibo.gapMarkerIndex[title]].is_gap = false;
         		Weibo.list[title][Weibo.gapMarkerIndex[title]].is_marker = true;
         		Weibo.list[title][Weibo.gapMarkerIndex[title]].marker_class = 'old_marker';
         		var _marker = [{is_gap:false,is_marker: true,marker_class: 'old_marker'}];
         		var listWgt = Weibo.getFeedWgt(title);
         		controller.get(listWgt).mojo.noticeUpdatedItems(Weibo.gapMarkerIndex[title], _marker);
         	}
              			
			for(var i = 0; i < oldItems.length; i++){

    		  	var tweet_id = oldItems[i].id;
    		  	var last_before_id = before_gap_tweets[before_gap_tweets.length - 2].id;
    		  	var first_after_id = after_gap_tweets[0].id;
    		  
    		  	//avoid first-duplicate
    	      	if(tweet_id == last_before_id){
    	    	  	Mojo.Log.info("Gap Construction, first duplicate found");
    	    	  	continue;
    	      	}
    		  
    		  	//avoid overlap
    		  	if(tweet_id == first_after_id || tweet_id < first_after_id) {
    			  	Mojo.Log.info("Gap Construction, overlap found, stopping");
    			  	break;
    		  	}
    		  
    		  	gap_tweets.push(oldItems[i]);
			}
    	  				
    	  	if(gap_tweets.length == 0) {				
         		Mojo.Controller.getAppController().showBanner({"messageText": 'No missing info...'}, {}, Weibo.MainStageName);
         		var sIndex = before_gap_tweets.length;
         					
    	  	}else if(gap_tweets.length > 0) {
    		  	var new_gap = thisA.detectGap(gap_tweets[gap_tweets.length - 1], after_gap_tweets[0], gap_tweets.length);
        	  				
        	  	//add gap
				if(new_gap == true) {
					var gap_marker = {is_gap: true,max_id:_data.max_id};
            		gap_tweets.push(gap_marker);
            		Weibo.gapMarkerIndex[title] = before_gap_tweets.length + gap_tweets.length-1;
					var sIndex = before_gap_tweets.length;
					Weibo.gap_max_id[title] = gap_tweets[gap_tweets.length-2].id;
					Mojo.Log.info("~~~~~~#set_gap_max_Id_"+Weibo.gap_max_id[title]);
            				
				//add marker
				}else{
         			var marker = {is_marker: true,marker_class: 'new_marker'};
         			gap_tweets.push(marker);
         			Weibo.markerIndex[title] = before_gap_tweets.length + gap_tweets.length-1;
         			var sIndex = before_gap_tweets.length;
				}
        	  				
    	  	}

    	  	var _oldItems2 = gap_tweets.concat(after_gap_tweets);
    	  	Weibo.list[title] = before_gap_tweets.concat(gap_tweets).concat(after_gap_tweets);
    	  	model.items = Weibo.list[title];
    	  				
    	  	//controller.get('feedListWgt').mojo.setLength(Weibo.list[title].length);
    	  	var listWgt = Weibo.getFeedWgt(title);
			controller.get(listWgt).mojo.setLength(Weibo.list[title].length);
    	  	controller.get(listWgt).mojo.noticeUpdatedItems(0, model.items);
    	  	controller.assistant.loadTip(false);
			//controller.get('feedListWgt').mojo.revealItem(sIndex,true);
            
             
             /*
             Weibo.list[title] = before_gap_tweets.concat(gap_tweets).concat(after_gap_tweets);
             model.items = Weibo.list[title];
			 controller.modelChanged(model);
			 controller.assistant.loadTip(false);
			 controller.get('feedListWgt').mojo.revealItem(sIndex,true);
			 */
             
			//controller.assistant.showData(Weibo.list[title],sIndex);
    				
        }else{
			controller.assistant.showFailure();
        }

	},
	
	countGapItem:function(data,title,model,controller) {
		Mojo.Log.info("~~~~~~#countGapItem_"+title);
		Mojo.Log.info("~~~~~~#Gap_max_id"+Weibo.gap_max_id[title]);
		var thisA = this;
		var before_gap_tweets = [];
    	var after_gap_tweets = [];
    	var gap_tweets = [];
    	
		if (Weibo.gap_max_id[title] && Weibo.list[title]) {
			
			var scope = Weibo.gapMarkerIndex[title];
			Mojo.Log.info("~~~~~~#Gap_"+scope);
			
			var _l = Weibo.list[title].length;

			for(var i = 0; i < scope+1; i++){
    		  before_gap_tweets.push(Weibo.list[title][i]);
    	  	}
    	  	for(var i = scope+1; i < Weibo.list[title].length; i++){
    		  after_gap_tweets.push(Weibo.list[title][i]);
    	  	}
    	  

			var _rData = data;

			
			if(title == 'geo_status'){
				_rData = _rData.statuses;
			}
						
			var _data = formatItems(_rData);

			var oldItems = _data.list;

			if(_data.ids){
				var url = "http://api.t.sina.com.cn/statuses/counts.json";
				//var _url = Weibo.Oauth.oauthUrl(url,"GET");
				var parameters = [['ids', _data.ids]];
				var _url = Weibo.signRequest(url, parameters, "GET");
	
				this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(r){
              			var _oldItems = countStatus(oldItems,r.responseJSON);

						if(Weibo.list[title][Weibo.gapMarkerIndex[title]] && Weibo.list[title][Weibo.gapMarkerIndex[title]].is_gap){
         					Weibo.list[title][Weibo.gapMarkerIndex[title]].is_gap = false;
         					Weibo.list[title][Weibo.gapMarkerIndex[title]].is_marker = true;
         					Weibo.list[title][Weibo.gapMarkerIndex[title]].marker_class = 'old_marker';
         					var _marker = [{is_gap:false,is_marker: true,marker_class: 'old_marker'}];
         					var listWgt = Weibo.getFeedWgt(title);
							controller.get(listWgt).mojo.setLength(Weibo.list[title].length);
         					controller.get(listWgt).mojo.noticeUpdatedItems(Weibo.gapMarkerIndex[title], _marker);
         					//Weibo.list[title].splice(Weibo.gapMarkerIndex[title], 1);
         				}
              			
              			for(var i = 0; i < _oldItems.length; i++){

    		  				var tweet_id = _oldItems[i].id;
    		  
    		  				var last_before_id = before_gap_tweets[before_gap_tweets.length - 2].id;
    		  
    		  				var first_after_id = after_gap_tweets[0].id;
    		  
    		  				//avoid first-duplicate
    	      				if(tweet_id == last_before_id){
    	    	  				Mojo.Log.info("Gap Construction, first duplicate found");
    	    	  				continue;
    	      				}
    		  
    		  				//avoid overlap
    		  				if(tweet_id == first_after_id || tweet_id < first_after_id) {
    			  				Mojo.Log.info("Gap Construction, overlap found, stopping");
    			  				break;
    		  				}
    		  
    		  				gap_tweets.push(_oldItems[i]);
    	  				}
    	  				
    	  				if(gap_tweets.length == 0) {				
         					Mojo.Controller.getAppController().showBanner({"messageText": 'No missing info...'}, {}, Weibo.MainStageName);
         					var sIndex = before_gap_tweets.length;
         					
    	  				}else if(gap_tweets.length > 0) {
    		  				var new_gap = thisA.detectGap(gap_tweets[gap_tweets.length - 1], after_gap_tweets[0], gap_tweets.length);
        	  				
        	  				//add gap
							if(new_gap == true) {
								var gap_marker = {is_gap: true,max_id:_data.max_id};
            					gap_tweets.push(gap_marker);
            					Weibo.gapMarkerIndex[title] = before_gap_tweets.length + gap_tweets.length-1;
								var sIndex = before_gap_tweets.length;
								Weibo.gap_max_id[title] = gap_tweets[gap_tweets.length-2].id;
								Mojo.Log.info("~~~~~~#set_gap_max_Id_"+Weibo.gap_max_id[title]);
            				
							//add marker
							}else{
         						var marker = {is_marker: true,marker_class: 'new_marker'};
         						gap_tweets.push(marker);
         						Weibo.markerIndex[title] = before_gap_tweets.length + gap_tweets.length-1;
         						var sIndex = before_gap_tweets.length;
							}
        	  				
    	  				}
    	  				
    	  				
    	  				var _oldItems2 = gap_tweets.concat(after_gap_tweets);
    	  				//gap_tweets.push.apply(gap_tweets, after_gap_tweets);
    	  				//var _oldItems2 = gap_tweets;
    	  				
    	  				Weibo.list[title] = before_gap_tweets.concat(gap_tweets).concat(after_gap_tweets);
    	  				model.items = Weibo.list[title];
 
    	  				//controller.get('feedListWgt').mojo.setLength(_l);
    	  				var listWgt = Weibo.getFeedWgt(title);

    	  				controller.get(listWgt).mojo.noticeUpdatedItems(0, model.items);
    	  				controller.assistant.loadTip(false);
    	  				
    				
              		}.bind(this),
              		onFailure: this.loadItem_Failure.bind(this,controller)
        		});
        	}else{
        		//Mojo.Controller.getAppController().showBanner({"messageText": '_k'+resp.status}, {}, Weibo.MainStageName);
				controller.assistant.showFailure();
        	}
        }else{

			controller.assistant.showFailure();

        }

	},
	
	detectGap: function(before_gap, after_gap, gap_tweets_count) {
		Mojo.Log.error("^^^^^^ TimelineModel#detectGap");
	
		var to_load_count = Weibo.Prefs.count;

		var loaded_count = gap_tweets_count;
    
		if(loaded_count != 0){
			var count_condition = loaded_count >= 3/4 * to_load_count;
		}else if(loaded_count == 0) {
			count_condition = false;
		}
    
		var previous_tweet_time = before_gap.created_at;
		//previous_tweet_time = Date.fromString(previous_tweet_time);
	
		var next_tweet_time = after_gap.created_at;
		//next_tweet_time = Date.fromString(next_tweet_time);
	
		var time_difference = previous_tweet_time - next_tweet_time;
		var time_difference_condition = true;//time_difference > 30*1000;
	
		Mojo.Log.error("Count Condition: ", count_condition);
		Mojo.Log.error("Time Difference Condition: ", time_difference_condition);
	
		if(count_condition == true && time_difference_condition == true){
			return true;
		}else{
			return false;
		}
	},
	
	loadItem_Failure:function(controller,resp){
		Mojo.Log.info("~~~~~~#loadItem_Failure_"+resp.status);
		Mojo.Controller.getAppController().showBanner({"messageText": resp.statusText}, {}, Weibo.MainStageName);
		controller.assistant.showFailure();
	},
	
	loadUserInfo:function(name,model,controller){
		var thisA = this;
		var url = "http://api.t.sina.com.cn/users/show.json";
		//var _url = Weibo.Oauth.oauthUrl(url,"GET");
		
		var parameters = [['screen_name', name]];
		var _url = Weibo.signRequest(url, parameters, "GET");

		var userInfo = [];
	
		this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(e){
              			if(e.responseJSON){
              				var _userinfo = e.responseJSON;
              			}else{
              				//var _userinfo = JSON.parse(e.responseText);
							var _userinfo = e.responseText.evalJSON();
              			}
              			
              			if(_userinfo.verified === true){
							_userinfo.verified = "<font color='#ff0000'>V</font>";
						}else{
							_userinfo.verified = "";
						}
						
						if(_userinfo.gender === 'm'){
							_userinfo.gender = "男";
							_userinfo.gender2 = "他";
						}else if(_userinfo.gender === 'f'){
							_userinfo.gender = "女";
							_userinfo.gender2 = "她";
						}else{
							_userinfo.gender = "未知";
							_userinfo.gender2 = "TA";
						}
						
						if(_userinfo.status != null){
							_userinfo.status.created_at = formatDate(_userinfo.status.created_at);
						}
						
						_userinfo.created_at = formatDate(_userinfo.created_at,'full');
						
              			userInfo.push(_userinfo);
              			if(name === Weibo.Prefs.screen_name){
              				Weibo.Prefs.myInfos = userInfo;
              			}
              			controller.assistant.showData(userInfo);

              		}.bind(this),
              		onFailure: this.loadItem_Failure.bind(this,controller)
            });
	},
	
	loadUserItem:function(name,cursor,model,controller,type){
		var thisA = this;
		var _type = type ? type : "friends";
		
		var title = "user_"+name+"_"+_type;
		var _cursor = cursor || -1;
		Weibo.list[title] = Weibo.list[title] || [];
		
		
		var url = _type === "friends" ? "http://api.t.sina.com.cn/statuses/friends.json?" : "http://api.t.sina.com.cn/statuses/followers.json";
		
		var parameters = [['screen_name', name],['cursor', _cursor],['count', Weibo.Prefs.count]];
		var _url = Weibo.signRequest(url, parameters, "GET");
		
		//var _url = Weibo.Oauth.oauthUrl(url,"GET");

		var userInfo = [];
	
		this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(e){
              			
              			if(e.responseJSON){
              				var _r = e.responseJSON;
              			}else{
              				var _r = JSON.parse(e.responseText);
              			}
              			
              			var _oldItems = formatUserItems(_r.users);
						
              			Weibo.cursor[title] = _r.next_cursor;
              			
              			var marker = {is_marker: true,marker_class: 'new_marker'};
         			
         				if(Weibo.list[title].length > 0){
         				
         					if(Weibo.list[title][Weibo.markerIndex[title]] && Weibo.list[title][Weibo.markerIndex[title]].is_marker){
         						Weibo.list[title][Weibo.markerIndex[title]].marker_class = 'old_marker';
         					}
         				
         					Weibo.list[title].push(marker);
         					Weibo.markerIndex[title] = Weibo.list[title].length-1;
         					var sIndex = Weibo.markerIndex[title];
         				
         				}else{
         					var sIndex = 0;
         				}
              			
              			Weibo.list[title] = Weibo.list[title].concat(_oldItems);
						controller.assistant.showData(Weibo.list[title],sIndex);
    					
              		}.bind(this),
              		onFailure: this.loadItem_Failure.bind(this,controller)
            });
	},
	
	loadHotUser:function(cate,model,controller){
		var thisA = this;

		var title = "user_hot_"+cate;

		var url = "http://api.t.sina.com.cn/users/hot.json";
		//var _url = Weibo.Oauth.oauthUrl(url,"GET");
		
		var parameters = [['category', cate],['count', 20]];
		var _url = Weibo.signRequest(url, parameters, "GET");
	
		this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(e){
              			
              			if(e.responseJSON){
              				var _r = e.responseJSON;
              			}else{
              				var _r = JSON.parse(e.responseText);
              			}
              			
              			var _oldItems = formatUserItems(_r);

						controller.assistant.showData(_oldItems,-1);
    					
              		}.bind(this),
              		onFailure: this.loadItem_Failure.bind(this,controller)
            });
	},

	loadGeoUser:function(para,model,controller){
		var thisA = this;

		var url = "http://api.t.sina.com.cn/search/geo/users.json";
		var parameters = [['longitude', para.lon],['latitude', para.lat],['page', para.page],['sort_type', 0],['base_app', para.app],['count', 20]];
		var _url = Weibo.signRequest(url, parameters, "GET");

		Weibo.list['geoUser'] = Weibo.list['geoUser'] ? Weibo.list['geoUser'] : [];
	
		this.req = new Ajax.Request(_url, {
              		method: "get",
              		requestHeaders:['Accept-Encoding','gzip,deflate'],
              		onSuccess: function(e){
              			
              			if(e.responseJSON){
              				var _r = e.responseJSON.users;
              			}else{
              				var _r = JSON.parse(e.responseText).users;
              			}
              			
              			var _oldItems = formatUserItems(_r);

						if(_oldItems.length > 0){

							var marker = {is_marker: true,marker_class: 'new_marker'};

							if(Weibo.list['geoUser'].length > 0){
							
								if(Weibo.list['geoUser'][Weibo.markerIndex['geoUser']] && Weibo.list['geoUser'][Weibo.markerIndex['geoUser']].is_marker){
									Weibo.list['geoUser'][Weibo.markerIndex['geoUser']].marker_class = 'old_marker';
								}
							
								Weibo.list['geoUser'].push(marker);
								Weibo.markerIndex['geoUser'] = Weibo.list['geoUser'].length-1;
								var sIndex = Weibo.markerIndex['geoUser'];
							
							}else{
								var sIndex = 0;
							}
							
							Weibo.list['geoUser'] = Weibo.list['geoUser'].concat(_oldItems);
							controller.assistant.showData(Weibo.list['geoUser'],sIndex);
						
						}else{
							controller.assistant.showNone();
						}

    					
              		}.bind(this),
              		onFailure: this.loadItem_Failure.bind(this,controller)
            });
	},
	
	destroy: function(title,url,data,eventItem,model,target){
		var appController = Mojo.Controller.getAppController();
        var stageController = appController.getStageController(Weibo.MainStageName);
		var currentScene = stageController.activeScene();
		
		currentScene.showAlertDialog({
			onChoose: function(value) {
				if(value === "OK"){

					var parameters = data;
					var postBody = Weibo.signRequest(url, parameters, "POST");

					var req = new Ajax.Request(url, {
						method : 'post', 
						evalJSON : 'force',
						postBody: postBody,
						contentType: 'application/x-www-form-urlencoded',
						onSuccess: function(e){
              				if(Weibo.list[title].length > 0){
              					var deleteIndex = Weibo.list[title].indexOf(eventItem);
    							Weibo.list[title].splice(deleteIndex, 1);
    							model.items = Weibo.list[title];
								target.modelChanged(model);
							}
              			}
					});
		
					
					/*
					var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
        	
        			var request = new Ajax.Request(url, {
						requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
						method: "post",
                		evalJSON: "true",
                		onSuccess: function(e){
              					var deleteIndex = data.indexOf(eventItem);
    							data.splice(deleteIndex, 1);
    							model.items = data;
								target.modelChanged(model);
              				}
            		});
            		*/
				}
			},
    		title: $L("确认删除吗?"),
    		choices:[
         				{label:$L("OK"), value:"OK", type:'negative'},    
         				{label:$L("Cancel"), value:"cancel", type:'dismiss'}    
    			]
        });	
	},
	
	resetCount: function(type){
		Mojo.Log.error("^^^^^^ resetCount_"+type);

		var url = "http://api.t.sina.com.cn/statuses/reset_count.json";

		var parameters = [['type', type]];

		var postBody = Weibo.signRequest(url, parameters, "POST");

		var req = new Ajax.Request(url, {
			method : 'post', 
			evalJSON : 'force',
			postBody: postBody,
			contentType: 'application/x-www-form-urlencoded',
			onSuccess:Mojo.doNothing,
         	onFailure:Mojo.doNothing
		});
	},

	resetCountType: function(title){
		if(title === "comment"){
			Weibo.Api.resetCount(1);
		}else if(title === "mention"){
			Weibo.Api.resetCount(2);
		}else if(title === "dm"){
			Weibo.Api.resetCount(3);
		}
	},
	
	cancelReq:function(){
		Mojo.Log.info("^^^^^^#cancelReq");
		try {
			Mojo.Log.info("^^^^^^#run_cancelReq");
			clearTimeout(this.refreshTimeOut);
			this.req.transport.abort();
		} catch (e) {
		
		}
		
	}
	


});