
Weibo.Cookie = ({
        
    initialize: function()  {
        // Update globals with preferences or create it.
        // With v0.4 start migrating preferences
        this.cookieData = new Mojo.Model.Cookie("comPalmAppWeiboPrefs");
        var oldWeiboPrefs = this.cookieData.get();

		if (oldWeiboPrefs) {
			
			Weibo.uid = oldWeiboPrefs.uid;
			Weibo.utitle = oldWeiboPrefs.utitle || "";
			Weibo.access_token = oldWeiboPrefs.access_token;
			Weibo.access_token_secret = oldWeiboPrefs.access_token_secret;
			Weibo.hasCache = oldWeiboPrefs.hasCache;
			this.storeCookie();
		}
        
    },
    
    storeCookie: function() {
        this.cookieData.put(    {  
            uid: Weibo.uid,
            utitle:Weibo.utitle,
            access_token: Weibo.access_token,
            access_token_secret: Weibo.access_token_secret,
            hasCache:Weibo.hasCache
        });
    },

	/////////

	getPrefs: function() {
		var prefs_cookie = new Mojo.Model.Cookie("WeiboPrefs");
		return prefs_cookie.get();
	},

	setPrefsDefaults: function() {
		var prefs_cookie = new Mojo.Model.Cookie("WeiboPrefs");
		prefs_cookie.put(Weibo.defaultPrefs);
		return prefs_cookie.get();
	},

	savePrefs: function() {
		var prefs_cookie = new Mojo.Model.Cookie("WeiboPrefs");
		prefs_cookie.put(Weibo.Prefs);
	},

	loadPrefs: function() {
		var prefs = this.getPrefs();
		if(!prefs){
			prefs = this.setPrefsDefaults();
			Weibo.Prefs = prefs;
		}else {
			Weibo.Prefs = prefs;
		}   
	},

	/////////

	getAccounts: function() {
		var accounts_cookie = new Mojo.Model.Cookie("WeiboAccounts");
		return accounts_cookie.get();
	},

	loadAccounts: function() {
		var accounts = this.getAccounts();
		if(!accounts){
			return;
		}else {
			Weibo.Accounts = accounts.accounts;
		}
	},
	
	getAccountById: function(account_id) {
		var account = null;
		account = Weibo.Accounts.find(function(acc){
			if(acc.uid == account_id)
			return true;
		});
		return account;
	},
	
	saveAccounts: function() {
		var accounts = new Mojo.Model.Cookie("WeiboAccounts");
		accounts.put({accounts:Weibo.Accounts});
	},

	createAccount: function(account_object) {
		Weibo.Accounts.push(account_object);   
		this.saveAccounts();
	},

	updateAccount: function(account_object) {  
		for(var i=0; i < Weibo.Accounts.length; i++) {
			if( Weibo.Accounts[i].uid == account_object.uid ){
				Weibo.Accounts[i] = account_object;
				this.saveAccounts();       
			}
		}
	},

	deleteAccount: function(account_id) {
   
		for(var i=0; i<Weibo.Accounts.length; i++){
			if(Weibo.Accounts[i].uid == account_id) {
				//delete the account
				Weibo.Accounts.splice(i, 1);
				//fix the array
				Weibo.Accounts = Weibo.Accounts.compact();
				//save this change
				this.saveAccounts();
				//if this account is the default account, then update the default account pref
				if(Weibo.Prefs.uid == account_id){
					if(Weibo.Accounts.length == 0){ //if it was the only account
						//set the prefs
						Weibo.Prefs.uid = null;
						Weibo.Prefs.access_token = '';
						Weibo.Prefs.access_token_secret = '';
						//save this change
						this.savePrefs();
					}else {
						//find the first account and make it default
						Weibo.Prefs.uid = Weibo.Accounts[0].uid;
						Weibo.Prefs.screen_name =  Weibo.Accounts[0].screen_name;
						Weibo.Prefs.access_token =  Weibo.Accounts[0].access_token;
						Weibo.Prefs.access_token_secret =  Weibo.Accounts[0].access_token_secret;
						//save this change
						this.savePrefs();
					}
				}
			}
		}
   
	}

});