
Weibo.Notify = ({
    
    dashBoard: function(title){
    	var dName = Weibo.Dashboard[title];
		var text = Weibo.PanelName[title];
		var num = title === "status" ? 'new' : Weibo.newStatusNum[title];
		
		if(num > 0 || num == 'new'){
			var appController = Mojo.Controller.getAppController();
			var dashboardStage = appController.getStageController(dName);
			var icon = '&nbsp; &nbsp; <img src="images/dashboard/'+title+'.png" align="absmiddle" />';
			var unit = title === "followers" ? "根" : "条";
			var mText = title === "status" ? "有新微博" : num+unit+"新"+text;
			Mojo.Controller.getAppController().showBanner({"icon":"sailor.png","messageText": mText}, {}, Weibo.MainStageName);
			if(Weibo.Prefs.updateMedia === true){
					Mojo.Controller.getAppController().playSoundNotification("media","changeSound.mp3");
				}
				if(Weibo.Prefs.updateVibrate === true){
					Mojo.Controller.getAppController().playSoundNotification("vibrate","");
				}
	        if (dashboardStage) {
				dashboardStage.delegateToSceneAssistant("update",mText+",点击查看",num);
			} else {
				var pushDScene = function(title,text,num, stageController) {
					stageController.pushScene('dashboard', title,text,num);
				};
				
				
				appController.createStageWithCallback({"name": dName, "lightweight": true},pushDScene.bind(this,title,mText+",点击查看"+icon,num), "dashboard");
			}
		}
    },
    
	unreadInfo: function(){
		Mojo.Log.info("^^^^^^#unreadInfo");
		
		var app_controller = Mojo.Controller.getAppController();
		var stage_controller = app_controller.getStageController(Weibo.MainStageName);
	
		var thisA = this;
		var url = "http://api.t.sina.com.cn/statuses/unread.json?with_new_status=1&since_id="+Weibo.since_id['home'];
		var _url = Weibo.Oauth.oauthUrl(url,"GET");
		
		var request = new Ajax.Request(_url, {
    		method: "get",
    		requestHeaders:['Accept-Encoding','gzip,deflate'],
        	onSuccess: function(e){
				Mojo.Log.info("^^^^^^#check_unread_success");
				
				Weibo.unreadComments = e.responseJSON.comments;
				Weibo.unreadDm = e.responseJSON.dm;
				Weibo.unreadMentions = e.responseJSON.mentions;
				Weibo.unreadFollowers = e.responseJSON.followers;
				
				Weibo.unreadStatus = e.responseJSON.new_status;
				
				Weibo.newStatusNum["totals"] = Weibo.unreadComments + Weibo.unreadDm + Weibo.unreadMentions + Weibo.unreadFollowers;
				
				
				if(Weibo.Prefs.notifyStatus === true && Weibo.unreadStatus>0){
            		Mojo.Log.info("^^^^^^#have_unread_status");
            		Weibo.newStatusNum["status"] = Weibo.unreadStatus;
            		setTimeout(function(){thisA.dashBoard("status")}, 4*1000);
            	}
            	
            	if(Weibo.Prefs.notifyComment === true && Weibo.unreadComments>0){
            		Mojo.Log.info("^^^^^^#have_unread_comment");
            		Weibo.newStatusNum["comment"] = Weibo.unreadComments;
            		thisA.dashBoard("comment");
            	}
            	
            	if(Weibo.Prefs.notifyMention === true && Weibo.unreadMentions>0){
            		Mojo.Log.info("^^^^^^#have_unread_mention");
            		Weibo.newStatusNum["mention"] = Weibo.unreadMentions;
            		//thisA.dashBoard("mention");
            		setTimeout(function(){thisA.dashBoard("mention")}, 1*1000);
            	}
            	
            	if(Weibo.Prefs.notifyDm === true && Weibo.unreadDm>0){
            		Mojo.Log.info("^^^^^^#have_unread_dm");
            		Weibo.newStatusNum["dm"] = Weibo.unreadDm;
            		//thisA.dashBoard("dm");
            		setTimeout(function(){thisA.dashBoard("dm")}, 2*1000);
            	}
            	
            	if(Weibo.Prefs.notifyFollowers === true && Weibo.unreadFollowers>0){
					Mojo.Log.info("^^^^^^#have_unread_follower");
					Weibo.newStatusNum["followers"] = Weibo.unreadFollowers;
					//thisA.dashBoard("followers");
					setTimeout(function(){thisA.dashBoard("followers")}, 3*1000);
            	}
			
			},
			onFailure: function(e){
				Mojo.Log.info("^^^^^^#check_unread_failure"+e.status);
			}
    	});
    
	}

});