
Weibo.Opt = ({

	appController:function(){
		return Mojo.Controller.getAppController();
	},
	
	stageController:function(){
		var ac = this.appController();
		return ac.getActiveStageController();
	},
	
	currentScene:function(){
		var sc = this.stageController();
		return sc.activeScene();
	},
		
	pageClick: function(event,title,model,controller){
		
		var eventSrc = event.originalEvent.target || event.target;
	
		var target = eventSrc.id;
		var name = eventSrc.title ? eventSrc.title : '';
		var cname = eventSrc.className != null ? eventSrc.className : '';
		var img_url = eventSrc.src != null ? eventSrc.src : '';
		//var oldText = eventSrc.alt;
		
		//Mojo.Controller.getAppController().showBanner({"messageText": '_t'+target}, {}, Weibo.MainStageName);
		
		var appController = Mojo.Controller.getAppController();
		var stageController = appController.getActiveStageController();
		var currentScene = stageController.activeScene();
	
		if (target === "user") {
			if(name == Weibo.Prefs.screen_name){
				Weibo.goHome('my');
			}else{
				if(Weibo.Prefs.clickUser === "status"){
					this.userTimeline(name);
				}else{
					var _userInfo = [];
					var _author = event.item.user ? event.item.user.screen_name : '';
					var _rt_author = event.item.retweeted_status ? event.item.retweeted_status.user.screen_name : '';
					if(name === _author){
						_userInfo.push(event.item.user);
					}else if(name === _rt_author){
						_userInfo.push(event.item.retweeted_status.user);
					}
			
					stageController.pushScene("user",name,_userInfo);
				}
				
				
			}

		}else if(target === "tweet_user"){
			if(name == Weibo.Prefs.screen_name){
				Weibo.goHome('my');
			}else{
				var _userInfo = [];
				_userInfo.push(event.item.user);
				stageController.pushScene("user",name,_userInfo);
			}

		}else if(target === "pic"){	
			stageController.pushScene("viewImage",cname,name,img_url);
			
		}else if(target === "viewurl"){	
			var thisA = this;
			currentScene.popupSubmenu({
    				onChoose: function(command) {
    					if(command === 'openurl'){
    						thisA.openUrl(name);

    					}else if(command === 'miniopenurl'){
    						//stageController.pushScene("browser",name);
    						thisA.openMiniBrowser(name);

    					}else if(command === 'copy'){
    						thisA.copyText(name);
    					}
					},
        			placeNear: eventSrc,
        			items: [
        				{label:"打开链接(自带浏览器)",command:"miniopenurl"},
        				{label:"打开链接(系统浏览器)",command:"openurl"},
        				{label:"复制链接",command:"copy"}
        			]
    			});
			
		}else if(target === "geoIcon"){	
			var lat = event.item.geo.coordinates[0];
			var lon = event.item.geo.coordinates[1];
			//stageController.pushScene({name:"map", disableSceneScroller: true},lat,lon);

			this.openMap(lat,lon);

		}else if(target === "viewComment" || target === "viewRtComment"){
        	var cid = target === "viewComment" ? event.item.id : event.item.retweeted_status.id;
        	var _oData = target === "viewComment" ? event.item : event.item.retweeted_status;
			stageController.pushScene("viewComment",cid,_oData);
			
		}else if(target === "comment_content" || target === "comment_title" || target === "comment_time" || target === "comment_source"){
        	
			currentScene.popupSubmenu({
    				onChoose: function(command) {
    					if(command == 'reply'){
    						var _id = event.item.status.id;
							var _cid = event.item.id;
							var _reContent = "回复@"+event.item.user.screen_name+"：";
							var postData = [{"title":"reply","titleName":"评论微博","id":_id,"cid":_cid,"reContent":_reContent,"status":event.item}];
							stageController.pushScene("update",postData);
							
    					}else if(command == 'view'){
    						var cid = event.item.status.id;
        					var _oData = event.item.status;
							stageController.pushScene("viewComment",cid,_oData);
							
    					}else if(command == 'del'){
    						var _id = event.item.id;
							var url = "http://api.t.sina.com.cn/statuses/comment_destroy/"+_id+".json";
							var _data = [['id', _id]];
							Weibo.Api.destroy(title,url,_data,event.item,model,controller);

    					}
					},
        			placeNear: eventSrc,
        			items: [
        				{label:"回复",command:"reply"},
        				{label:"查看",command:"view"},
						{label:"删除",command:"del"}
        			]
    			});
    			
		
		}else if(target === "public"){
			var _url = "http://api.t.sina.com.cn/statuses/public_timeline.json";
			var _para = [['count', Weibo.Prefs.count]];
			var _title = "home_public";
			var _data = {"url":_url,"para":_para,"title":_title,"name":"public","type":"public","titleName":"随便看看"};
			stageController.pushScene("listStatus",_data);
			
		}else if(target === "hotRt"){
			var _url = "http://api.t.sina.com.cn/statuses/hot/repost_daily.json";
			var _para = [['count', 30]];
			var _title = "home_hotRt";
			var _data = {"url":_url,"para":_para,"title":_title,"titleName":"热门转发","type":"daily"};
			stageController.pushScene("listStatus",_data);
			
		}else if(target === "hotCm"){
			var _url = "http://api.t.sina.com.cn/statuses/hot/comments_daily.json";
			var _para = [['count', 30]];
			var _title = "home_hotCm";
			var _data = {"url":_url,"para":_para,"title":_title,"titleName":"热门评论","type":"daily"};
			stageController.pushScene("listStatus",_data);
			
		}else if(target === "hotTp"){
			stageController.pushScene("listTopic");
			
		}else if(target === "mytopic"){
			stageController.pushScene("listTopic","my");
			
		}else if(target === "hotUser"){
			var _data = {"name":"default","type":"hot","titleName":"名人堂"};
			stageController.pushScene("listUser",_data);
			
		}else if(target === "geoStatus"){
			var _url = "http://api.t.sina.com.cn/search/geo/statuses.json";
			var _para = [];
			var _title = "geo_status";
			var _data = {"url":_url,"para":_para,"title":_title,"titleName":"周边微博"};
			stageController.pushScene("listStatus",_data);

		}else if(target === "geoUser"){
			var _data = {"name":"default","type":"geo","titleName":"周边用户"};
			stageController.pushScene("listUser",_data);
			
		}else if(target === "topic"){
			stageController.pushScene("search",name);
			
		}else if(target === "fav_timeline"){
			this.favTimeline(name);
			
		}else if(target === "user_timeline"){
			var openType = name == Weibo.Prefs.screen_name ? 'new' : 'old';
			this.userTimeline(name,openType);
			
		}else if(target === "user_friends"){
			if(name){
				var openType = name == Weibo.Prefs.screen_name ? 'new' : 'old';
				this.userFriends(name,openType);
			}
			
		}else if(target === "user_followers"){
			if(name){
				var openType = name == Weibo.Prefs.screen_name ? 'new' : 'old';
				this.userFollowers(name,openType);
			}

		}else if(target === "user_pm"){
			if(name){
				stageController.pushScene("pm",name);
			}
		
		}else if(target === "pm_content"){
			var thisA = this;
			//var _sharedText = data[event.index].sender.screen_name+":"+data[event.index].text;
			currentScene.popupSubmenu({
    				onChoose: function(command) {
    					if(command == 'repm'){
    						stageController.pushScene("pm",event.item.sender.screen_name);
    					}else if(command == 'dialog'){
    						stageController.pushScene("listUserDm",event.item.sender.screen_name);
    					}else if(command == 'delDm'){
    						var _id = event.item.id;
							var url = "http://api.t.sina.com.cn/direct_messages/destroy/"+_id+".json";
							var _data = [['id', _id]];
							Weibo.Api.destroy(title,url,_data,event.item,model,controller);
    					}
					},
        			placeNear: eventSrc,
        			items: [
        				{label:"回复",command:"repm"},
        				{label:"对话模式",command:"dialog"},
						{label:"删除",command:"delDm"}
        			]
    			});
    			
    	}else if(target === "pm_del"){
			var _id = event.item.id;
			var url = "http://api.t.sina.com.cn/direct_messages/destroy/"+_id+".json";
			var _data = [['id', _id]];
			Weibo.Api.destroy(title,url,_data,event.item,model,controller);
			
		}else if(target === "mentions"){
			this.mention(name);

		}else if(target === "comment"){
			this.comment(event.item);
		
		}else if(target === "repost"){
			this.repost(event.item);
			
		
			
		}else if(target === "reply" || target === "commentListItemContent" || target === "commentListItemFooter"){
			var _id = event.item.status.id;
			var _cid = event.item.id;
			var _reContent = "回复@"+event.item.user.screen_name+"：";
			var postData = [{"title":"reply","titleName":"评论微博","id":_id,"cid":_cid,"reContent":_reContent,"status":event.item}];
			stageController.pushScene("update",postData);
		
		}else if(target === "dmListUserContent" || target === "dmListUserFooter"){
			stageController.pushScene("listUserDm",event.item.screen_name);
			
		}else if(target === "dmListUserItem" || target === "dmListUserItemFooter"){
			var thisA = this;
			var _sharedText = event.item.sender.screen_name+":"+event.item.text;
			currentScene.popupSubmenu({
    				onChoose: function(command) {
    					if(command){
							if(command == 'copy'){
								thisA.copyText(_sharedText);
							}else if(command == 'email'){
								thisA.emailText("转自新浪微博",_sharedText);
							}else if(command == 'sms'){
								thisA.smsText(_sharedText);
							}else if(command == 'delDm'){
								var _id = event.item.id;
								var url = "http://api.t.sina.com.cn/direct_messages/destroy/"+_id+".json";
								var _data = [['id', _id]];
								Weibo.Api.destroy(title,url,_data,event.item,model,controller);
							}
						}
					},
    				//toggleCmd: this.title,
        			placeNear: eventSrc,
        			items: [
        				{label:"删除",command:"delDm"},
        				{label:"复制到剪贴板",command:"copy"},
        				{label:"发Email",command:"email"},
						{label:"发短信",command:"sms"}
        			]
    			});
			
		
		}else if(target === "more"){
			var thisA = this;

			var _sharedText = event.item.user.screen_name+":"+event.item.OldText;
			var _menu_item = [
        				{label:"发私信",command:"pm"},
        				{label:"发Email",command:"email"},
						{label:"发短信",command:"sms"}
        			];
        	
        	if(event.item.geo != null){
        		_menu_item.push({label:"查看地图",command:"geo"});
        	}
        	
        	if(event.item.user.screen_name === Weibo.Prefs.screen_name){
        		_menu_item.push({label:"删除",command:"del"});
        	}
			currentScene.popupSubmenu({
    				onChoose: function(command) {
						if(command){
							if(command == 'pm'){
								stageController.pushScene("pm",event.item.user.screen_name);
							}else if(command == 'email'){
								thisA.emailText("转自新浪微博",_sharedText);
							}else if(command == 'sms'){
								thisA.smsText(_sharedText);
							}else if(command == 'del'){
								var _id = event.item.id;
								var url = "http://api.t.sina.com.cn/statuses/destroy/"+_id+".json";
								var _data = [['id', _id]];
								Weibo.Api.destroy(title,url,_data,event.item,model,controller);
							}else if(command == 'geo'){
								var lat = event.item.geo.coordinates[0];
								var lon = event.item.geo.coordinates[1];
								Weibo.Opt.openMap(lat,lon);
								//stageController.pushScene("map",lat,lon);
							}
						}
					},
    				//toggleCmd: this.title,
        			placeNear: eventSrc,
        			items: _menu_item
    			});

		}else if(target === "clipboard"){
			var _copyData = event.item.user.screen_name+":"+event.item.OldText;
			//var _copyData = data[event.index].retweeted_status.user.screen_name+":"+data[event.index].retweeted_status.OldText;
			this.copyText(_copyData);
			
		
		}else if(target === "fav"){
			/*
			var url = "http://api.t.sina.com.cn/favorites/create.json?id="+name;
			var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
        	
        	var request = new Ajax.Request(url, {
				requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
				method: "post", 
                evalJSON: "true",
                onSuccess: function(e){
					Mojo.Log.info("^^^^^^ #fav_status_"+e.status);
					eventSrc.className = "drawer_menu_unfav";
					eventSrc.id = "unfav";
				}
            });
			*/

			var url = "http://api.t.sina.com.cn/favorites/create.json";
			var parameters = [['id', name]];

			var postBody = Weibo.signRequest(url, parameters, "POST");

			var req = new Ajax.Request(url, {
				method : 'post', 
				evalJSON : 'force',
				postBody: postBody,
				contentType: 'application/x-www-form-urlencoded',
				onSuccess: function(e){
						Mojo.Log.info("^^^^^^ #fav_status_"+e.status);
						eventSrc.className = "drawer_menu_unfav";
						eventSrc.id = "unfav";
						Mojo.Controller.getAppController().showBanner({"messageText": "Favorites"}, {}, Weibo.MainStageName);

              		} 
				});

            
		}else if(target === "unfav"){
			/*
			var url = "http://api.t.sina.com.cn/favorites/destroy/"+name+".json";
			var oHeader = Weibo.Oauth.oauthHeader(url,"POST");
        	
        	var request = new Ajax.Request(url, {
				requestHeaders:['Authorization',oHeader,'Accept-Encoding','gzip,deflate'],
				method: "post", 
                evalJSON: "true",
                onSuccess: function(e){
					Mojo.Log.info("^^^^^^ #fav_status_"+e.status);
					eventSrc.className = "drawer_menu_fav";
					eventSrc.id = "fav";
				}
            });
			*/

			var url = "http://api.t.sina.com.cn/favorites/destroy/"+name+".json";
			var parameters = [['id', name]];

			var postBody = Weibo.signRequest(url, parameters, "POST");

			var req = new Ajax.Request(url, {
				method : 'post', 
				evalJSON : 'force',
				postBody: postBody,
				contentType: 'application/x-www-form-urlencoded',
				onSuccess: function(e){
						Mojo.Log.info("^^^^^^ #fav_status_"+e.status);
						eventSrc.className = "drawer_menu_fav";
						eventSrc.id = "fav";
						Mojo.Controller.getAppController().showBanner({"messageText": "Cancel Favorites"}, {}, Weibo.MainStageName);
	
              		} 
				});
			
		}else if(target === "timeline_gap"){
			Mojo.Log.info("~~~~~~#operate_timeline_gap_max_id:"+event.item.max_id);
			Weibo.Api.cancelReq();

			if(name == 'home' && Weibo.homeFeature > 0){
				var _name = 'home_featrue_'+Weibo.homeFeature;
			}else{
				var _name = name;
			}

			controller.assistant.loadTip(true);
			Weibo.gapMarkerIndex[_name] = event.index;
			Weibo.gap_max_id[_name] = event.item.max_id;
			//Weibo.gap_max_id[name] = data[event.index-1].id;
			var url = Weibo.getUrl(name,'gap');

			setTimeout(function(){
				Weibo.Api.loadItem(url,_name,model,controller,'gap');
			}, 200);
    		

		}else if(target === "timeline_marker" || target === "srcStatus" || target === "pbox" || target === "operateIconMenu" || target === "messageMenu" || target === "otherBox"){
		
		}else{
			if (event.item.open == true)   {
				event.item.open = false;
				event.item.openSub = 'false';
			} else {
				event.item.open = true;
				event.item.openSub = 'true';
				
			}
			controller.modelChanged(event.item, this);
			/*
			
			if (event.item.open === true){
				controller.get('feedListWgt').mojo.revealItem(event.index+1,true);
			}
			*/
		}
	},
	
	repost: function(data) {
		var postData = [{"title":"repost","titleName":"转发微博","postSet":"first","status":data}];
		this.stageController().pushScene("update",postData);
	},
	
	comment: function(data) {
		var postData = [{"title":"comment","titleName":"评论微博","status":data}];
		this.stageController().pushScene("update",postData);
	},
	
	mention: function(name) {
		var postData = [{"title":"update","titleName":"发布微博","oldText":"对@"+name+" 说："}];
        this.stageController().pushScene("update",postData);
	},
	
	userTimeline: function(name,openType) {
		var _openType = openType || 'new';
		var _url = "http://api.t.sina.com.cn/statuses/user_timeline.json";
		var _para = [['count', Weibo.Prefs.count],['screen_name', name]];
		var _title = "home_user_timeline";
		var _data = {"url":_url,"para":_para,"title":_title,"name":name,"type":"status","titleName":name};
		
		if(_openType === 'old'){
			this.stageController().swapScene({transition: Mojo.Transition.crossFade,name: "listStatus"},_data);
		}else{
			this.stageController().pushScene("listStatus",_data);
		}
		
	},
	
	userFollowers: function(name,openType) {
		var _openType = openType || 'new';
		var _data = {"name":name,"type":"followers","titleName":name};
		
		if(_openType === 'old'){
			this.stageController().swapScene({transition: Mojo.Transition.crossFade,name: "listUser"},_data);
		}else{
			this.stageController().pushScene("listUser",_data);
		}
		
	},
	
	userFriends: function(name,openType) {
		var _openType = openType || 'new';
		var _data = {"name":name,"type":"friends","titleName":name};

		if(_openType === 'old'){
			this.stageController().swapScene({transition: Mojo.Transition.crossFade,name: "listUser"},_data);
		}else{
			this.stageController().pushScene("listUser",_data);
		}
	},
	
	favTimeline: function(name) {
		var _url = "http://api.t.sina.com.cn/favorites.json?count="+Weibo.Prefs.count;
		var _para = [['count', Weibo.Prefs.count]];
		var _title = "home_fav_"+name;
		var _data = {"url":_url,"para":_para,"title":_title,"name":name,"type":"favs","titleName":name,"loadType":"page"};
		this.stageController().pushScene("listStatus",_data);
	},

	emailText: function(subject,content) {
		Mojo.Log.info("^^^^^^ Operate#emailText");
		var cs = this.currentScene();
		cs.serviceRequest("palm://com.palm.applicationManager", {
			method: 'open',
			parameters: {
				id: "com.palm.app.email",
				params: {
					summary: subject,
					text: content
				}
			}
		}); 
	},

	smsText: function(message) {
		Mojo.Log.info("^^^^^^ Operate#smsText");
		var cs = this.currentScene();
		cs.serviceRequest('palm://com.palm.applicationManager', {
			method: 'launch',
			parameters: {
			id: 'com.palm.app.messaging',
			params: {
				messageText: message
             }
			}
		});
	},
	
	goMaps: function(lat,lon) {
		Mojo.Log.info("^^^^^^ Operate#goMaps");
		var cs = this.currentScene();
		cs.serviceRequest('palm://com.palm.applicationManager', { 
				method: 'launch', 
				parameters: { 
					id: 'com.palm.app.maps',
					params: { 
						location: {lat: lat, lng: lon, acc: 30},
						//query: "Pizza"
					} 
				}  
			}); 
	},

	copyText: function(text) {
		Mojo.Log.info("^^^^^^ Operate#copyText");
		var sc = this.stageController();
		var cs = this.currentScene();
		sc.setClipboard(text,true);
		Mojo.Controller.getAppController().showBanner({"messageText": "内容已复制到剪贴板"}, {}, Weibo.MainStageName);
		/*
		cs.showAlertDialog({
				onChoose: function() {},
    			title: $L("已复制到剪贴板"),
    			choices:[{label:$L("OK"), value:""}]
			});
		*/
	},
	
	openUrl: function(url) {
		Mojo.Log.info("^^^^^^ Operate#smsText");
		var cs = this.currentScene();
		cs.serviceRequest('palm://com.palm.applicationManager', {
			method: 'open',
			parameters: {
			id: 'com.palm.app.browser',
			params: {
				target: url
             }
			}
		});
	},

	openMiniBrowser: function(url){
		var appController = Mojo.Controller.getAppController();
		var stageController = appController.getStageController("WeiboMiniBrowserStage");

		if (stageController){
			stageController.activate();
			stageController.delegateToSceneAssistant("openUrl",url);
		}else{
			var pushMainScene = function(stageController) {
				stageController.pushScene('browser',url);
			};
			appController.createStageWithCallback({"name": "WeiboMiniBrowserStage", "lightweight": true}, pushMainScene,"card");
		}
	},

	openMap: function(lat,lon){
		if(Weibo.Prefs.mapType == 'google'){
			var _map = "map";
		}else{
			var _map = "sogouMap";
		}
		
		var appController = Mojo.Controller.getAppController();
		var stageController = appController.getStageController("WeiboMapStage");

		if (stageController){
			stageController.activate();
			stageController.delegateToSceneAssistant("showMap",lat,lon);
		}else{
			var pushMainScene = function(stageController) {
				stageController.pushScene({name:_map, disableSceneScroller: true},lat,lon);
			};
			appController.createStageWithCallback({"name": "WeiboMapStage", "lightweight": false}, pushMainScene,"card");
		}
	}

});