
Weibo.Oauth = ({
//1. 获取Request Token，该步骤使用API Key和API Key Secret签名
	getRequestToken: function(cb, fcb){
        var appController = Mojo.Controller.getAppController();
		var stageController = appController.getActiveStageController();
		var currentScene = stageController.activeScene();
		
        var message = {
            method: "GET",
            action: Weibo.request_token_uri,
            parameters: {
                oauth_consumer_key: Weibo.api_key,
                oauth_signature_method: Weibo.signature_method,
                oauth_signature: "",
                oauth_timestamp: "",
                oauth_nonce: "",
                oauth_version: "1.0"
            }
 	 	}
  
  		// 签名
  		OAuth.setTimestampAndNonce(message);
  		OAuth.SignatureMethod.sign(message, {
      		consumerSecret: Weibo.api_key_secret
  		})
        //构造请求Request Token的url
      	var url = message.action + '?' + new Hash(OAuth.getParameterMap(message.parameters)).toQueryString();
      	//stageController.get('browser').innerHTML = url;
  		var req = new Ajax.Request(url,{
      		
      		method: message.method,
      		onSuccess: function(resp){
          		//解析返回的Request Token和Request Token Secret
          		var responseObj = OAuth.getParameterMap(OAuth.decodeForm(resp.responseText));
          		Weibo.request_token = responseObj.oauth_token;
          		Weibo.request_token_secret = responseObj.oauth_token_secret;
          		cb(Weibo.request_token, Weibo.request_token_secret);
          		//stageController.get('browser').innerHTML = Object.toJSON(resp);
      		}.bind(this),
      		onFailure: function(xhr){
        		fcb(xhr);
        		//stageController.get('browser').innerHTML = "error";
      		}.bind(this)
  		})
	},

	// 2. 用户确认授权
	getUserAuthorizationURL:function (){     
        //生成引导用户授权的url
    	return Weibo.authorization_uri + Weibo.request_token + '&display=mobile&oauth_callback=a';
	},

	// 3. 换取Access Token，该步骤使用API Key、API Key Secret、Request Token和Request Token Secret签名
	getAccessToken:function(value,cb, fcb){
    	var message = {
        	method: "GET",
        	action: Weibo.access_token_uri,
        	parameters: {
            	oauth_consumer_key: Weibo.api_key,
            	oauth_token: Weibo.request_token,
                oauth_signature_method: Weibo.signature_method,
            	oauth_signature: "",
            	oauth_timestamp: "",
            	oauth_verifier: value,
            	oauth_nonce: "",
            	oauth_version: "1.0"
        	}
    	}
    
    	// 签名
    	OAuth.setTimestampAndNonce(message);
    	OAuth.SignatureMethod.sign(message, {
        	consumerSecret: Weibo.api_key_secret,
        	tokenSecret: Weibo.request_token_secret,
   		});
   		
   		
   		//构造请求Access Token的url
        var url = message.action + '?' + new Hash(OAuth.getParameterMap(message.parameters)).toQueryString();

    	var req = new Ajax.Request(url,{
              
              method: message.method,
              onSuccess: function(resp){
                  //解析返回的Request Token和Request Token Secret
                  var responseObj = OAuth.getParameterMap(OAuth.decodeForm(resp.responseText));
                  var access_token = responseObj.oauth_token;
                  var access_token_secret = responseObj.oauth_token_secret;
                  var uid = responseObj.user_id
                  //Weibo.Cookie.storeCookie();
                  cb(uid, access_token,access_token_secret);
              }.bind(this),
              onFailure: function(xhr){
                  fcb(xhr);
              }.bind(this)
    	})
	},
	
	oauthHeader: function(surl,smethod,access_token,access_token_secret){
	 	//Mojo.Log.info("~~~~~~#oauthHeader"+access_token);
	    var message = {
            method: smethod,
            action: surl,
            parameters: {
            	oauth_consumer_key: Weibo.api_key,
                oauth_token: access_token ? access_token : Weibo.Prefs.access_token,
                oauth_signature_method: Weibo.signature_method,
                oauth_signature: "",
                oauth_timestamp: "",
                oauth_nonce: "",
                oauth_version: "1.0"
            }
          };
          //Mojo.Log.info("~~~~~~#oauthHeader"+message.parameters.oauth_token);
          // 签名
          OAuth.setTimestampAndNonce(message);
          OAuth.SignatureMethod.sign(message, {
              consumerSecret: Weibo.api_key_secret,
              tokenSecret: access_token_secret ? access_token_secret : Weibo.Prefs.access_token_secret,
          });

          /*/构造OAuth头部
          var oauth_header = "OAuth realm=\"\", oauth_consumer_key=";
              oauth_header += message.parameters.oauth_consumer_key + ', oauth_nonce=';
              oauth_header += hex_md5(message.parameters.oauth_nonce) + ', oauth_timestamp=';
              oauth_header += message.parameters.oauth_timestamp + ', oauth_signature_method=HMAC-SHA1, oauth_signature=';
              oauth_header += message.parameters.oauth_signature + ', oauth_token=';
              oauth_header += message.parameters.oauth_token + ', oauth_version=1.0';
            
           var oauth_header = 'OAuth oauth_nonce="';
               oauth_header += message.parameters.oauth_nonce + '", oauth_signature_method="HMAC-SHA1", oauth_timestamp="';
               oauth_header += message.parameters.oauth_timestamp + '", oauth_consumer_key="';
               oauth_header += message.parameters.oauth_consumer_key + '", oauth_token="';
               oauth_header += message.parameters.oauth_token + '", oauth_signature="';
               oauth_header += message.parameters.oauth_signature + '", oauth_version="1.0"';

   		  */	
 		  var oauth_header = OAuth.getAuthorizationHeader("", message.parameters);
 		  return oauth_header;
	},

	oauthUrl: function(surl,smethod,access_token,access_token_secret){
	 
	    var message = {
            method: smethod,
            action: surl,
            parameters: {
            	oauth_consumer_key: Weibo.api_key,
                oauth_token: access_token ? access_token : Weibo.Prefs.access_token,
                oauth_signature_method: Weibo.signature_method,
                oauth_signature: "",
                oauth_timestamp: "",
                oauth_nonce: "",
                oauth_version: "1.0"
            }
          }
          // 签名
          OAuth.setTimestampAndNonce(message);
          OAuth.SignatureMethod.sign(message, {
              consumerSecret: Weibo.api_key_secret,
              tokenSecret: access_token_secret ? access_token_secret : Weibo.Prefs.access_token_secret,
          });		
 		  
 		  return message.action + '&' + new Hash(OAuth.getParameterMap(message.parameters)).toQueryString();
	}

});